package client.Java_client;

import javax.security.auth.login.LoginContext;
import hero.client.test.SimpleCallbackHandler;

import hero.interfaces.*;

import java.util.*;

public class ApprovalIteratingWorkflow {
	
	static public void main(String[] args) throws Exception{
		
		char[] password={'t','o','t','o'};
		SimpleCallbackHandler handler = 
			new SimpleCallbackHandler("admin",password);
		LoginContext lc = new LoginContext("TestClient", handler);
		lc.login();
		
		ProjectSessionHome projectSessionh = ProjectSessionUtil.getHome();
		ProjectSession pss = projectSessionh.create();
				
		pss.initModel("Approval_iterating_workflow");
		
		// Set activities
		pss.addNode("Request", Constants.Nd.AND_JOIN_NODE);
		pss.addNode("Approval", Constants.Nd.AND_JOIN_NODE);
		pss.addNode("Acceptance", Constants.Nd.AND_JOIN_AUTOMATIC_NODE);
		pss.addNode("Reject", Constants.Nd.AND_JOIN_AUTOMATIC_NODE);
		pss.setNodeTraditional("Request");
		pss.setNodeTraditional("Approval");
		pss.setNodeTraditional("Acceptance");
		pss.setNodeTraditional("Reject");
		
		// Set node properties
		pss.setNodeProperty("Request", "User_name", "", true);
		pss.setNodeProperty("Request", "Phone_number", "", true);
		pss.setNodeProperty("Request", "Email_address", "", true);
		
		Collection applications = new ArrayList();
		applications.add("application1");
		applications.add("application2");
		applications.add("application3");
		pss.setNodePropertyPossibleValues("Request", "Available_applications", applications);
		pss.setNodeProperty("Request", "Available_applications", "application1");
		
		Collection possible_decision = new ArrayList();
		possible_decision.add("change_request");
		possible_decision.add("grant");
		possible_decision.add("reject");
		pss.setNodePropertyPossibleValues("Approval", "decision", possible_decision);
		pss.setNodeProperty("Approval", "decision", "change_request", true);
		
		// Set transitions
		pss.addEdge("Request", "Approval");
		String approval_acceptance = pss.addEdge("Approval", "Acceptance");
		String approval_reject = pss.addEdge("Approval", "Reject");
		pss.setEdgeCondition(approval_acceptance, "decision.equals(\"grant\")");
		pss.setEdgeCondition(approval_reject, "decision.equals(\"reject\")");

		// Set iterations
		pss.addIteration("Approval", "Request", "decision.equals(\"change_request\")");
		
		// Set hooks
		pss.addNodeHook("Acceptance", "hero.hook.MailAccept", hero.interfaces.Constants.Nd.BEFORETERMINATE, Constants.Hook.JAVA);
		pss.addNodeHook("Reject", "hero.hook.MailReject", hero.interfaces.Constants.Nd.BEFORETERMINATE, Constants.Hook.JAVA);
			
		// Set activity roles
		pss.addRole("Administrator", "The system administator role");
		pss.setNodeRole("Request", "Administrator");
		pss.setNodeRole("Approval", "Administrator");
		
		// Set role mapper
		pss.addRoleMapper("Administrator", "AdministratorMapper", Constants.Mapper.PROPERTIES);
		
		// Check the defition model
		pss.checkModelDefinition();
	}
}

