/**
*
* Bonita
* Copyright (C) 1999 Bull S.A.
* Bull 68 route de versailles  78434 Louveciennes Cedex France
* Further information: bonita@objectweb.org
*
* This library is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or any later version.
*
* This library is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this library; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
* USA
*
*
--------------------------------------------------------------------------
* $Id: MailSample.java,v 1.1 2006/05/29 14:44:54 mvaldes Exp $
*
--------------------------------------------------------------------------
*/

package hero.hook;

import hero.interfaces.*;
import hero.interfaces.BnNodeLocal;
import hero.util.HeroHookException;
import hero.util.BonitaServiceLocator;

import javax.naming.InitialContext;
import javax.mail.Session;
import javax.mail.Address;
import javax.mail.Transport;
import javax.mail.internet.InternetAddress;
import javax.mail.internet.MimeMessage;
import javax.rmi.PortableRemoteObject;

import java.util.*;

public class MailSample implements hero.hook.NodeHookI {

	public String getMetadata() {
		return Constants.Nd.BEFORETERMINATE;
	}
	
	public void create(Object b,BnNodeLocal n) throws HeroHookException {}
	public void beforeStart(Object b,BnNodeLocal n) throws HeroHookException {}
    public void afterTerminate(Object b,BnNodeLocal n) throws HeroHookException {}
    public void onCancel(Object b,BnNodeLocal n) throws HeroHookException {}
    public void anticipate(Object b,BnNodeLocal n) throws HeroHookException {}
    public void onDeadline(Object b,BnNodeLocal n) throws HeroHookException {}
    public void afterStart(Object b, BnNodeLocal n) throws HeroHookException {}
    public void onReady(Object b,BnNodeLocal n) throws HeroHookException {}

    public void beforeTerminate(Object b,BnNodeLocal n) throws HeroHookException {
        try {
        String nodeName = n.getName();

        BnProjectLocal project = n.getBnProject();
        String prjName = project.getName();

        ProjectSessionHome prjhome = (ProjectSessionHome) ProjectSessionUtil.getHome();
        ProjectSession prjSession = prjhome.create();
        prjSession.initProject(prjName);

		// In this sample we assume that the "Email_address" property was defined at activity level
		// during the model definition. Otherwise this hook will throw an Exception at
		// execution time
        BnNodePropertyValue val = prjSession.getNodeProperty(nodeName,"Email_address");
        String mailString = val.getTheValue();

        BonitaServiceLocator serviceLocator = BonitaServiceLocator.getInstance();
        Session session =
                (Session) serviceLocator.getMailSession(BonitaServiceLocator.Services.MAIL_SERVICE);

        MimeMessage m = new MimeMessage(session);
        m.setFrom();
        Address[] to = new InternetAddress[] {new InternetAddress(mailString)};
        m.setRecipients(javax.mail.Message.RecipientType.TO, to);
        m.setSubject("Request accepted...");
        m.setSentDate(new java.util.Date());
        String content = "";
        m.setContent(content,"text/plain");

        // Envoi du mail
        Transport.send(m);
        System.out.println("send mail OK");
        } catch (Exception e) {System.out.println("mail service error: "+e);e.printStackTrace();}
    }

}
