/*
 * Created on 04 mai. 2004 by the Message Center Team
 *
 */
package mc.formgenerator.bonita;

import java.util.HashMap;

/**
 * Class that represents activity properties
 *
 */
public class DataActivity{

	
	/**
	 * Instance variable which represents activity name.
	 */
	private String projectName;
	
	
	/**
	 * The name of the activity to which it belongs
	 */
	private String activityName;
	
	
	/**
	 * Instance variable which represents the project properties.
	 * The Hashmap has key values which are : key = property name & value = property value.
	 */
	private HashMap projectProperties = new HashMap();
	
	
	/**
	 * Instance variable which represents activity properties.
	 * The Hashmap has key values which are : key = property name & value = property value.
	 */
	private HashMap activityProperties = new HashMap();
	
	
	/**
	 * Default class constructor
	 */
	public DataActivity(){
	}
	
	
	
	

	/**
	 * Class constructor with the attributes setting.
	 * @param theProjectName the process name of the new instance.
	 * @param theActivityName the activity name of the new instance.
	 * @param table the activity properties of the new instance.
	 */
	public DataActivity(String theProjectName, String theActivityName, HashMap projectTable, HashMap activityTable) {
		
		//set project name
		this.setProjectName(theProjectName);
		
		//set activity name
		this.setActivityName(theActivityName);
		
		//set project properties
		this.setProjectProperties(projectTable);
		
		//set activity properties
		this.setActivityProperties(activityTable);
	}
	
	
	//**************************************************************************
	//							THE SETTERS
	//**************************************************************************
		
	/**
	 * Initializes the projectName attribute
	 * @param theActivityName the name of the activity to which it belongs
	 */
	public void setProjectName(String theProjectName) {
		
		this.projectName = theProjectName;
	}
	
		
	/**
	 * Initializes the activityName attribute
	 * @param theActivityName the name of the activity to which it belongs
	 */
	public void setActivityName(String theActivityName) {
		
		this.activityName = theActivityName;
	}


	/**
	 * Set the value of the attribute projectProperties.
	 * @param table HashMap : the new project properties.
	 */
	public void setProjectProperties(HashMap table) {
		
		this.projectProperties = table;
	}
	
	
	/**
	 * Set the value of the attribute projectProperties.
	 * @param table HashMap : the new project properties.
	 */
	public void setActivityProperties(HashMap table) {
		
		this.activityProperties = table;
	}

	
	//**************************************************************************
	//							THE GETTERS
	//**************************************************************************
	
	/**
	 * Gets the projectName attribute
	 * @return the content of the activityName attribute
	 */
	public String getProjectName() {
		
		return this.projectName;
	}
	

	/**
	 * Gets the activityName attribute
	 * @return the content of the activityName attribute
	 */
	public String getActivityName() {
		
		return this.activityName;
	}	
	
	
	/**
	 * Gets projectProperties attribute
	 * @return the content of the activityName attribute
	 */
	public HashMap getProjectProperties() {
		
		return this.projectProperties;
	}
	
	
	/**
	 * Gets activityProperties attribute
	 * @return the content of the activityName attribute
	 */
	public HashMap getActivityProperties() {
		
		return this.activityProperties;
	}
}
