/*
 * Created on 4 mai 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package mc.formgenerator.bonita;

import java.util.HashMap;

/**
 * Class that represents project properties
 *
 */
public class DataProject {

	/**
	 * Instance variable which represents the project name.
	 */
	private String projectName;
	private String projectVersion;
	
	/**
	 * Instance variable which represents the project properties.
	 * The Hashmap has key values which are : key = property name & value = property value.
	 */
	private HashMap projectProperties = new HashMap();
	

	/**
	 * Default class constructor.
	 */
	public DataProject() {
		
	}


	/**
	 * Class constructor with the attributes setting.
	 * @param name	String : the process name of the new instance.
	 * @param table	HashMap: the process properties of the new instance.
	 */
	public DataProject(String name, HashMap table) {
		
		//set the attributes values
		this.setProjectName(name);
		this.setProjectProperties(table);
	}
	
	/**
	 * Class constructor with the attributes setting.
	 * @param name	String : the process name of the new instance.
	 * @param version	String : the process version of the new instance.
	 * @param table	HashMap: the process properties of the new instance.
	 */
	public DataProject(String name, String version, HashMap table) {
		
		//set the attributes values
		this.setProjectName(name);
		this.setProjectVersion(version);
		this.setProjectProperties(table);
	}
	
	//**************************************************************************
	//							THE SETTERS
	//**************************************************************************
	
	
	/**
	 * Set the value of the attribute processName.
	 * @param name String : the new process name.
	 */
	public void setProjectName(String name) {
		
		this.projectName = name;
	}

	/**
	 * Set the value of the attribute processVersion.
	 * @param version String : the new process version.
	 */
	public void setProjectVersion(String version) {
		
		this.projectVersion = version;
	}


	/**
	 * Set the value of the attribute processProperties.
	 * @param table HashMap : the new process properties.
	 */
	public void setProjectProperties(HashMap table) {
		
		this.projectProperties = table;
	}



	//**************************************************************************
	//							THE GETTERS
	//**************************************************************************
	
	
	/**
	 * Returns the value of the attribute processName.
	 * @return String : the process name.
	 */
	public String getProjectName() {
		
		return this.projectName;
	}
	
	/**
	 * Returns the value of the attribute processVersion.
	 * @return String : the process version.
	 */
	public String getProjectVersion() {
		
		return this.projectVersion;
	}
	
	/**
	 * Returns the value of the attribute processProperties.
	 * @return HashMap : the process properties.
	 */
	public HashMap getProjectProperties() {
		
		return this.projectProperties;
	}	
	
}
