/*
 * Created on 28 avr. 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package mc.formgenerator.bonita;

import java.io.StringWriter;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Set;
import java.util.StringTokenizer;
import java.util.Vector;

import mc.formgenerator.servlets.util.FormGeneratorConstant;
import org.apache.xerces.dom.DOMImplementationImpl;
import org.apache.xml.serialize.DOMSerializer;
import org.apache.xml.serialize.OutputFormat;
import org.apache.xml.serialize.XMLSerializer;
import org.w3c.dom.DOMImplementation;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;
import org.w3c.dom.Text;


/**
 * Class that offers methods to transform XML Document to DataProject/DataActivity
 * et vice versa
 *
 */
public class DocumentParser {



	/**
	 * Default class constructor.
	 */
	public DocumentParser() {

	}



	/**
	 * Say if the document has properties about the process.
	 * @param doc Document which owns the process information.
	 * @return boolean
	 */
	public boolean hasProperties(Document doc, Boolean isActivity) {

		//Root is the first tag of the document. Its name is "project"
		Element root = doc.getDocumentElement();

		NodeList elementProperty = null;
		NodeList elementPropertyProcForAct = null;
		int nAct = 0;
		int nActProc = 0;
		int nProc = 0;
		int n = 0;

		if(isActivity.booleanValue()){
			// Activity
			// property of activity
			elementProperty = root.getElementsByTagName("activityProperties");
			Element EleAct = (Element)elementProperty.item(0);
			nAct = EleAct.getElementsByTagName("*").getLength();
			// property of process
			elementPropertyProcForAct = root.getElementsByTagName("properties");
			Element EleActProc = (Element)elementPropertyProcForAct.item(0);
			nActProc = EleActProc.getElementsByTagName("*").getLength();
			n = nAct + nActProc;

		}else{
			elementProperty = root.getElementsByTagName("properties");
			Element propertyElement = (Element)elementProperty.item(0);
			n = propertyElement.getElementsByTagName("*").getLength();
		}

		return (n != 0);

	}






	/**
	 * Creates a DataProject structure thanks to the Document information.
	 * @param doc Document which represents the project.
	 * @return dataProject Structure which represents the project.
	 */
	public DataProject parseProject(Document doc, Vector req_parameters, boolean formsExists) {

		//the structure to return
		DataProject dataProject = new DataProject();

		//new information will be saved in these variables
		String newName;

		HashMap newTable = new HashMap();


		//Root is the first tag of the document. Its name is "project"
		Element root = doc.getDocumentElement();



		//**************************************************************************
		//				GET THE PROCESS NAME FROM THE DOCUMENT
		//**************************************************************************


		//Save the process name
		NodeList elementName = root.getElementsByTagName("name");

		if (elementName.getLength() == 0) {

				//default process name
				newName = "defaultProject";
		}
		else {
				Text nameProcess = (Text)elementName.item(0).getFirstChild();

				newName = nameProcess.getNodeValue();
		}



		//**************************************************************************
		//				GET THE PROCESS PROPERTIES FROM THE DOCUMENT
		//**************************************************************************



		//List of nodes named properties
		NodeList elementProperty = root.getElementsByTagName("properties");
		if (elementProperty.getLength() == 0) {
		}
		else {

				//Is unique, it's the first
				Element propertyElement = (Element)elementProperty.item(0);

				//List of child nodes of element "properties" : the key-value
				//NodeList elementsKeyValue = propertyElement.getElementsByTagName("*");
				NodeList elementsProperty = propertyElement.getElementsByTagName("property");
				int size = elementsProperty.getLength();

				//Save name-value if they exist
				if (size > 0) {

						for (int i=0; i<size; i++)
						{
							// new xml Format
							Element propertyElementNameValue = (Element)elementsProperty.item(i);

							NodeList elementsPropertyNameValue = propertyElementNameValue.getElementsByTagName("*");
							//Element propertyElementValue = (Element)elementsPropertyNameValue.item(0);
							//Text valueElement = (Text)elementsPropertyNameValue.item(0).getFirstChild();
							//String currentKey = valueElement.getNodeValue();
							String currentKey = propertyElementNameValue.getAttribute("id");
							String currentValue = "";
							if ((Text)elementsPropertyNameValue.item(1).getFirstChild() != null)
							{
							   //valueElement = (Text)elementsPropertyNameValue.item(1).getFirstChild();
								Text valueElement = (Text)elementsPropertyNameValue.item(0).getFirstChild();
								//#306244 if the workkflow property has no value then no text child is put in the value node within instance doc
								if (valueElement != null) {
								    currentValue = valueElement.getNodeValue();
                                }
						    }
								//old cml format
								//current node which gives the value
								//Text valueElement = (Text)elementsKeyValue.item(i).getFirstChild();

								//Takes the current node information
								//String currentValue = valueElement.getNodeValue();
								//String currentKey = elementsKeyValue.item(i).getNodeName();




								//Puts them in the HashMap
								newTable.put(currentKey, currentValue);
						}

				}
		}
		if (formsExists && (req_parameters != null) ){
			//remove from projectTable properties not into req_parameters beacause of hidden or readonly constraints
			Object[] tabProjectProp = newTable.keySet().toArray();
			for (int k=0;k<tabProjectProp.length;k++){
				if (!req_parameters.contains(tabProjectProp[k].toString())){
					newTable.remove(tabProjectProp[k]);
				}
			}
		}
		//**************************************************************************
		//				SET DATAPROJECT ATTRIBUTES
		//**************************************************************************

		dataProject.setProjectName(newName);
		dataProject.setProjectProperties(newTable);

		return dataProject;
	}







	/**
	 * Creates a DataActivity structure thanks to the Document information.
	 * @param doc Document which represents the activity.
	 * @return dataProject Structure which represents the activity.
	 */
	public DataActivity parseActivity(Document doc, Vector req_parameters, boolean formsExists) {

		//the structure to return
		DataActivity dataActivity = new DataActivity();

		//PROJECT INFO

		//new information will be saved in these variables
		String newProjectName;

		HashMap projectTable = new HashMap();
		HashMap activityTable = new HashMap();


		//Root is the first tag of the document. Its name is "project"
		Element root = doc.getDocumentElement();



		//**************************************************************************
		//				GET THE PROCESS NAME FROM THE DOCUMENT
		//**************************************************************************


		//Save the process name
		NodeList projectElementName = root.getElementsByTagName("name");

		if (projectElementName.getLength() == 0) {

				//default process name
				newProjectName = "defaultProject";
		}
		else {
				Text nameProcess = (Text)projectElementName.item(0).getFirstChild();

				newProjectName = nameProcess.getNodeValue();
		}



		//**************************************************************************
		//				GET THE PROCESS PROPERTIES FROM THE DOCUMENT
		//**************************************************************************



		//List of nodes named properties
		NodeList projectElementProperty = root.getElementsByTagName("properties");
		if (projectElementProperty.getLength() == 0) {
		}
		else {

				//Is unique, it's the first
				Element propertyElement = (Element)projectElementProperty.item(0);

				//List of child nodes of element "properties" : the key-value
				//NodeList elementsKeyValue = propertyElement.getElementsByTagName("*");
				NodeList elementsProperty = propertyElement.getElementsByTagName("property");
				int size = elementsProperty.getLength();

				//Save name-value if they exist
				if (size > 0) {

						for (int i=0; i<size; i++)
						{
							// new xml Format
							Element propertyElementNameValue = (Element)elementsProperty.item(i);

							NodeList elementsPropertyNameValue = propertyElementNameValue.getElementsByTagName("*");
							//Element propertyElementValue = (Element)elementsPropertyNameValue.item(0);
							//Text valueElement = (Text)elementsPropertyNameValue.item(0).getFirstChild();
							//String currentKey = valueElement.getNodeValue();
							String currentKey = propertyElementNameValue.getAttribute("id");
							String currentValue = "";
							if ((Text)elementsPropertyNameValue.item(1).getFirstChild() != null)
							{
								Text valueElement = (Text)elementsPropertyNameValue.item(0).getFirstChild();
								//#306244
								if (valueElement != null) {
								    currentValue = valueElement.getNodeValue();
								}                            
						     }
								//old cml format
								//current node which gives the value
								//Text valueElement = (Text)elementsKeyValue.item(i).getFirstChild();

								//Takes the current node information
								//String currentValue = valueElement.getNodeValue();
								//String currentKey = elementsKeyValue.item(i).getNodeName();




								//Puts them in the HashMap
								projectTable.put(currentKey, currentValue);
						}

				}
		}

		//remove from projectTable properties not into req_parameters beacause of hidden or readonly constraints
		if (formsExists && (req_parameters != null) ){
			Object[] tabProjectProp = projectTable.keySet().toArray();
			for (int k=0;k<tabProjectProp.length;k++){
				if (!req_parameters.contains(tabProjectProp[k].toString())){
					projectTable.remove(tabProjectProp[k]);
				}
			}
		}


		//**************************************************************************
		//				SET DATA PROJECT ATTRIBUTES
		//**************************************************************************

		dataActivity.setProjectName(newProjectName);
		dataActivity.setProjectProperties(projectTable);

		//END PROJECT INFO

		//ACTIVITY INFO

		String activityName ="";


		//**************************************************************************
		//				GET THE Activity NAME FROM THE DOCUMENT
		//**************************************************************************

		//Save the process name
		NodeList activityElementName = root.getElementsByTagName("activityName");

		if (activityElementName.getLength() == 0) {

				//default activity name
				activityName = "defaultActivity";
		}
		else {
				Text nameProcess = (Text)activityElementName.item(0).getFirstChild();
				activityName = nameProcess.getNodeValue();
		}

		//**************************************************************************
		//				GET THE ACTIVITY PROPERTIES FROM THE DOCUMENT
		//**************************************************************************


		//List of nodes named properties
		NodeList activityElementProperty = root.getElementsByTagName("activityProperties");
		if (activityElementProperty.getLength() == 0) {
		}
		else {

				//Is unique, it's the first
				Element propertyElement = (Element)activityElementProperty.item(0);

				//List of child nodes of element "properties" : the key-value
				//NodeList elementsKeyValue = propertyElement.getElementsByTagName("*");
				NodeList elementsProperty = propertyElement.getElementsByTagName("property");
				int size = elementsProperty.getLength();

				//Save name-value if they exist
				if (size > 0) {

						for (int i=0; i<size; i++)
						{
							// new xml Format
							Element propertyElementNameValue = (Element)elementsProperty.item(i);

							NodeList elementsPropertyNameValue = propertyElementNameValue.getElementsByTagName("*");
							//Element propertyElementValue = (Element)elementsPropertyNameValue.item(0);
							//Text valueElement = (Text)elementsPropertyNameValue.item(0).getFirstChild();
							//String currentKey = valueElement.getNodeValue();
							String currentKey = propertyElementNameValue.getAttribute("id");
							String currentValue = "";
							if ((Text)elementsPropertyNameValue.item(1).getFirstChild() != null)
							{
							   //valueElement = (Text)elementsPropertyNameValue.item(1).getFirstChild();
								Text valueElement = (Text)elementsPropertyNameValue.item(0).getFirstChild();
								//patch for #306244
								if (valueElement != null) {                                
								    currentValue = valueElement.getNodeValue();
								}
						     }
								//old cml format
								//current node which gives the value
								//Text valueElement = (Text)elementsKeyValue.item(i).getFirstChild();

								//Takes the current node information
								//String currentValue = valueElement.getNodeValue();
								//String currentKey = elementsKeyValue.item(i).getNodeName();




								//Puts them in the HashMap
								activityTable.put(currentKey, currentValue);
						}

				}
		}
		if (formsExists && (req_parameters != null) ){
			//remove from projectTable properties not into req_parameters beacause of hidden or readonly constraints
			Object[] tab_activity_prop = activityTable.keySet().toArray();
			for (int k=0;k<tab_activity_prop.length;k++){
				if (!req_parameters.contains(tab_activity_prop[k].toString())){
					activityTable.remove(tab_activity_prop[k]);
				}
			}
		}

		//**************************************************************************
		//				SET DATA ACTIVITY ATTRIBUTES
		//**************************************************************************

		dataActivity.setActivityName(activityName);
		dataActivity.setActivityProperties(activityTable);

		return dataActivity;
	}






	/**
	 * Creation of a xml document by using Xerces
	 * @param data The data to put in the Document.
	 * @return Document contains process information given by the DataProcess.
	 */
	public Document createDocument(DataProject data, ArrayList projectKeys){

	   //Out Document for manipulation by Xerces API
	   Document document = null;

	   //Set for all the hmap keys
	   //Set keySet = null;

	   //Interface
	   DOMImplementation domImpl = new DOMImplementationImpl();

	   //Document creation with the root element called project
	   document = domImpl.createDocument(null, "process" , null);

	   //Setting the root element always called "project"
	   Element root = document.getDocumentElement();


	   //Name of the Bonita project***************************************
	   Element elementName = document.createElement("name");

	   //Value of the node called "name"
	   Text textName = document.createTextNode(data.getProjectName());
	   elementName.appendChild(textName);
	   root.appendChild(elementName);
	   //*****************************************************************



	   //Node "properties" that will contain project properties************
	   Element elementProperties = document.createElement("properties");
	   //******************************************************************


	   //Getting keys set
	   //keySet = data.getProjectProperties().keySet();

	   //Current key
	   String currentKey = "";

	   //Current value
	   String currentValue = "";

	   //For each key we must get the value associeted
	   //Iterator it = keySet.iterator();
	   Iterator it = projectKeys.iterator();
	   while(it.hasNext())
	   {
                                //New format : <properties><property><name>key</name><type></type><value>value></value>
                                //<possible-values><possible></possible></possible-values><property></properties>
				Element elementProperty = document.createElement("property");

				//Getting the key
				currentKey = (String)it.next();

				//Getting the value
				currentValue = 	(String)data.getProjectProperties().get(currentKey);

				//old format : <properties><key>value</key><key>value</key></properties>
				//Element elementKey = document.createElement(currentKey);
				//Text textKey = document.createTextNode(currentValue);

				//Element elementPropertyName = document.createElement("name");
				//Text textPropertyName = document.createTextNode(currentKey);
				//elementPropertyName.appendChild(textPropertyName);
				//Adding this element to the "property" element
				//elementProperty.appendChild(elementPropertyName);
				elementProperty.setAttribute("id",currentKey);

				// We test if there is a multiple possible values
				// value1|value2|value3 ...
        			StringTokenizer st = new StringTokenizer(currentValue, "|");
        			Element elementPropertyValue = null;
        			Element elementPropertyPossible = null;
        			Element elementPropertyType = document.createElement("type");
        			if (st.countTokens() > 1)
        			{


				   boolean first = true;
				   Element elementPropertyPossibleValues = document.createElement("possible-values");
        			   while (st.hasMoreTokens())
        			   {
        				String value = st.nextToken();
        				if (first)
        				{
//patch for #302738: enumerated with multi selection can be validated with an empty value
        					if (" ".equals(value)) {
//System.out.println("$$$$$$$$$$$$  ******** DocumentParser:createDocument for Project - (first) value = **" + value + "**");
        						value = "";
        					}
						elementPropertyValue = document.createElement("value");
						Text textPropertyValue = document.createTextNode(value);
						elementPropertyValue.appendChild(textPropertyValue);
						elementProperty.appendChild(elementPropertyValue);

		   				Text textPropertyType = document.createTextNode("select");
						elementPropertyType.appendChild(textPropertyType);
						elementProperty.appendChild(elementPropertyType);
						first = false;
        				}
        				else
        				{
						elementPropertyPossible = document.createElement("possible");
						Text textPropertyPossible = document.createTextNode(value);
						elementPropertyPossible.appendChild(textPropertyPossible);
						elementPropertyPossibleValues.appendChild(elementPropertyPossible);
					}
				   }

				   elementProperty.appendChild(elementPropertyPossibleValues);
				}
				else
				{
				   elementPropertyValue = document.createElement("value");                   
				   //patch for #306244: put no text node if the value = empty string and insert the attribut xsi:nil="true" into the value node
                   if (!"".equals(currentValue)) {
				     Text textPropertyValue = document.createTextNode(currentValue);
				     elementPropertyValue.appendChild(textPropertyValue);
                   } else {
                       elementPropertyValue.setAttributeNS("http://www.w3.org/2001/XMLSchema-instance", "nil", "true");
                   }
				   elementProperty.appendChild(elementPropertyValue);

   				   Text textPropertyType = document.createTextNode("input");
				   elementPropertyType.appendChild(textPropertyType);
				   elementProperty.appendChild(elementPropertyType);
				}
				//Adding this element to the "properties" element
				elementProperties.appendChild(elementProperty);
	   	}

		//Adding the node to the root element
		root.appendChild(elementProperties);

//debug
//System.out.println("$$$$$$$$$$$$$$$$ xml instance build by BonitaProjectAdapter");
//System.out.println(this.toXmlString(document));
//System.out.println("$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$");

		//Return the document
		return document;
	}


	/**
	 * Creation of a xml document by using Xerces
	 * @param data The data to put in the Document.
	 * @return Document contains process information given by the DataProcess.
	 */
	public Document createDocument(DataActivity data, ArrayList projectKeys, ArrayList activityKeys){

	   //Out Document for manipulation by Xerces API
	   Document document = null;

	   //Set for all the hmap keys
	   //Set keySet = null;

	   //Current key
	   String currentKey = "";

	   //Current value
	   String currentValue = "";

	   //iterator for keys
	   Iterator it;

	   //Interface
	   DOMImplementation domImpl = new DOMImplementationImpl();

	   //Document creation with the root element called project
	   document = domImpl.createDocument(null, "process" , null);

	   Element root = document.getDocumentElement();

	   //PROJECT INFO

	   //Name of the Bonita project***************************************
	   Element elementProjectName = document.createElement("name");

	   //Value of the node called "name"
	   Text textName = document.createTextNode(data.getProjectName());
	   elementProjectName.appendChild(textName);
	   root.appendChild(elementProjectName);
	   //*****************************************************************



	   //Node "properties" that will contain project properties************
	   Element elementProjectProperties = document.createElement("properties");
	   //******************************************************************


	   //Getting keys set
	   //keySet = data.getProjectProperties().keySet();

	   //For each key we must get the value associeted
	   //it = keySet.iterator();
	   it = projectKeys.iterator();
	   while(it.hasNext())
	   {
                //New format : <properties><property><name>key</name><type></type><value>value></value>
                //<possible-values><possible></possible></possible-values><property></properties>
				Element elementProjectProperty = document.createElement("property");

				//Getting the key
				currentKey = (String)it.next();

				//Getting the value
				currentValue = 	(String)data.getProjectProperties().get(currentKey);

				//old format : <properties><key>value</key><key>value</key></properties>
				//Element elementKey = document.createElement(currentKey);
				//Text textKey = document.createTextNode(currentValue);

				//Element elementPropertyName = document.createElement("name");
				//Text textPropertyName = document.createTextNode(currentKey);
				//elementPropertyName.appendChild(textPropertyName);
				//Adding this element to the "property" element
				//elementProjectProperty.appendChild(elementPropertyName);
				elementProjectProperty.setAttribute("id",currentKey);

				// We test if there is a multiple possible values
				// value1|value2|value3 ...
        			StringTokenizer st = new StringTokenizer(currentValue, "|");
        			Element elementPropertyValue = null;
        			Element elementPropertyPossible = null;
        			Element elementPropertyType = document.createElement("type");
        			if (st.countTokens() > 1)
        			{


				   boolean first = true;
				   Element elementPropertyPossibleValues = document.createElement("possible-values");
        			   while (st.hasMoreTokens())
        			   {
        				String value = st.nextToken();
        				if (first)
        				{
//patch for #302738: enumerated with multi selection can be validated with an empty value
        					if (" ".equals(value)) {
//System.out.println("$$$$$$$$$$$$  ******** DocumentParser:createDocument (for Activity/project data) - (first) value = **" + value + "**");
        						value = "";
        					}
						elementPropertyValue = document.createElement("value");
						Text textPropertyValue = document.createTextNode(value);
						elementPropertyValue.appendChild(textPropertyValue);
						elementProjectProperty.appendChild(elementPropertyValue);

		   				Text textPropertyType = document.createTextNode("select");
						elementPropertyType.appendChild(textPropertyType);
						elementProjectProperty.appendChild(elementPropertyType);
						first = false;
        				}
        				else
        				{
						elementPropertyPossible = document.createElement("possible");
						Text textPropertyPossible = document.createTextNode(value);
						elementPropertyPossible.appendChild(textPropertyPossible);
						elementPropertyPossibleValues.appendChild(elementPropertyPossible);
					}
				   }

					   elementProjectProperty.appendChild(elementPropertyPossibleValues);
				}
				else
				{
                   elementPropertyValue = document.createElement("value");                   
                          //patch for #306244: put no text node if the value = empty string and insert the attribut xsi:nil="true" into the value node
                          if (!"".equals(currentValue)) {
                                Text textPropertyValue = document.createTextNode(currentValue);
                                elementPropertyValue.appendChild(textPropertyValue);
                          } else {
                                elementPropertyValue.setAttributeNS("http://www.w3.org/2001/XMLSchema-instance", "nil", "true");
                          }
                   elementProjectProperty.appendChild(elementPropertyValue);                   

   				   Text textPropertyType = document.createTextNode("input");
				   elementPropertyType.appendChild(textPropertyType);
				   elementProjectProperty.appendChild(elementPropertyType);
				}
				//Adding this element to the "properties" element
					elementProjectProperties.appendChild(elementProjectProperty);
	   	}

		//Adding the node to the root element
		root.appendChild(elementProjectProperties);

		//END PROJECT INFO

		//ACTIVITY INFO

	  	//Element creation
		Element elementActivityName = document.createElement("activityName");

		//Value of the node called "nameProject"
		Text textNameActivity = document.createTextNode(data.getActivityName());

		//Adding the text to the element
		elementActivityName.appendChild(textNameActivity);

		//Adding the node to the root element
		root.appendChild(elementActivityName);
		   //*****************************************************************



	   //Node "properties" that will contain activity properties************
	   Element elementActivityProperties = document.createElement("activityProperties");
	   //******************************************************************


	   //Getting keys set
	   //keySet = data.getActivityProperties().keySet();

	   //For each key we must get the value associeted
	   //it = keySet.iterator();
	   it = activityKeys.iterator();
	   while(it.hasNext())
	   {
                                //New format : <properties><property><name>key</name><type></type><value>value></value>
                                //<possible-values><possible></possible></possible-values><property></properties>
				Element elementActivityProperty = document.createElement("property");

				//Getting the key
				currentKey = (String)it.next();

				//Getting the value
				currentValue = 	(String)data.getActivityProperties().get(currentKey);

				//old format : <properties><key>value</key><key>value</key></properties>
				//Element elementKey = document.createElement(currentKey);
				//Text textKey = document.createTextNode(currentValue);

				//Element elementPropertyName = document.createElement("name");
				//Text textPropertyName = document.createTextNode(currentKey);
				//elementPropertyName.appendChild(textPropertyName);
				//Adding this element to the "property" element
				//elementActivityProperty.appendChild(elementPropertyName);
				elementActivityProperty.setAttribute("id",currentKey);

				// We test if there is a multiple possible values
				// value1|value2|value3 ...
        			StringTokenizer st = new StringTokenizer(currentValue, "|");
        			Element elementPropertyValue = null;
        			Element elementPropertyPossible = null;
        			Element elementPropertyType = document.createElement("type");
        			if (st.countTokens() > 1)
        			{


				   boolean first = true;
				   Element elementPropertyPossibleValues = document.createElement("possible-values");
        			   while (st.hasMoreTokens())
        			   {
        				String value = st.nextToken();
        				if (first)
        				{
//patch for #302738: enumerated with multi selection can be validated with an empty value
        					if (" ".equals(value)) {
//System.out.println("$$$$$$$$$$$$  ******** DocumentParser:createDocument (for Activity data) - (first) value = **" + value + "**");
        						value = "";
        					}
						elementPropertyValue = document.createElement("value");
						Text textPropertyValue = document.createTextNode(value);
						elementPropertyValue.appendChild(textPropertyValue);
						elementActivityProperty.appendChild(elementPropertyValue);

		   				Text textPropertyType = document.createTextNode("select");
						elementPropertyType.appendChild(textPropertyType);
						elementActivityProperty.appendChild(elementPropertyType);
						first = false;
        				}
        				else
        				{
						elementPropertyPossible = document.createElement("possible");
						Text textPropertyPossible = document.createTextNode(value);
						elementPropertyPossible.appendChild(textPropertyPossible);
						elementPropertyPossibleValues.appendChild(elementPropertyPossible);
					}
				   }

					   elementActivityProperty.appendChild(elementPropertyPossibleValues);
				}
				else
				{                                  
                   elementPropertyValue = document.createElement("value");                   
                   //patch for #306244: put no text node if the value = empty string and insert the attribut xsi:nil="true" into the value node
                   if (!"".equals(currentValue)) {
                           Text textPropertyValue = document.createTextNode(currentValue);
                           elementPropertyValue.appendChild(textPropertyValue);
                   } else {
                           elementPropertyValue.setAttributeNS("http://www.w3.org/2001/XMLSchema-instance", "nil", "true");
                   }
                   elementActivityProperty.appendChild(elementPropertyValue);

   				   Text textPropertyType = document.createTextNode("input");
				   elementPropertyType.appendChild(textPropertyType);
				   elementActivityProperty.appendChild(elementPropertyType);
				}
				//Adding this element to the "properties" element
				elementActivityProperties.appendChild(elementActivityProperty);
	   	}

		//Adding the node to the root element
		root.appendChild(elementActivityProperties);


		//Return the document
		return document;
	}
	/**
	 * Utility function
	 * @param document
	 * @return
	 */
	public String toXmlString(Document document) {
		try {
			OutputFormat outputFormat = new OutputFormat(document,FormGeneratorConstant.DEBUG_OUTPUT_FORMAT_ENCODING,true);
			outputFormat.setIndenting(true);
			outputFormat.setIndent(1);
			outputFormat.setPreserveSpace(true);
			StringWriter writer = new StringWriter();
			DOMSerializer serializer = new XMLSerializer(writer, outputFormat);
			serializer.serialize(document);
			writer.close();
			return writer.toString();
		} catch (Exception ex) {
			ex.printStackTrace();
		}
		return null;
	}

}
