/*
 * Created on 03 mai 2004 by the Message Center Team
 *
 */
package mc.formgenerator.servlets.bonita;

import java.rmi.RemoteException;
import java.util.ArrayList;
import java.util.Collection;

import javax.ejb.CreateException;
import javax.naming.NamingException;

import hero.interfaces.UserSessionHome;
import hero.interfaces.UserSession;
import hero.util.HeroException;

/**
 * Model for servlet ServletActivityToDoList to give ToDo List to display.
 * 
 */
public class ModelActivityToDoList {

	//The project name
	private String projectName = null;
	
	//The todo list as a collection
	private Collection toDoList = null;


	/**
	 * Default constructor
	 * Creates an instance of ModelActivityToDoList
	 */
	public ModelActivityToDoList(){};




	/**
	 * Gets the ToDoList
	 * @return the ToDoList as collection
	 */
	public Collection getToDoList(){
		//Return the todo list
		return this.toDoList;	
	}
	
	
	

	/**
	 * Sets the ToDoList
	 * @param collection : The collection to set
	 */
	public void setToDoList(Collection collection){
		//Set the todo list
		this.toDoList = collection;	
	}
	
	
	

	/**
	 * Gets the project name
	 * @return the project name as stringection
	 */
	public String getProjectName(){
		//Return the name of the project
		return this.projectName;	
	}
	
	
	

	/**
	 * Sets the project name
	 * @param theProjectName : The name of the project
	 */
	public void setProjectName(String theProjectName){
		//Set the todo list
		this.projectName = theProjectName;	
	}
	
	
	
	
	/**
	 * Gets the to do list for the authentified user
	 * @param projectName : The name of the project
	 * @return The todo list for this project
	 * @throws HeroException
	 * @throws RemoteException
	 * @throws CreateException
	 * @throws NamingException
	 * @throws LoginException
	 */
	private Collection getBonitaToDoList(String projectName) 
		throws HeroException, RemoteException, 
			   CreateException, NamingException{
		
		//Connection to Bonita via API
		UserSessionHome userh = (UserSessionHome)hero.interfaces.UserSessionUtil.getHome();
		UserSession usersession = userh.create();
		
		//Collection as ToDo list
		Collection collectionToDoList = new ArrayList();
		try{
		collectionToDoList = 
			usersession.getToDoList(projectName);
		}catch(HeroException e){}
			
		return collectionToDoList;	
	}
	
	
	
	
	/**
	 * For the MVC corresponds to the work the object has to do
	 * @param projectName : The project on which the object opers
	 * @throws RemoteException
	 * @throws LoginException
	 * @throws HeroException
	 * @throws CreateException
	 * @throws NamingException
	 */
	public void process(String theProjectName) 
		throws 	RemoteException, HeroException,
				CreateException, NamingException{
		
		//Setting attributes
		this.setProjectName(theProjectName);
		this.setToDoList(this.getBonitaToDoList(theProjectName));	
	}
}
