/*
 * Created on September 2004, the 16th
 * By the Message Center Team
 */
package mc.formgenerator.servlets.bonita;

import hero.interfaces.ProjectSessionLocalHome;
import hero.interfaces.UserSessionLocalHome;
import hero.util.HeroException;
import hero.util.StrutsNodeValue;

import java.util.Collection;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.Vector;

import javax.ejb.CreateException;
import javax.naming.NamingException;

import mc.formgenerator.bonita.Worklist;

/**
 * Model for servlet ServletWorkList to give worklist to display.
 * 
 */
public class ModelWorkList {
    
    //The worklists list
    private Vector workList;
    
    
    /**
     * Default constructor for our class 
     *
     */
    public ModelWorkList(){
        this.setWorkList(new Vector());
    }
    
    
    
    
    /**
     * For each project of the user, store its worklist 
     * @throws CreateException
     * @throws NamingException
     * @throws HeroException
     */
    public void process() 
    	throws CreateException, NamingException, HeroException{
        
        //Get project session bean
        hero.interfaces.UserSessionLocalHome userh = (UserSessionLocalHome)hero.interfaces.UserSessionUtil.getLocalHome();
        hero.interfaces.UserSessionLocal usersession = userh.create();
        hero.interfaces.ProjectSessionLocalHome projecth = (ProjectSessionLocalHome)hero.interfaces.ProjectSessionUtil.getLocalHome();

        //Get project list
        Collection projects = usersession.getProjectList();
        Iterator i = projects.iterator();
        
        while (i.hasNext()){
    	
            Worklist currentWorkList = new Worklist();
            
            //Get current project name
            String currentProject = ((hero.interfaces.BnProjectLightValue)i.next()).getName();
            
            //Current project todo list name
            Vector todoListNames = new Vector(usersession.getToDoList(currentProject));
            
            //Current activity list for the current project
            Vector activityListNames = new Vector(usersession.getActivityList(currentProject));

            Hashtable readyList = new Hashtable();
            Hashtable executingList = new Hashtable();
            Hashtable anticipableList = new Hashtable();
            Hashtable anticipatingList = new Hashtable();

            //Setting worklist values
            if (todoListNames.size() != 0 || activityListNames.size() != 0){
                
                //Setting project name
                currentWorkList.setProjectName(currentProject);
                
                //Get project session bean
                hero.interfaces.ProjectSessionLocal projectsession = projecth.create();
                projectsession.initProject(currentProject);
    		
                int j=0;
                while (j<todoListNames.size()){
                    StrutsNodeValue stnt = new StrutsNodeValue();
                    stnt.setProjectName(currentProject);
                    stnt.setName(((hero.interfaces.BnNodeValue)projectsession.getNodeValue((String)todoListNames.elementAt(j))).getName());
    		
	    	        if (((hero.interfaces.BnNodeValue)projectsession.getNodeValue((String)todoListNames.elementAt(j))).getState() == hero.interfaces.Constants.Nd.READY)
	    	            readyList.put((String)todoListNames.elementAt(j), stnt);
	    	        else
	    	            anticipableList.put((String)todoListNames.elementAt(j), stnt);
	    	       	j++;
	    	    }
    	    
	    	    j=0;
	    	    while (j<activityListNames.size()){
	    	        StrutsNodeValue stna = new StrutsNodeValue();
	    	        stna.setProjectName(currentProject);
	    	        stna.setName(((hero.interfaces.BnNodeValue)projectsession.getNodeValue((String)activityListNames.elementAt(j))).getName());
	
		    		if (((hero.interfaces.BnNodeValue)projectsession.getNodeValue((String)activityListNames.elementAt(j))).getState() == hero.interfaces.Constants.Nd.ANTICIPATING)
		    		    anticipatingList.put((String)activityListNames.elementAt(j),stna);
		
		    		else{ 
		    		    executingList.put((String)activityListNames.elementAt(j),stna);
		    		}
	    	    j++;
	    	    }
	    	    
	    	    //Initializing class attribute
	    	    currentWorkList.setTodoListReady(readyList);
	    	    currentWorkList.setTodoListAnti(anticipableList);
	    	    currentWorkList.setActivityListAnti(anticipatingList);
	    	    currentWorkList.setActivityListExec(executingList);
	    	    this.getWorkList().add(currentWorkList);       
            }
        }
    }

    
    
    
    /**
     * Get the workLists list
     * @return the workLists list as Vector
     */
    public Vector getWorkList() {
        return workList;
    }
    
    
    
    
    /**
     * Set the workLists list
     * @param workList the workLists list to set
     */
    public void setWorkList(Vector workList) {
        this.workList = workList;
    }
}

