/*
 * Created on 3 mai 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package mc.formgenerator.servlets.bonita;

import hero.client.importLdap.SimpleCallbackHandler;
import hero.interfaces.UserSessionHome;
import hero.interfaces.UserSessionUtil;
import hero.util.HeroException;
import hero.util.StrutsProjectValue;

import java.rmi.RemoteException;
import java.util.Collection;
import java.util.Iterator;
import java.util.Vector;

import javax.ejb.CreateException;
import javax.naming.NamingException;
import javax.security.auth.login.LoginContext;
import javax.security.auth.login.LoginException;

import hero.interfaces.*;

/**
 * Model for servlet ServletAccueil to give project list to display.
 * 
 */
public class ModeleAccueil {

	
	/**
	 * Attribute which stocks the project names
	 */
	private Collection modelProjectList;


	/**
	 * Default class constructor
	 */
	public ModeleAccueil() {
	}




	/**
	 * Returns the list of all the projects but without the instances.
	 * @return Colection model projects -> they aren't instances.
	 * @throws LoginException
	 * @throws NamingException
	 * @throws CreateException
	 * @throws RemoteException
	 * @throws HeroException
	 */
	public Collection getAllModelProjects() throws LoginException, NamingException, CreateException, RemoteException, HeroException {
		
		boolean isAnInstance;
		
		Vector listeResultat = new Vector();
	    hero.interfaces.AllProjectsSessionLocalHome projecth = (AllProjectsSessionLocalHome)hero.interfaces.AllProjectsSessionUtil.getLocalHome();
	    hero.interfaces.AllProjectsSessionLocal allProject = projecth.create();
				
		//Get all the projects : models & instances		
		Collection listeProjets = allProject.getProjects();		
		
		//listeResultat only owns the model projects
		Iterator it = listeProjets.iterator();
		while (it.hasNext()) {
					//Getting the name of the current project
					StrutsProjectValue struts = (StrutsProjectValue)it.next();
					String name = struts.getName();
					
					//is this project an instance
					isAnInstance = name.matches(".*_instance.*");
					if (!isAnInstance) {
							listeResultat.addElement(name);
					}
		}
		
		return listeResultat;
	}




	/**
	 * The main method which asks and returns the model projects list.
	 * @throws LoginException
	 * @throws RemoteException
	 * @throws NamingException
	 * @throws CreateException
	 * @throws HeroException
	 */
	public void process() throws LoginException, RemoteException, NamingException, CreateException, HeroException {
		
		Collection list = this.getAllModelProjects();
		
		this.setModelProjectList(list);
	}




	/**
	 * Set the value of the attribute modelProjectList with the value 'col'.
	 * @param col Collection
	 */
	public void setModelProjectList(Collection col) {
		
		this.modelProjectList = col;
	}




	/**
	 * Get the value of the attribute modelProjectList.
	 * @return Collection List of all model projects.
	 */
	public Collection getModelProjectList() {
		
		return this.modelProjectList;
	}


}
