/*
 * Created on 12 mai 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package mc.formgenerator.servlets.bonita;

import hero.util.HeroException;
import hero.interfaces.UserSession;
import hero.interfaces.UserSessionHome;
import hero.interfaces.UserSessionUtil;

import java.rmi.RemoteException;
import java.util.Collection;

import javax.ejb.CreateException;
import javax.naming.NamingException;

/**
 * Model for servlet ServletInstancesProjects to give projects instances to display.
 * 
 */
public class ModeleInstances {



	/**
	 * Attribute which stocks the project names
	 */
	private Collection instanceProjectList;




	/**
	 * Default class constructor
	 */
	public ModeleInstances() {
	}





	/**
	 * The main method which finds and initialises the model projects list.
	 * @throws LoginException
	 * @throws RemoteException
	 * @throws NamingException
	 * @throws CreateException
	 * @throws HeroException
	 */
	public void process() throws RemoteException, NamingException, CreateException, HeroException {
		
		Collection list = this.getAllInstancesProjects();
		
		this.setInstanceProjectList(list);
	}






	/**
	 * Returns the projects instances list of the current user.
	 * @return Collection List of the projects instances of the user.
	 * @throws NamingException
	 * @throws CreateException
	 * @throws RemoteException
	 * @throws HeroException
	 */
	private Collection getAllInstancesProjects() throws NamingException, CreateException, RemoteException, HeroException {
		
		UserSessionHome userh = UserSessionUtil.getHome();
		
		UserSession userSession = userh.create();	
		
		Collection list = userSession.getInstancesListNames();
		
		return list;
	}




	/**
	 * Set the value of the attribute instanceProjectList with the value 'col'.
	 * @param col Collection List of all instance projects.
	 */
	public void setInstanceProjectList(Collection col) {
		
		this.instanceProjectList = col;
	}




	/**
	 * Get the value of the attribute instanceProjectList.
	 * @return Collection List of all instance projects.
	 */
	public Collection getInstanceProjectList() {
		
		return this.instanceProjectList;
	}

}
