/*
 * Created on 04 mai. 2004 by the Message Center Team
 *
 */
package mc.formgenerator.servlets.bonita;

import java.io.IOException;

import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

/**
 * Servlet that will show user his todo list in order to allow him to start an activity
 */
public class ServletActivityToDoList extends HttpServlet {
	
	/**
	 * Servlet reaction on get method : Displaying todo list associated to the project
	 */
	protected void doGet(
		HttpServletRequest request,
		HttpServletResponse response)
		throws IOException {
			
		//Get current session
		HttpSession session = request.getSession(true);
		
		//Parameter value
		String projectName = request.getParameter("projectName");
			
		//Project name must be specified
		if(projectName == null)
			throw new IOException("projectName parameter empty");
			
		else{
			//We create the model for this controller
			ModelActivityToDoList modelActivityToDoList = new ModelActivityToDoList();
			
			//Stores the model in the session
			session.setAttribute("modelActivityToDoList", modelActivityToDoList);
		
			try{		
				//Model processing
				modelActivityToDoList.process(projectName);
		
				//Request redirection in order to build the client response
				this.getServletContext().getRequestDispatcher("/web/jsp/toDoList.jsp").forward(request ,response);
			}
		
			catch(Exception e){
				e.printStackTrace();
				response.sendError(	HttpServletResponse.SC_INTERNAL_SERVER_ERROR,
				 					e.getMessage());
			}
		}
	}
}