/*
 * Created on September 2004, the 16th
 * By the Message Center Team
 */
package mc.formgenerator.servlets.bonita;

import java.io.IOException;

import javax.servlet.http.*;

/**
 * Servlet that will show user his work list in order to allow him to start an activity
 * 
 */
public class ServletWorkList extends HttpServlet {




	/**
	 * Get request
	 * @throws IOException
	 */
	public void doGet(HttpServletRequest req, HttpServletResponse res) throws IOException  {
		
		//Create the model corresponding to this controller
		ModelWorkList modelWorkList = new ModelWorkList();
		
		//Get the session of the user.
		HttpSession session = req.getSession(true);

		//Save in the session the model which has the information to display.
		session.setAttribute("modelWorkList", modelWorkList);		
		
		try{		
			//Asks to the model to do its work
		    modelWorkList.process();
			
			//The request is redirected on the JSP page so that it builds the answer for the user.
			this.getServletContext().getRequestDispatcher("/web/jsp/worklist.jsp").forward(req,res);

		}		
		catch(Exception e){
			e.printStackTrace();
			res.sendError(HttpServletResponse.SC_INTERNAL_SERVER_ERROR,	e.getMessage());
		}
	}
}
