package hero.client.grapheditor;

import hero.util.BonitaClient;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.Toolkit;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import javax.swing.BorderFactory;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.ToolTipManager;
import java.awt.Color;

public class Frame extends JFrame{

static java.util.ResourceBundle resource = java.util.ResourceBundle.getBundle("resources.Traduction")/*#BundleType=List*/;

	private  String project =null;
	WFManager manager;
	WFPersistence persistence;
	WFGraph wfGraph;
	JLabel statusBar = new JLabel(resource.getString("frame.workeditor"));
	JScrollPane scrollPane=null;
	public final static String imageBase = "images/";
	private final String CLOSE = "close";
	private static Frame frame;
	
	public Frame(){
		frame = this;
		frame.setBackground(new Color(177,177,251));
	}
    
	public Frame(String managerProject, BonitaClient soapclient, boolean subProcess) throws Exception{
		frame = this;
		
		//	java.awt.Frame f = new java.awt.Frame();
		//	SplashWindow sw = new SplashWindow(f,this);
	    
		java.net.URL iconUrl = Thread.currentThread().getContextClassLoader().getResource(imageBase + "icon.png");
		setIconImage(Toolkit.getDefaultToolkit().getImage(iconUrl));
	    
		persistence = new WFPersistence(managerProject,soapclient);
		// If open subprocess GraphEditor = only in visualization mode
		if (subProcess)
	    	persistence.permission=false;
	    
		manager= new WFManager(this,persistence);
		
		getContentPane().removeAll();
		getContentPane().setBackground(new Color(177,177,251));
	    
		//this.setJMenuBar(new WFMenuBar(this,manager));
		WFMenuBar menuBar = new WFMenuBar(this,manager);
		menuBar.setBackground(new Color(153,153,255));
		this.setJMenuBar(menuBar);
				    
	    this.project=managerProject;
	    
		//	JGraph graph = new JGraph();
		wfGraph = new WFGraph(manager,persistence);
	    
		wfGraph.setEditable(false);
		wfGraph.setBackground(new Color(177,177,251));
			    
			    
		//Register ToolTip
		ToolTipManager.sharedInstance().registerComponent(wfGraph);
		ToolTipManager.sharedInstance().setInitialDelay(100);
	    
		scrollPane = new JScrollPane(wfGraph);
		scrollPane.setBackground(new Color(177,177,251));
		    
		manager.setWFGraph(wfGraph);
	    
		WFToolBar toolBar = new WFToolBar(this,manager);
		toolBar.setBackground(new Color(177,177,251));
		toolBar.setFloatable(false);
		WFToolBar2 toolBar2 = new WFToolBar2(this,manager);
		toolBar2.setBackground(new Color(177,177,251));
		toolBar2.setFloatable(false);
			    	    
		JPanel toolPanel = new JPanel();
		toolPanel.setLayout(new BorderLayout());
		toolPanel.setBackground(new Color(177,177,251));
			    
		//toolPanel.add(scrollPane, BorderLayout.CENTER);
		//toolPanel.add(toolBar2, BorderLayout.NORTH);
	    
		toolPanel.add(toolBar2, BorderLayout.CENTER);
		toolPanel.add(statusBar, BorderLayout.SOUTH);
	    
	    statusBar.setBorder(BorderFactory.createLoweredBevelBorder());
		statusBar.setBackground(new Color(177,177,251));
		getContentPane().add(toolBar, BorderLayout.NORTH);
		getContentPane().add(scrollPane, BorderLayout.CENTER);
		getContentPane().add(toolPanel, BorderLayout.SOUTH);
			    
		pack();
		/*Dimension screenSize =Toolkit.getDefaultToolkit().getScreenSize();
		Dimension dim = getPreferredSize();
		setLocation(screenSize.width/2 - (dim.width/2),	screenSize.height/2 - (dim.height/2));*/
		
		frame.setSize(600, 600);
		frame.setBackground(new Color(177,177,251));
		Dimension screen = Toolkit.getDefaultToolkit().getScreenSize();
		setLocation((screen.width - getWidth()) / 2, (screen.height - getHeight()) / 2);
		
		this.setTitle(resource.getString("frame.grapheditor"));
		//this.setBackground(new Color(177,177,251));
		
	    
		this.addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent e) {
			  setPropertyChange();
			  manager.exit();
			}
			
			public void windowActivated(WindowEvent e) {
			  try {
			    if (!(persistence.soapclient.getProjectName()).equals(persistence.getProjectName()))
					persistence.openProject(persistence.getProjectName());
			  }catch(Exception open){}
			}
			
		});
	    manager.openProject(managerProject);      
	}

	public String getProject(){
		return this.project;
	}
	
	public void setPropertyChange(){
		firePropertyChange(CLOSE, "", frame.getProject());
	}
	
	public void setStatusBar(String info){
	statusBar.setText(info);
	statusBar.setBackground(new Color(177,177,251));
	}
	
	public WFGraph getWorkflowGraph() {
		return this.wfGraph;
	}
	
	public static Frame getFrame() {
		return frame;
	}

	public JScrollPane getScrollPane(){
	return scrollPane;
	}
}

