/**
 *
 * Bonita
 * Copyright (C) 1999 Bull S.A.
 * Bull 68 route de versailles  78434 Louveciennes Cedex France
 * Further information: bonita@objectweb.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 *
--------------------------------------------------------------------------
 * $Id: IconManager.java,v 1.1 2004/07/30 14:57:57 mvaldes Exp $
 *
--------------------------------------------------------------------------
 */

package hero.client.grapheditor;


import java.awt.Image;
import java.awt.Toolkit;
import java.net.URL;

public class IconManager {

	public static Image getIcon(String name) {
		URL iconUrl = Thread.currentThread().getContextClassLoader().getResource(Frame.imageBase + name);
		return Toolkit.getDefaultToolkit().getImage(iconUrl);
	}

	public static URL getIconUrl(String name) {
		return Thread.currentThread().getContextClassLoader().getResource(Frame.imageBase + name);
	}

	public static String[] listAvailablesIcons() {
		return new String[] {
			"publiee-icon.png",
			"classic-icon.png",
			"waiting-icon.png",
			"locked-red-icon.png",
			"locked-yellow-icon.png",
			"creation-icon.png",
			"ok-icon.png",
			"archived-icon.png" };
	}
	
	public static String getDefaultIcon() {
		return "classic-icon.png";
	}

}
