package hero.client.grapheditor;

import java.awt.Color;
import java.awt.Point;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.ImageIcon;
import javax.swing.JFrame;
import javax.swing.JMenu;
import javax.swing.JMenuItem;
import javax.swing.JPopupMenu;

public class WFContextMenu {
    
    static java.util.ResourceBundle resource = java.util.ResourceBundle.getBundle("resources.Traduction")/*#BundleType=List*/;
    
    public static JPopupMenu popupMenu(final JFrame frame, final Point p,final String nodeName,final WFManager manager){

	JPopupMenu menu = new JPopupMenu();    	
	JMenuItem mi;
	ClassLoader cl = frame.getClass().getClassLoader();

	if(nodeName!=null){  //BnNode Options

	    JMenu order = (JMenu) menu.add(new JMenu(resource.getString("wfcontextmenu.order")));
	    order.setBackground(new Color(177,177,251));
	    
	    mi =(JMenuItem) order.add(new JMenuItem(resource.getString("wfcontextmenu.front")));
		mi.setBackground(new Color(177,177,251));
	    mi.setIcon(new ImageIcon(cl.getResource("images/Forward.gif")));
	    mi.addActionListener (new ActionListener () {
		    public void actionPerformed (ActionEvent e) {
				manager.getGraph().toFront(nodeName);
		    }
		});
	    
	    mi = (JMenuItem) order.add(new JMenuItem(resource.getString("wfcontextmenu.back")));
		mi.setBackground(new Color(177,177,251));        
	    mi.setIcon(new ImageIcon(cl.getResource("images/Backward.gif")));
	    mi.addActionListener (new ActionListener () {
		    public void actionPerformed (ActionEvent e) {
			manager.getGraph().toBack(nodeName);
		    }
		});
	   
		menu.addSeparator();

        mi = (JMenuItem) menu.add(new JMenuItem(resource.getString("wfcontextmenu.addprop")));
		mi.setBackground(new Color(177,177,251));
		mi.setEnabled(manager.getPersistence().hasPermission());
		mi.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {   		      
			manager.addNodeProperty(nodeName); 
			}
		});
		
		mi = (JMenuItem) menu.add(new JMenuItem(resource.getString("wfcontextmenu.newhook")));
		mi.setBackground(new Color(177,177,251));
				mi.setEnabled(manager.getPersistence().hasPermission());
				mi.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {   		      
					manager.setNodeHook(nodeName); 
					}
		});
		
		mi = (JMenuItem) menu.add(new JMenuItem(resource.getString("wfcontextmenu.additer")));
		mi.setBackground(new Color(177,177,251));
		mi.setEnabled(manager.getPersistence().hasPermission());
		mi.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {   		      
			manager.iterate(nodeName); 
			}
		});
    
		mi = (JMenuItem) menu.add(new JMenuItem(resource.getString("wfcontextmenu.addperf")));
		mi.setBackground(new Color(177,177,251));
		mi.setEnabled(manager.getPersistence().hasPermission());
		mi.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {   		      
			manager.addPerformerAssigment(nodeName); 
			}
		});
    
	    mi = (JMenuItem) menu.add(new JMenuItem(resource.getString("wfcontextmenu.editact")));
		mi.setBackground(new Color(177,177,251));
	    mi.setEnabled(manager.getPersistence().hasPermission());
	    mi.addActionListener(new ActionListener() {
		    public void actionPerformed(ActionEvent e) {   		      
			manager.editNode(nodeName); 
		    }
		});
   	
	} else {

		JMenu project = (JMenu) menu.add(new JMenu(resource.getString("wfcontextmenu.configproj")));
		project.setBackground(new Color(177, 177, 251));

		mi = (JMenuItem) project.add(new JMenuItem(resource.getString("wfcontextmenu.addprop")));
		mi.setBackground(new Color(177, 177, 251));
		mi.setEnabled(manager.getPersistence().hasPermission());
		mi.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				manager.addProjectProperty();
			}
		});

		mi = (JMenuItem) project.add(new JMenuItem(resource.getString("wfcontextmenu.newhook")));
		mi.setBackground(new Color(177, 177, 251));
		mi.setEnabled(manager.getPersistence().hasPermission());
		mi.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				manager.setProjectHook();
			}
		});
		
	    menu.addSeparator();
	    		    
	    mi = (JMenuItem) menu.add(new JMenuItem(resource.getString("wfcontextmenu.newuser")));
		mi.setBackground(new Color(177,177,251));
	    mi.setIcon(new ImageIcon(cl.getResource("images/User.gif")));
	    mi.setEnabled(manager.getPersistence().hasPermission());
	    mi.addActionListener(new ActionListener() {
		    public void actionPerformed(ActionEvent e) {   		      
			manager.newUser();
		    }
		});
	    mi = (JMenuItem) menu.add(new JMenuItem(resource.getString("wfcontextmenu.userproj")));
		mi.setBackground(new Color(177,177,251));
	    mi.setIcon(new ImageIcon(cl.getResource("images/User2.gif")));
	    mi.setEnabled(manager.getPersistence().hasPermission());
	    mi.addActionListener(new ActionListener() {
		    public void actionPerformed(ActionEvent e) {   		      
			manager.usersInProject();
		    }
		});
		
		
	    menu.addSeparator();
		 
	    mi = (JMenuItem) menu.add(new JMenuItem(resource.getString("wfcontextmenu.addrole")));
		mi.setBackground(new Color(177,177,251));
	    mi.setIcon(new ImageIcon(cl.getResource("images/Role2.gif")));
	    mi.setEnabled(manager.getPersistence().hasPermission());
	    mi.addActionListener(new ActionListener() {
		    public void actionPerformed(ActionEvent e) {   		      
			manager.newRole();
		    }
		});
	    
	    mi = (JMenuItem) menu.add(new JMenuItem(resource.getString("wfcontextmenu.adduserrole")));
		mi.setBackground(new Color(177,177,251));
	    mi.setIcon(new ImageIcon(cl.getResource("images/Role.gif")));
	    mi.setEnabled(manager.getPersistence().hasPermission());
	    mi.addActionListener(new ActionListener() {
		    public void actionPerformed(ActionEvent e) {   		      
			manager.addUserToRole();
		    }
		});
	    
	}
	return menu;
	

    }
    
}

