package hero.client.grapheditor;

/**
 * WFGraph.java
 *
 *
 * Created: Mon Aug 12 11:23:48 2002
 *
 * @version 1.0
 */

import hero.interfaces.Constants;
import hero.net.ProjectSession.StrutsNodeValue;
import hero.net.ProjectSession.BnIterationLightValue;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Point;
import java.awt.Rectangle;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.Map;
import java.util.Observable;
import java.util.Observer;
import java.util.Set;

import javax.swing.BorderFactory;
import javax.swing.JPopupMenu;
import javax.swing.JScrollPane;
import javax.swing.JOptionPane;

import com.jgraph.JGraph;
import com.jgraph.event.GraphModelEvent;
import com.jgraph.event.GraphModelListener;
import com.jgraph.event.GraphSelectionEvent;
import com.jgraph.event.GraphSelectionListener;
import com.jgraph.graph.BasicMarqueeHandler;
import com.jgraph.graph.CellView;
import com.jgraph.graph.ConnectionSet;
import com.jgraph.graph.DefaultEdge;
import com.jgraph.graph.DefaultGraphCell;
import com.jgraph.graph.DefaultGraphModel;
import com.jgraph.graph.DefaultPort;
import com.jgraph.graph.EdgeView;
import com.jgraph.graph.GraphConstants;
import com.jgraph.graph.GraphView;
import com.jgraph.graph.Port;
import com.jgraph.graph.PortView;
import com.jgraph.graph.VertexView;
import java.awt.Toolkit;
import java.awt.Image;
import javax.swing.ImageIcon;
import java.net.URL;

import java.util.Collection;

import com.jgraph.graph.CellMapper;

public class WFGraph extends JGraph {

static java.util.ResourceBundle resource = java.util.ResourceBundle.getBundle("resources.Traduction")/*#BundleType=List*/;

    private DefaultGraphModel model;
    private WFManager manager;
    private WFPersistence persistence;
    public Hashtable nodes;
    private Hashtable edges;
    private DefaultGraphCell sourceCell;
    private boolean NEWEDGE = false;
    private Touch layout2;
    private boolean automaticLayout=false;
    private LayoutThread expand;
	private Image background;
	
	public final static String imageBase = "images/";
	public final static ImageIcon icon = new ImageIcon(Thread.currentThread().getContextClassLoader().getResource(imageBase + "icon.png"));

    public WFGraph ( final WFManager manager,WFPersistence persist){
	super();
	this.manager=manager;
	this.persistence=persist;
	nodes=new Hashtable();
	edges=new Hashtable();
    setMarqueeHandler(new WFMarqueeHandler());
	expand= new LayoutThread(this);
	layout2 = new Touch(this);
	WFListener listener =new WFListener();
	getView().addObserver(listener);
	addGraphSelectionListener(listener);
	getModel().addGraphModelListener(listener);

	setDragEnabled(false);
	setDropEnabled(false);

	// set resizable false
	setSizeable(false);
	setEditable(false);
	setConnectable(false);
	setDisconnectable(false);
	setBendable(false);
	setAntiAliased(true);
	setCloneable(false);

   //setBackground(new Color(0,153,204));
	    
	setAutomaticLayout(true);
	this.addMouseListener(new MouseAdapter() {
		public void mousePressed(MouseEvent e){
			if (e.getClickCount() == 1)
			{
		     try{
		      if (!(persistence.soapclient.getProjectName()).equals(persistence.getProjectName()))
			 	persistence.openProject(persistence.getProjectName());
			 }catch(Exception openProject){}
			}
		    if (e.getClickCount() == 2)
		    {
			DefaultGraphCell myCell =(DefaultGraphCell) getFirstCellForLocation(e.getX(), e.getY());
			if (myCell != null &&  isVertex(myCell))
			{
				Map props = myCell.getAttributes();	
				String subProcess = (String)props.get("subProcess");
				if (subProcess.equals("no")) {
				   try {
				     BrowserControl.displayURL(java.lang.System.getProperty("bonita.host")+"/bonita/protected/Action.jsp?projectname="+persistence.getProjectName()+"&nodename="+(String)myCell.getUserObject());
			       }catch(Exception ex){}
				}else
				{
				try{
				  Frame frame =	new hero.client.grapheditor.Frame((String)props.get("name"),persistence.soapclient, true);
				  frame.setSize(new Dimension(500, 400));
				  frame.setVisible(true);
				  frame.requestFocus();
				}catch(Exception exce){exce.printStackTrace();};
				}
			}
			if (myCell != null &&  isEdge(myCell))
			{
			    try {				
				Map props = myCell.getAttributes();				
				manager.setEdgeCondition((String)props.get("name"));
			    }catch(Exception ex){ex.printStackTrace();}
			}
		    }
		}
	    });
	    
		// load background
		URL backgroundUrl = Thread.currentThread().getContextClassLoader().getResource(imageBase + "background.png");
		this.background = Toolkit.getDefaultToolkit().getImage(backgroundUrl);		
		setUI(new BonitaGraphUI());

		// background
		setBackground(Color.decode("#F7F7F7"));
	    
    }

	public Image getBackgroundImage() {
		return background;
	}

    public void setAutomaticLayout(boolean value){
	automaticLayout=value;
	if (value){
	    layout2.start();
	    layout2.resetDamper();
	}else{
	    layout2.stop();	
	}
    }

	protected VertexView createVertexView(Object v, CellMapper cm) {
		if (v instanceof BonitaActivityCell) {
			return new BonitaActivityView(v, this, cm);
		}		
		return super.createVertexView(v, cm);
	}
	
    public void addNewNode(String name, int state, int type){
	Map map;

	if (!nodes.containsKey(name)){
	    Hashtable attributes = new Hashtable(); 
	    //DefaultGraphCell vertex = new DefaultGraphCell(name);
		BonitaActivityCell vertex = new BonitaActivityCell(name);			 
	    Map vertexAttrib = GraphConstants.createMap(); 
		Map props = new HashMap();
		props.put("type", "node");
		props.put("state", new Integer(state).toString());  
		props.put("name", name);
		props.put("iterate", "false");
		 
		
		if (type != Constants.Nd.SUB_PROCESS_NODE)
		{
		   	GraphConstants.setBounds(vertexAttrib, new Rectangle(20, 100, 85, 27));
		   	props.put("subProcess","no");
		}
	    else
	    {
	    	GraphConstants.setBounds(vertexAttrib, new Rectangle(20, 100, 85, 33));
			props.put("subProcess","yes");
	    }
		GraphConstants.setBorder(vertexAttrib, BorderFactory.createRaisedBevelBorder());
	    GraphConstants.setForeground(vertexAttrib, Color.white);
	    GraphConstants.setFontStyle(vertexAttrib, Font.BOLD);
	    GraphConstants.setFontSize(vertexAttrib,(float) 11);
	    GraphConstants.setOpaque(vertexAttrib, true);
		
		//	GraphConstants.setAutoSize(vertexAttrib, true);

	    vertex.setAttributes(props);
	       
	    switch (state) { 
	    case Constants.Nd.INITIAL: 
		GraphConstants.setBackground(vertexAttrib,(Color.lightGray).darker()); break;
	    case Constants.Nd.READY: 
		GraphConstants.setBackground(vertexAttrib,(Color.yellow).darker()); break;
	    case Constants.Nd.ANTICIPABLE: 
		GraphConstants.setBackground(vertexAttrib,(Color.green).darker()); break;
	    case Constants.Nd.ANTICIPATING:
		GraphConstants.setBackground(vertexAttrib,(Color.magenta).darker()); break;
	    case Constants.Nd.EXECUTING:
		GraphConstants.setBackground(vertexAttrib,(Color.red).darker()); break;
	    case Constants.Nd.EXECUTED:
		GraphConstants.setBackground(vertexAttrib,(Color.orange).darker()); break;
	    case Constants.Nd.TERMINATED: 
		GraphConstants.setBackground(vertexAttrib,(Color.cyan).darker()); break;
	    case Constants.Nd.ANT_SUSPENDED: 
		GraphConstants.setBackground(vertexAttrib,(Color.blue).darker()); break;
	    case Constants.Nd.EXEC_SUSPENDED:
		GraphConstants.setBackground(vertexAttrib,(Color.gray).darker()); break;
	    case Constants.Nd.DEAD:
		GraphConstants.setBackground(vertexAttrib,(Color.blue).darker()); break;
	    }
	    
	    GraphConstants.setSizeable(vertexAttrib,false); 
	    
	    attributes.put(vertex, vertexAttrib); 
	    vertex.add(new DefaultPort());
	    nodes.put(name,vertex);
	    Object[] cell = new Object[]{vertex}; 
	    model.insert(cell,null,null,attributes);
	   }
    }
    
    public void updateIterationNodes(String from, String to)
    {
		BonitaActivityCell vertexFrom = (BonitaActivityCell)nodes.get(from);
		if(nodes.containsKey(from)){
			Hashtable attributes = new Hashtable(); 
					
			Map propsFrom = vertexFrom.getAttributes();
			propsFrom.put("iterate","from");
			attributes.put(nodes.get(from), propsFrom); 
			model.insert(null,null,null,propsFrom);
			repaint();	
		}
		BonitaActivityCell vertexTo = (BonitaActivityCell)nodes.get(to);
		if(nodes.containsKey(to)){
			Hashtable attributes = new Hashtable(); 
						
			Map propsTo = vertexTo.getAttributes();
			propsTo.put("iterate","to");
			attributes.put(nodes.get(to), propsTo); 
			model.insert(null,null,null,propsTo);
			repaint();
		}		
    }

    public void addNewEdge(DefaultGraphCell in, DefaultGraphCell out,String name){
	Hashtable attributes = new Hashtable();
	DefaultEdge e = new DefaultEdge();

	Map edgeAttrib = GraphConstants.createMap();
	GraphConstants.setLineBegin(edgeAttrib, GraphConstants.TECHNICAL);
	GraphConstants.setBeginFill(edgeAttrib, true);
	GraphConstants.setBeginSize(edgeAttrib, 8);
	GraphConstants.setBendable(edgeAttrib,false);
	GraphConstants.setDisconnectable(edgeAttrib,false);
	attributes.put(e, edgeAttrib);
    
	Map inn = in.getAttributes();
	Map outn = out.getAttributes();

	Map props = new HashMap();
	props.put("type", "edge"); 
	props.put("name", name); 
	props.put("nodein", inn.get("name")); 
	props.put("nodeout", outn.get("name")); 
	e.setAttributes(props);

	ConnectionSet cs = new ConnectionSet();
	cs.connect(e,(DefaultPort)in.getChildAt(0),false);
	cs.connect(e,(DefaultPort)out.getChildAt(0),true);
	edges.put(name,e);
	Object[] cell = new Object[]{e};
	model.insert(cell,cs,null,attributes);
    }

	public void openGraph(String projectName) {
			try {
				newGraph();
				nodes.clear();
				edges.clear();

				Object[] nd = persistence.getNodes();
				for (int i = 0; i < nd.length; i++) {
					String nodeName = (String) nd[i];
					int state = persistence.getNodeState(nodeName);
					int type = persistence.getNodeType(nodeName);
					addNewNode(nodeName, state, type);
				}

				Object[] ed = persistence.getEdges();
				for (int i = 0; i < ed.length; i++) {
					String nEdge = (String) ed[i];
					String nodeIn = persistence.getEdgeInNode(nEdge);
					String nodeOut = persistence.getEdgeOutNode(nEdge);
					addNewEdge((DefaultGraphCell) nodes.get(nodeIn),(DefaultGraphCell) nodes.get(nodeOut),nEdge);
				}

				if (automaticLayout)
					layout2.resetDamper();
				
			Collection iterations = persistence.getIterations();
				Iterator ite = iterations.iterator();
				while (ite.hasNext())
				{
					BnIterationLightValue i = (BnIterationLightValue)ite.next();
					this.updateIterationNodes(i.getFromNode(),i.getToNode());
				}
				
			/*	Collection properties = persistence.getProperties();
				Iterator prop = properties.iterator();
				ArrayList itNodes = new ArrayList();
				while (prop.hasNext())
				{
					String pProp = (String)prop.next();
					if (pProp.matches("iterate_"+".*"))
					{
						itNodes = getItNodes(pProp);
						this.updateIterationNodes((String)itNodes.get(0),(String)itNodes.get(1));	
					}
				}*/

			} catch (Exception e1) {e1.printStackTrace();
			}

		}
		
	/**
	 * Method that returns iteration nodes of this property
	 */

	private ArrayList getItNodes(String prop)
		throws Exception {
		ArrayList nodes = new ArrayList();
		int index = prop.indexOf("iterate_");
		prop = prop.substring(index+8);
		index = prop.indexOf("-");
		String to = prop.substring(index+1);
		String from = prop.substring(0,index);
		nodes.add(from);
		nodes.add(to);
		return(nodes);
	}

    public void newGraph(){
	nodes.clear();
	edges.clear();
	model = new DefaultGraphModel();
	setModel(model);
	manager.setStatusBar(" ");
    };
    

    public void setLayout1(){
	basicLayout(this);
    }
    public void setExpand(){
	expand.step();
    }
    public void setZoom(int value){
	setScale(1);	
    }
    public void zoomIn(){
	setScale(getScale()*2); 
    }
    
    public void zoomOut(){
	if (getScale() > 0.01)
	    setScale(getScale()/2);
	
    }

    public void fitWindow(JScrollPane scrollPane){
	Dimension p = getPreferredSize();
	Dimension s = scrollPane.getViewport().getBounds().getSize();
	if (Math.abs (s.getWidth () - p.getWidth ()) <
	    Math.abs (s.getHeight () - p.getHeight ()))
	    setScale ((double) s.getWidth () / p.getWidth ());
	else setScale ((double) s.getHeight () / p.getHeight ());
    }

    public void selectAll(){
	addSelectionCells(getRoots());

    }

    public boolean isGroup(Object cell) {
	// Map the Cell to its View
	CellView view = getView().getMapping(cell, false);
	if (view != null)
	    return !view.isLeaf();
	return false;
    }



    public boolean isVertex(Object object) {
	if (!(object instanceof Port) && !(object instanceof com.jgraph.graph.Edge))
	    return !isGroup(object);
	return false;
    }

    public boolean isEdge(Object object) {
	return (object instanceof com.jgraph.graph.Edge);
    }

    public Object[] getSelectionNodes() {
	Object[] tmp = getSelectionCells();
	Object[] all = DefaultGraphModel.getDescendants(getModel(), tmp).toArray();
	Object[] cells = getVertices(all);
	Object[] elems = new Object[cells.length];
	for(int i=0;i<cells.length;i++){
	    elems[i]=(String)(((DefaultGraphCell)cells[i]).getUserObject());
	}
	return elems;
    }
    
	public boolean isSubProcess(String name) {
	 Object[] tmp = getSelectionCells();
	 Object[] all = DefaultGraphModel.getDescendants(getModel(), tmp).toArray();
	 Object[] cells = getVertices(all);
	 Object[] elems = new Object[cells.length];
	 for(int i=0;i<cells.length;i++){
	 	if (name.equals((String)((DefaultGraphCell)cells[i]).getUserObject()))
	 	{
		  DefaultGraphCell myCell = (DefaultGraphCell)cells[i];
		  Map props = myCell.getAttributes();	
		  String subProcess = (String)props.get("subProcess");
		  if (subProcess.equals("yes"))
		  	return(true);
	 	 }
	  }
	 return false;
    }

    public Object[] getVertices(Object[] cells) {
	if (cells != null) {
	    ArrayList result = new ArrayList();
	    for (int i = 0; i < cells.length; i++)
		if (isVertex(cells[i]))
		    result.add(cells[i]);
	    return result.toArray();
	}
	return null;
    }

    public Object[] getSelectionEdges() {
	Object[] all= getSelectionCells();
	Object[] cells = getEdges(all);
	Object[] elems = new Object[cells.length];
	for(int i=0;i<cells.length;i++){
	    elems[i]=(String)(((DefaultEdge)cells[i]).getAttributes().get("name"));
	}
	return elems;

    }

    public Object[] getEdges(Object[] cells) {
	if (cells != null) {
	    ArrayList result = new ArrayList();
	    for (int i = 0; i < cells.length; i++)
		if (isEdge(cells[i]))
		    result.add(cells[i]);
	    return result.toArray();
	}
	return null;
    }

    public Object[] getEdge(Object[] cells, String name) {
	if (cells != null) {
	    ArrayList result = new ArrayList();
	    for (int i = 0; i < cells.length; i++)
	    {
		if (isEdge(cells[i]))
		{
		    Map a = ((DefaultEdge)cells[i]).getAttributes();
		    if (name.equals(a.get("name")))
			result.add(cells[i]);
		}
	    }
	    return result.toArray();
	}
	return null;
    }

    public void removeNodeEdges(Object[] cells, String name) {
	if (cells != null) {
	    for (int i = 0; i < cells.length; i++)
	    {
		if (isEdge(cells[i]))
		{
		    Map a = ((DefaultEdge)cells[i]).getAttributes();
		    if (name.equals(a.get("nodein")) || name.equals(a.get("nodeout")))
			deleteEdge((String)a.get("name"));
		}
	    }
	}
    }

    public void deleteNode(String node) throws Exception{
	  if(nodes.containsKey(node)){
	      Object[] all=getRoots();
	      removeNodeEdges(all,node);
		  getModel().remove(new Object[]{nodes.get(node)});
		  nodes.remove(node);
	  }
    }

    public void deleteEdge(String edge){
	  if(edges.containsKey(edge)){
	    Object[] all=getRoots();
	    getModel().remove(getEdge(all,edge));
	    edges.remove(edge);	
	 }
    }

    public boolean existEdge(String name){
	return(edges.containsKey(name));
    }

	public void restoreEdges() {
		try {
			Object[] all = getRoots();
			Object[] ed = getEdges(all);

			edges.clear();
			if (ed != null) {
				getModel().remove(ed);
				Object[] edv = persistence.getEdges();
				for (int i = 0; i < edv.length; i++) {
					String nEdge = (String) ed[i];
					String nodeIn = persistence.getEdgeInNode(nEdge);
					String nodeOut = persistence.getEdgeOutNode(nEdge);
					addNewEdge(
						(DefaultGraphCell) nodes.get(nodeIn),
						(DefaultGraphCell) nodes.get(nodeOut),
						nEdge);
				}
			}
		} catch (Exception e1) {
			JOptionPane.showMessageDialog(
				null,
				resource.getString("wfgraph.edgeerror"));
		}

	}

    public void restoreEdge(String nEdge, String nodeIn, String nodeOut){
	
	addNewEdge((DefaultGraphCell)nodes.get(nodeIn),(DefaultGraphCell)nodes.get(nodeOut),nEdge);
    }



    public void changeNodeState(String node,int state){
	if(nodes.containsKey(node)){
	    Hashtable attributes = new Hashtable(); 
	    Map vertexAttrib = GraphConstants.createMap(); 
	    switch (state) { 
	    case Constants.Nd.INITIAL: 
		GraphConstants.setBackground(vertexAttrib,(Color.lightGray).darker()); break;
	    case Constants.Nd.READY: 
		GraphConstants.setBackground(vertexAttrib,(Color.yellow).darker()); break;
	    case Constants.Nd.ANTICIPABLE: 
		GraphConstants.setBackground(vertexAttrib,(Color.green).darker()); break;
	    case Constants.Nd.ANTICIPATING:
		GraphConstants.setBackground(vertexAttrib,(Color.magenta).darker()); break;
	    case Constants.Nd.EXECUTING:
		GraphConstants.setBackground(vertexAttrib,(Color.red).darker()); break;
	    case Constants.Nd.EXECUTED:
		GraphConstants.setBackground(vertexAttrib,(Color.orange).darker()); break;
	    case Constants.Nd.TERMINATED: 
		GraphConstants.setBackground(vertexAttrib,(Color.cyan).darker()); break;
	    case Constants.Nd.ANT_SUSPENDED: 
		GraphConstants.setBackground(vertexAttrib,(Color.blue).darker()); break;
	    case Constants.Nd.EXEC_SUSPENDED:
		GraphConstants.setBackground(vertexAttrib,(Color.gray).darker()); break;
	    case Constants.Nd.DEAD:
		GraphConstants.setBackground(vertexAttrib,(Color.blue).darker()); break;
	    }
	    attributes.put(nodes.get(node), vertexAttrib); 
	    model.insert(null,null,null,attributes);
	    repaint();
	}
    }

    public Object getNeighbour(Object edge, Object vertex) {
      Object source = getSourceVertex(edge);
      if (vertex == source)
	return getTargetVertex(edge);
      else
	return source;
    }

    public Object getSourceVertex(Object edge) {
      Object sourcePort = graphModel.getSource(edge);
      return graphModel.getParent(sourcePort);
    }

    public Object getTargetVertex(Object edge) {
      Object targetPort = graphModel.getTarget(edge);
      return graphModel.getParent(targetPort);
    }

    public CellView getSourceView(Object edge) {
      Object source = getSourceVertex(edge);
      return getView().getMapping(source, false);
    }

    public CellView getTargetView(Object edge) {
      Object target = getTargetVertex(edge);
      return getView().getMapping(target, false);
    }

    public Object[] getEdgesBetween(Object vertex1, Object vertex2) {
      ArrayList result = new ArrayList();
      Set edges = DefaultGraphModel.getEdges(graphModel, new Object[]{vertex1});
      Iterator it = edges.iterator();
      while (it.hasNext()) {
	Object edge = it.next();
	Object source = getSourceVertex(edge);
	Object target = getTargetVertex(edge);
	if ((source == vertex1 && target == vertex2) ||
	    (source == vertex2 && target == vertex1))
	      result.add(edge);
      }
      return result.toArray();
    }

	//Override JGraph getToolTipText method
	public String getToolTipText(MouseEvent e) {
		try {

			if (e != null) {
				//Fetch Cell under Mousepointer
				if (!(persistence.soapclient.getProjectName()).equals(persistence.getProjectName()))
					persistence.openProject(persistence.getProjectName());
				Object c = getFirstCellForLocation(e.getX(), e.getY());
				if (c != null && isVertex(c)) {
					String nodeName = convertValueToString(c);
					StrutsNodeValue nl = persistence.getProjectNode(nodeName);									

					String s =
						"<html><center><b>"
							+ nodeName
							+ "</b></center>"
							+ resource.getString("wfgraph.state")
							+ nl.getState()
							+ "<br>"
							+ resource.getString("wfgraph.role")
							+ nl.getRole()
							+ "<br>"
							+ resource.getString("wfgraph.type")
							+ nl.getType()
							+ "<br>"
							+ resource.getString("wfgraph.deadline")
							+ nl.getDeadline()
					    // +"<TEXTAREA cols=30 rows=5 name=description style=overflow:hidden;height:auto>"
					    //		+ nl.getDescription()
					    //   +"</TEXTAREA>"       
							+ "<br></html>";

					return s;
				}
			}
		} catch (Exception e1) {
			JOptionPane.showMessageDialog(null, resource.getString("wfgraph.errorgettool"));
		}

		return null;
	}

    public Object[] getAll() {
      return getDescendants(getRoots());
    }

    public void setAddEdgeState(boolean b){
	NEWEDGE = b;
    }

    public void toFront(String nodeName){
	Object[] cells = new Object[]{nodes.get(nodeName)};
	//	Object[] cells = graph.getSelectionCells();
	  if (cells != null) {
	    GraphView gv = getView();
	    CellView[] views = gv.getMapping(cells);
	    gv.toFront(views);
	  }
    }

    public void toBack(String nodeName){
	Object[] cells = new Object[]{nodes.get(nodeName)};
	//	  Object[] cells = graph.getSelectionCells();
	  if (cells != null) {
	    GraphView gv = getView();
	    CellView[] views = gv.getMapping(cells);
	    gv.toBack(views);
	  }
    }


    public static java.awt.image.BufferedImage toImage(JGraph graph) {
	Object[] cells = graph.getRoots();
	
	if (cells.length > 0) {
	    Rectangle bounds = graph.getCellBounds(cells);
	    graph.toScreen(bounds);
	    
	    // Create a Buffered Image
	    Dimension d = bounds.getSize();
	    java.awt.image.BufferedImage img = new java.awt.image.BufferedImage(d.width+10,
						  d.height+10, java.awt.image.BufferedImage.TYPE_INT_RGB);
	    Graphics2D graphics = img.createGraphics();
	    graphics.translate(-bounds.x+5, -bounds.y+5);
	    graph.paint(graphics);
	    
	    return img;
	}
	return null;
    }

    private static String addNodeToVRML(Point p,Color c){
	String vrml="Transform{\n"+
	    "translation "+p.getX()+" "+p.getY()+" 0\n"+
	    "	children[\n"+
	    "		Shape{\n"+
	    "	          appearance Appearance\n"+
            "	        {\n"+
	    "        		material Material\n"+
	    "        		{"+
	    "	                        diffuseColor "+c.getRed()+" "+c.getGreen()+" "+c.getBlue()+"\n"+
	    "	               		shininess 0.01\n"+
            "            			}"+
            "             		}"+
	    "                   geometry Box     { size 25 25 25  }\n"+
	    "	        }\n"+
	    "]\n"+
	    "}\n"; 			
	return vrml;
    }
    private static String addEdgeToVRML(Point in,Point out){
	String vrml=	"Shape{appearance Appearance { \n"+
	"material Material {\n"+
	    "	emissiveColor 1 1 1 }\n"+
	    "	}\n"+
	    " 	geometry IndexedLineSet {\n"+
	    " 		coord Coordinate {point [ "+in.getX()+" "+in.getY()+" 0\n"+
	    "					 "+out.getX()+" "+out.getY()+" 0\n"+
	    "					] }\n"+
	    "		coordIndex [0 1 ]\n"+
	    "		color Color { color [1 0 0, 0 1 0, 0 0 1]}\n"+
	    "		colorIndex [0 1 ]\n"+
	    "		colorPerVertex TRUE\n"+
	    "	}\n"+
	    "}\n";
	
	return vrml;
    }

    public static String vrmlView(JGraph graph){
	CellView[] views = graph.getView().getRoots();
	int max= 0;
	String vrml="#VRML V2.0 utf8\n Background{skyColor 0 0 0.5}\n";
	for(int i=0; i<views.length; i++){
	    if (views[i] instanceof VertexView){
		Point p = ((VertexView)views[i]).getCenterPoint();
		Color c=(Color)((Map)((VertexView)views[i]).getAttributes()).get("backgroundColor");
		vrml= vrml+addNodeToVRML(p,c);		
	    }else if (views[i] instanceof EdgeView){
		Point in=((EdgeView)views[i]).getPoint(0);
		Point out=((EdgeView)views[i]).getPoint(((EdgeView)views[i]).getPointCount()-1);
		vrml= vrml+addEdgeToVRML(in,out);
	    }
	}
	return vrml;

    }


    //Basic Layout
    public static void basicLayout (JGraph graph){
	//fetch all cell views
	CellView[] views = graph.getView().getRoots();
	//list to store the vertices
	java.util.List vertices = new ArrayList();
	int max= 0;
	//loop through all views
	for(int i=0; i<views.length; i++){
	    //Add vertex to list
	    if (views[i] instanceof VertexView){
		vertices.add(views[i]);
		//fetch bounds
		Rectangle b = views[i].getBounds();
		//update Maximum
		if(b !=null)
		    max = Math.max(Math.max(b.width, b.height), max);
	    }
	}
	//compute radius
	int r= (int) Math.max(vertices.size()*max/Math.PI, 100);
	//Compute Radial step
	double phi = 2*Math.PI/vertices.size();
	//Arrange vertices in a circle
	for (int i= 0; i<vertices.size(); i++){
	    //Cast the object to a CellView
	    CellView view = (CellView) vertices.get(i);
	    //Fetch the Bounds
	    Rectangle bounds = view.getBounds();
	    //Update the Location
	    if(bounds !=null)
		bounds.setLocation(r+(int) (r*Math.sin(i*phi)), r+(int) (r*Math.cos(i*phi)));
	}
	graph.repaint();
    }


    public class WFListener implements Observer,GraphModelListener,GraphSelectionListener{
	public WFListener(){} 
	//
	// Listeners
	//
	
	public void update(Observable o, Object obj){
	    if(automaticLayout)
		layout2.resetDamper();
	}
		
	// GraphSelectionListener
	public void valueChanged(GraphSelectionEvent e) {
	    if (!isSelectionEmpty()){
		if(automaticLayout)
		    layout2.setDamper(0);
		    //layout2.resetDamper();
	    }
	    manager.updateStatus();

	}
		
	// GraphModelListener
	public void graphChanged(GraphModelEvent e) {
	    if(automaticLayout)
		layout2.resetDamper();
	}		
    }
    
   /**
    * MarqueeHandler that can insert cells.
   */
    public class WFMarqueeHandler extends BasicMarqueeHandler {

	protected Point start, current;
	
	protected Rectangle bounds;
	
	protected PortView port, firstPort, lastPort;

	protected DefaultGraphCell sourceCell,destCell;
	
	protected boolean exception=false;

      /* Return true if this handler should be preferred over other handlers. */
	public boolean isForceMarqueeEvent(MouseEvent e) {
	    if ((e.getModifiers() & java.awt.event.InputEvent.BUTTON3_MASK) == 0) 
		return NEWEDGE || super.isForceMarqueeEvent(e);
	    return true;
      }

	public void mousePressed(MouseEvent event) {

	    if (NEWEDGE) {
		start = snap(event.getPoint());
		sourceCell = (DefaultGraphCell)getFirstCellForLocation(event.getX(), event.getY()); 
		event.consume();
	    }else{	    
		// Popup Menu 
		if ((event.getModifiers() & java.awt.event.InputEvent.BUTTON3_MASK) != 0) { 

		    Object cell = getFirstCellForLocation(event.getX(), event.getY()); 
		    JPopupMenu  menu = WFContextMenu.popupMenu(manager.getFrame(), event.getPoint(), convertValueToString(cell),manager); 
		    
		    // Flip along screen 
		    int x = event.getX(); 
		    int y = event.getY(); 
		    
		    menu.show(manager.getGraph(), x, y);
		}
	    }

	    super.mousePressed(event);
	}
	
	public void mouseDragged(MouseEvent event) {
	    if(NEWEDGE){
		Graphics g = getGraphics();
		Color   bg = getBackground();
		Color   fg = Color.black;
		g.setColor(fg);
		g.setXORMode(bg);
		current = snap(event.getPoint());
		overlay(g);
	    }
	    super.mouseDragged(event);
	}
	
	public void mouseReleased(MouseEvent event) {
		try {
			if (NEWEDGE) {
				destCell =(DefaultGraphCell) getFirstCellForLocation(event.getX(),	event.getY());
				if ((sourceCell != null) && (destCell != null)) {
					String name = persistence.addEdge((String) sourceCell.getUserObject(),(String) destCell.getUserObject());
					if (name != null) {
						addNewEdge(sourceCell, destCell, name);
					} else {
						exception = true;
					}
				}
				NEWEDGE = false;
				sourceCell = null;
				destCell = null;
			}

			super.mouseReleased(event);
			if (exception) {
				exception = false;
			}

		} catch (Exception e1) {
		}

	}
	
	public void mouseMoved(MouseEvent event) {
	    super.mouseMoved(event);
	}
	
	public void overlay(Graphics g) {
	    try{
		super.overlay(g);
		if(NEWEDGE){
		    repaint();
		    g.drawLine(start.x, start.y, current.x, current.y);
		}
	    }catch(Exception e){}
	}	
    }
    
    public class LayoutThread extends javax.swing.Timer {

	public LayoutThread(final WFGraph graph) {
	    super(200,new ActionListener() {
		    public void actionPerformed(ActionEvent e) {
			int n = graph.getModel().getRootCount();
			Spring s = new Spring(10*n);
			s.compute(graph);
			graph.repaint();
		    }
		});
	}
	
	public void step() {
	    super.fireActionPerformed(null);
	}
	
    }


}// WFGraph
