package hero.client.grapheditor;

/**
 * WFToolBar.java
 *
 *
 * Created: Fri Aug 09 16:18:15 2002
 *
 * @version 1.0
 */

import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.Color;

import javax.swing.ImageIcon;
import javax.swing.JButton;


public class WFToolBar extends javax.swing.JToolBar {

static java.util.ResourceBundle resource = java.util.ResourceBundle.getBundle("resources.Traduction")/*#BundleType=List*/;

    public WFToolBar (final Frame frame,final WFManager manager){
	
	super.setFloatable(true);
	boolean buttonState = manager.getPersistence().hasPermission();
	JButton jb;
	this.setMargin(new Insets(0,5,0,0));
	this.putClientProperty("JToolBar.isRollover", Boolean.TRUE);
	this.setBackground(new Color(177,177,251));


	ClassLoader cl = frame.getClass().getClassLoader();
	
	// New
	jb = new JButton(new ImageIcon(cl.getResource("images/new.png")));
	jb.setToolTipText(resource.getString("wftoolbar.newproj"));
	jb.setBackground(new Color(177,177,251));
	jb.setMargin(new Insets(0,0,0,0));
	jb.setText(null);
	jb.addActionListener (new ActionListener () {
		public void actionPerformed (ActionEvent e) {
		    manager.newProject();
		}
	    });
	super.add(jb);

	// Open
	jb = new JButton(new ImageIcon(cl.getResource("images/open.png")));
	jb.setToolTipText(resource.getString("wftoolbar.openproj"));
	jb.setBackground(new Color(177,177,251));
	jb.setMargin(new Insets(0,0,0,0));
	jb.setText(null);
	jb.addActionListener (new ActionListener () {
		public void actionPerformed (ActionEvent e) {
		    manager.openProject();
		}
	    });
	super.add(jb);

	super.addSeparator();
	// Copy
	jb = new JButton(new ImageIcon(cl.getResource("images/Copy.gif")));
	jb.setBackground(new Color(177,177,251));
	jb.setToolTipText(resource.getString("wftoolbar.copy"));
	jb.setMargin(new Insets(0,0,0,0));
	jb.setText(null);
	jb.setEnabled(buttonState);
	jb.addActionListener (new ActionListener () {
		public void actionPerformed (ActionEvent e) {
		    manager.copySelection();
		}
	    });
	super.add(jb);

	// Paste
	jb = new JButton(new ImageIcon(cl.getResource("images/Paste.gif")));
	jb.setToolTipText(resource.getString("wftoolbar.paste"));
	jb.setBackground(new Color(177,177,251));
	jb.setMargin(new Insets(0,0,0,0));
	jb.setText(null);
	jb.setEnabled(buttonState);
	jb.addActionListener (new ActionListener () {
		public void actionPerformed (ActionEvent e) {
		    manager.pasteSelection();
		}
	    });
	super.add(jb);

	// Delete
	jb = new JButton(new ImageIcon(cl.getResource("images/Delete.gif")));
	jb.setToolTipText(resource.getString("wftoolbar.delete"));
	jb.setBackground(new Color(177,177,251));
	jb.setMargin(new Insets(0,0,0,0));
	jb.setText(null);
	jb.setEnabled(buttonState);
	jb.addActionListener (new ActionListener () {
		public void actionPerformed (ActionEvent e) {
		    manager.deleteSelection();
		}
	    });
	super.add(jb);

	super.addSeparator();


	super.addSeparator();
	
	jb = new JButton(new ImageIcon(cl.getResource("images/Zoom100.gif")));   // Zoom 100%
	jb.setToolTipText(resource.getString("wftoolbar.zoom100"));
	jb.setBackground(new Color(177,177,251));
	jb.setMargin(new Insets(0,0,0,0));
	jb.addActionListener (new ActionListener () {
		public void actionPerformed (ActionEvent e) {
		    manager.zoom(100);
		}
	    });
	super.add(jb);
	
	jb = new JButton(new ImageIcon(cl.getResource("images/ZoomIn.gif")));   // Zoom In
	jb.setToolTipText(resource.getString("wftoolbar.zoomin"));
	jb.setBackground(new Color(177,177,251));
	jb.setMargin(new Insets(0,0,0,0));
	jb.addActionListener (new ActionListener () {
		public void actionPerformed (ActionEvent e) {
		    manager.zoomIn(); 
		}
	    });
	super.add(jb);
	
	jb = new JButton(new ImageIcon(cl.getResource("images/ZoomOut.gif")));   // Zoom Out
	jb.setToolTipText(resource.getString("wftoolbar.zoomout"));
	jb.setBackground(new Color(177,177,251));
	jb.setMargin(new Insets(0,0,0,0));
	jb.addActionListener (new ActionListener () {
		public void actionPerformed (ActionEvent e) {
		    manager.zoomOut();
		}
	    });
	super.add(jb);

	super.addSeparator();

	// Layout
	jb = new JButton(new ImageIcon(cl.getResource("images/Arrange.gif")));
	jb.setToolTipText(resource.getString("wftoolbar.circlay"));
	jb.setBackground(new Color(177,177,251));
	jb.setMargin(new Insets(0,0,0,0));
	jb.setText(null);
	jb.addActionListener (new ActionListener () {
		public void actionPerformed (ActionEvent e) {
		    manager.setLayout1();
		} 		
	    });
	super.add(jb);
	
	jb = new JButton(new ImageIcon(cl.getResource("images/Layout.gif")));
	jb.setToolTipText(resource.getString("wftoolbar.expand"));
	jb.setBackground(new Color(177,177,251));
	jb.setMargin(new Insets(0,0,0,0));
	jb.setText(null);
	jb.addActionListener (new ActionListener () {
		public void actionPerformed (ActionEvent e) {
		    manager.setLayout2();
		}
	    });
	super.add(jb);

    
    }
}
