package hero.client.grapheditor;

/**
 * WFWindowManager.java
 *
 *
 * Created: Mon Aug 12 12:02:44 2002
 *
 * @version 1.0
 */

import java.awt.*;
import java.util.*;

import hero.net.ProjectSession.StrutsNodeValue;
import hero.interfaces.Constants;
import javax.swing.JComboBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextField;
import javax.swing.JTextArea;
import javax.swing.SwingConstants;
import java.text.SimpleDateFormat;
import javax.swing.JCheckBox;
import javax.swing.ImageIcon;

public class WFWindowManager implements Constants{

static java.util.ResourceBundle resource = java.util.ResourceBundle.getBundle("resources.Traduction")/*#BundleType=List*/;

	WFManager manager;
	WFPersistence persistence;
	public final static String imageBase = "images/";
		public final static ImageIcon icon = new ImageIcon(Thread.currentThread().getContextClassLoader().getResource(imageBase + "icon.png"));

	public String newProjectWindow() {
		try {
			JPanel jp = new JPanel();			
			ArrayList types = new ArrayList();
			types.add("Model");
			types.add("Cooperative");
			JComboBox processTypes = new JComboBox(types.toArray());
			processTypes.setSelectedItem("Model");
			
			JTextField projectName = new JTextField();			
			jp.add(new JLabel(resource.getString("wfwindowsmanager.newproj"), SwingConstants.LEFT));
			jp.add(projectName);
						
			jp.setLayout(new GridLayout(0, 2));
			jp.add(new JLabel(resource.getString("wfwindowsmanager.choosetype"), SwingConstants.LEFT));
			jp.add(processTypes);
						
			int cloneOption =JOptionPane.showConfirmDialog(null,jp,resource.getString("wfwindowsmanager.newproj"),JOptionPane.OK_CANCEL_OPTION,JOptionPane.QUESTION_MESSAGE, icon);
			if (cloneOption != JOptionPane.CANCEL_OPTION) {
				while ((projectName.getText()).equals("")
					&& cloneOption != JOptionPane.CANCEL_OPTION) {
					JOptionPane.showMessageDialog(null,resource.getString("wfwindowsmanager.enterproj"),resource.getString("wfwindowsmanager.newproj"),JOptionPane.INFORMATION_MESSAGE, icon);
					cloneOption =JOptionPane.showConfirmDialog(null,jp,resource.getString("wfwindowsmanager.newproj"),JOptionPane.OK_CANCEL_OPTION,JOptionPane.QUESTION_MESSAGE, icon);		
				}
				if (cloneOption != JOptionPane.CANCEL_OPTION) {
					boolean ok = false;
					if (processTypes.getSelectedItem().equals("Model"))
						ok =persistence.createModel(projectName.getText());
					else
						ok = persistence.createProject(projectName.getText());					
					if (!ok) {
						JOptionPane.showMessageDialog(null,resource.getString("wfwindowsmanager.existproj"),resource.getString("wfwindowsmanager.newproj"),JOptionPane.INFORMATION_MESSAGE, icon);

					} else {
						manager.setTitle(projectName.getText());
						return projectName.getText();
					}
				}
			}
		} catch (Exception e1) {
			JOptionPane.showMessageDialog(null,resource.getString("wfwindowsmanager.createerror"),resource.getString("wfwindowsmanager.newproj"),JOptionPane.INFORMATION_MESSAGE, icon);
		}
		return null;
	}

	public WFWindowManager(WFManager manager, WFPersistence persistence) {
		this.manager = manager;
		this.persistence = persistence;
	}

	public boolean cloneProjectWindow() {
		try {
			JPanel jp = new JPanel();
			Object[] possibleValues = persistence.getProjects();
			JComboBox projectNames = new JComboBox(possibleValues);
			jp.setLayout(new GridLayout(0, 2));
			jp.add(new JLabel(resource.getString("wfwindowsmanager.chooseproj"), SwingConstants.LEFT));
			jp.add(projectNames);

			JTextField newProject = new JTextField("", 0);
			jp.setLayout(new GridLayout(0, 2));
			jp.add(new JLabel(resource.getString("wfwindowsmanager.projname"), SwingConstants.LEFT));
			jp.add(newProject);
			
			int cloneOption =JOptionPane.showConfirmDialog(null,jp,resource.getString("wfwindowsmanager.cloneproj"),JOptionPane.OK_CANCEL_OPTION,JOptionPane.QUESTION_MESSAGE, icon);
			if (cloneOption != JOptionPane.CANCEL_OPTION) {
				while ((newProject.getText()).equals("")
					&& cloneOption != JOptionPane.CANCEL_OPTION) {
					JOptionPane.showMessageDialog(null,resource.getString("wfwindowsmanager.enterproj"),resource.getString("wfwindowsmanager.cloneproj"),JOptionPane.INFORMATION_MESSAGE, icon);
					cloneOption =JOptionPane.showConfirmDialog(null,jp,resource.getString("wfwindowsmanager.cloneproj"),JOptionPane.OK_CANCEL_OPTION,JOptionPane.QUESTION_MESSAGE, icon);		
				}
				if (cloneOption != JOptionPane.CANCEL_OPTION) {
					boolean ok =persistence.cloneProject((String) projectNames.getSelectedItem(),newProject.getText());
					if (!ok) {
						JOptionPane.showMessageDialog(null,resource.getString("wfwindowsmanager.existproj"),resource.getString("wfwindowsmanager.cloneproj"),JOptionPane.INFORMATION_MESSAGE, icon);
					} else {
						manager.openProject(newProject.getText());
						return true;
					}
				}
			}
		} catch (Exception e1) {
			JOptionPane.showMessageDialog(null,resource.getString("wfwindowsmanager.cloneerror"),resource.getString("wfwindowsmanager.cloneproj"),JOptionPane.INFORMATION_MESSAGE, icon);
		}
		return false;
	}

	public void openProject() {
		try {
			Object[] values = persistence.getProjects();
			Object selectedValue = JOptionPane.showInputDialog(null,resource.getString("wfwindowsmanager.graphedit"),resource.getString("wfwindowsmanager.openproj"),JOptionPane.INFORMATION_MESSAGE,icon,values,values[0]);
			if (selectedValue != null) {
				manager.openProject((String) selectedValue);
			}
		} catch (Exception e1) {
			JOptionPane.showMessageDialog(null, resource.getString("wfwindowsmanager.openerror"),resource.getString("wfwindowsmanager.openproj"),JOptionPane.INFORMATION_MESSAGE, icon);
		}
	}
	
	public void editNode(String nodeName) {

		String result = null;
		JPanel jp = new JPanel();
		try {
			persistence.setProjectNodes();
			StrutsNodeValue nl = persistence.getProjectNode(nodeName);
			GridBagLayout gridbag = new GridBagLayout();
			GridBagConstraints c = new GridBagConstraints();
			jp.setLayout(gridbag);

			c.fill = GridBagConstraints.BOTH;
			c.weightx = 1.0;

			jp.add(new JLabel(resource.getString("wfwindowsmanager.deadline")));
			DateComboBox dcb = new DateComboBox();
			SimpleDateFormat df = new SimpleDateFormat("yyyy-MM-dd");
			SimpleDateFormat dateFormat = new SimpleDateFormat("MMM dd,yyyy");
			if (persistence.getDeadline(nodeName) != null)
				dcb.setSelectedItem(dateFormat.format(df.parse(nl.getDeadline().toString())));

			dcb.setEditable(true);
			jp.add(dcb);
			gridbag.setConstraints(dcb, c);
			c.gridwidth = GridBagConstraints.REMAINDER;

			c.weightx = 1.0;
			Object[] possibleRoles = persistence.getRoles();
			JComboBox roles = new JComboBox(possibleRoles);
			roles.setSelectedItem(persistence.getRole(nodeName));
			jp.add(new JLabel(resource.getString("wfwindowsmanager.selectrole"), SwingConstants.LEFT));
			jp.add(roles);
			gridbag.setConstraints(roles, c);

			c.gridwidth = GridBagConstraints.REMAINDER;
			c.weightx = 0.0;

			JTextArea description = new JTextArea(nl.getDescription());
			JScrollPane areaScrollPane = new JScrollPane(description);
			areaScrollPane.setVerticalScrollBarPolicy(
			JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
			areaScrollPane.setPreferredSize(new Dimension(200, 100));

			jp.add(new JLabel(resource.getString("wfwindowsmanager.description"), SwingConstants.LEFT));
			jp.add(areaScrollPane);
			gridbag.setConstraints(areaScrollPane, c);
			
			JCheckBox anti = new JCheckBox(resource.getString("wfwindowsmanager.anticipable"));
			if (persistence.getNodeAnticipable(nodeName) == true)
				anti.setSelected(true);
			else
				anti.setSelected(false);
			jp.add(anti);
			gridbag.setConstraints(anti, c);

			int option =JOptionPane.showConfirmDialog(null,jp,resource.getString("wfwindowsmanager.editact"),JOptionPane.OK_CANCEL_OPTION,JOptionPane.QUESTION_MESSAGE, icon);

			if (option != JOptionPane.CANCEL_OPTION) {
				if (dcb.getSelectedItem() != null) {
					java.util.Date deadline =
						dateFormat.parse((String) dcb.getSelectedItem());

					while (deadline.getTime() <= System.currentTimeMillis()
						&& option != JOptionPane.CANCEL_OPTION) {
						JOptionPane.showMessageDialog(null,resource.getString("wfwindowsmanager.datedeadline"),resource.getString("wfwindowsmanager.editact"),JOptionPane.INFORMATION_MESSAGE, icon);
						option =JOptionPane.showConfirmDialog(null,jp,"Edit Activity",JOptionPane.OK_CANCEL_OPTION,JOptionPane.QUESTION_MESSAGE, icon);
						deadline =dateFormat.parse((String) dcb.getSelectedItem());
					}
					persistence.setEditNode(nodeName,(String) roles.getSelectedItem(),description.getText(),deadline);
				} else {
					persistence.setNodeDescription(nodeName,description.getText());
					persistence.setNodeRole(nodeName,(String) roles.getSelectedItem());
					if (!anti.isSelected())
						persistence.setNodeTraditional(nodeName);
					else
						persistence.setNodeAnticipable(nodeName);
				}
			}
		} catch (Exception e) {
			JOptionPane.showMessageDialog(null,resource.getString("wfwindowsmanager.editerror") + e.getMessage(),resource.getString("wfwindowsmanager.editact"),JOptionPane.INFORMATION_MESSAGE, icon);
		}
	}

	public Vector addInterHook() {
		Vector result = new Vector();
		Vector hookTypes = new Vector();
		hookTypes.add(hero.interfaces.Constants.Nd.AFTERSTART);
		hookTypes.add(hero.interfaces.Constants.Nd.BEFORESTART);
		hookTypes.add(hero.interfaces.Constants.Nd.AFTERTERMINATE);
		hookTypes.add(hero.interfaces.Constants.Nd.BEFORETERMINATE);
		hookTypes.add(hero.interfaces.Constants.Nd.ANTICIPATE);
		hookTypes.add(hero.interfaces.Constants.Nd.ONCANCEL);
		hookTypes.add(hero.interfaces.Constants.Nd.ONDEADLINE);
		hookTypes.add(hero.interfaces.Constants.Nd.ONREADY);

		JPanel jp = new JPanel();
		JTextField hook = new JTextField("", 10);
		jp.add(new JLabel(resource.getString("wfwindowsmanager.namehook"), SwingConstants.LEFT));
		jp.add(hook);

		JComboBox types = new JComboBox(hookTypes);
		jp.setLayout(new GridLayout(0, 2));
		jp.add(new JLabel(resource.getString("wfwindowsmanager.choosetype"), SwingConstants.LEFT));
		jp.add(types);

		int option = JOptionPane.showConfirmDialog(	null,jp,resource.getString("wfwindowsmanager.newhook"),JOptionPane.OK_CANCEL_OPTION,JOptionPane.QUESTION_MESSAGE, icon);

		if (option != JOptionPane.CANCEL_OPTION) {
			while ((hook.getText()).equals("")
				&& option != JOptionPane.CANCEL_OPTION) {
				JOptionPane.showMessageDialog(null,hook.getText()+ resource.getString("wfwindowsmanager.nullhook"),resource.getString("wfwindowsmanager.newhook"),JOptionPane.INFORMATION_MESSAGE, icon);
				option = JOptionPane.showConfirmDialog(	null,jp,resource.getString("wfwindowsmanager.newhook"),JOptionPane.OK_CANCEL_OPTION,JOptionPane.QUESTION_MESSAGE, icon);
			}
			if (option != JOptionPane.CANCEL_OPTION) {
				result.add(hook.getText());
				result.add((String) types.getSelectedItem());
				String value = null;
				switch (types.getSelectedIndex()) {
					case 0 :
						value = hero.interfaces.Constants.AFTERSTART;
						break;
					case 1 :
						value = hero.interfaces.Constants.BEFORESTART;
						break;
					case 2 :
						value = hero.interfaces.Constants.AFTERTERMINATE;
						break;
					case 3 :
						value = hero.interfaces.Constants.BEFORETERMINATE;
						break;
					case 4 :
						value = hero.interfaces.Constants.ANTICIPATE;
						break;
					case 5 :
						value = hero.interfaces.Constants.ONCANCEL;
						break;
					case 6 :
						value = hero.interfaces.Constants.ONDEADLINE;
						break;
					case 7 :
						value = hero.interfaces.Constants.ONREADY;
						break;
				}
				result.add(value);
				return (result);
			}
		}
		return (result);
	}

	public String setInterHookValue(String value) {

		String result = null;
		JPanel jp = new JPanel();
		JTextArea hook = new JTextArea(value);
		JScrollPane areaScrollPane = new JScrollPane(hook);
		areaScrollPane.setVerticalScrollBarPolicy(
		JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
		areaScrollPane.setPreferredSize(new Dimension(350, 250));

		jp.add(new JLabel(resource.getString("wfwindowsmanager.hookaction"), SwingConstants.LEFT));
		jp.add(areaScrollPane);

		int option =JOptionPane.showConfirmDialog(null,jp,resource.getString("wfwindowsmanager.hookscript"),JOptionPane.OK_CANCEL_OPTION,JOptionPane.QUESTION_MESSAGE, icon);

		if (option != JOptionPane.CANCEL_OPTION) {
			while ((hook.getText()).equals("")
				&& option != JOptionPane.CANCEL_OPTION) {
				JOptionPane.showMessageDialog(null,hook.getText()+ resource.getString("wfwindowsmanager.nullhook"),resource.getString("wfwindowsmanager.hookscript"),JOptionPane.INFORMATION_MESSAGE, icon);
				option =JOptionPane.showConfirmDialog(null,jp,resource.getString("wfwindowsmanager.hookscript"),JOptionPane.OK_CANCEL_OPTION,JOptionPane.QUESTION_MESSAGE, icon);		
			}
			if (option != JOptionPane.CANCEL_OPTION)
				result = hook.getText();
		}
		return (result);
	}

	public void addNodePropertyWindow(String node) {
		JPanel jp = new JPanel();

		JTextField key = new JTextField("", 0);
		jp.setLayout(new GridLayout(0, 2));
		jp.add(new JLabel(resource.getString("wfwindowsmanager.keyprop"), SwingConstants.LEFT));
		jp.add(key);

		JTextField value = new JTextField("", 0);
		jp.setLayout(new GridLayout(0, 2));
		jp.add(new JLabel(resource.getString("wfwindowsmanager.valprop"), SwingConstants.LEFT));
		jp.add(value);

		JCheckBox prop = new JCheckBox(resource.getString("wfwindowsmanager.propagate"));
		prop.setSelected(true);
		jp.add(prop);

		int option =JOptionPane.showConfirmDialog(null,jp,resource.getString("wfwindowsmanager.newnodeprop"),JOptionPane.OK_CANCEL_OPTION,JOptionPane.QUESTION_MESSAGE, icon);

		if (option != JOptionPane.CANCEL_OPTION) {
			while ((key.getText()).equals("")
				&& option != JOptionPane.CANCEL_OPTION) {
				JOptionPane.showMessageDialog(null,resource.getString("wfwindowsmanager.enterprop"),resource.getString("wfwindowsmanager.newnodeprop"),JOptionPane.INFORMATION_MESSAGE, icon);
				option =JOptionPane.showConfirmDialog(null,jp,resource.getString("wfwindowsmanager.newprop"),JOptionPane.OK_CANCEL_OPTION,JOptionPane.QUESTION_MESSAGE, icon);		
			}
			if (option != JOptionPane.CANCEL_OPTION && !prop.isSelected()) {
				try {
					persistence.addNodeProperty(node,key.getText(),value.getText(),	false);
				} catch (Exception e) {
					JOptionPane.showMessageDialog(null,resource.getString("wfwindowsmanager.existprop"),resource.getString("wfwindowsmanager.newnodeproperty"),JOptionPane.INFORMATION_MESSAGE, icon);
				}
			} else if (
				option != JOptionPane.CANCEL_OPTION && prop.isSelected()) {
				try {
					persistence.addNodeProperty(node,key.getText(),value.getText(),true);
				} catch (Exception e) {
					JOptionPane.showMessageDialog(null,resource.getString("wfwindowsmanager.adderrorprop"),resource.getString("wfwindowsmanager.newnodeprop"),JOptionPane.INFORMATION_MESSAGE, icon);
				}
			}
		}
	}
	
	public void addProjectPropertyWindow() {
			JPanel jp = new JPanel();

			JTextField key = new JTextField("", 0);
			jp.setLayout(new GridLayout(0, 2));
			jp.add(new JLabel(resource.getString("wfwindowsmanager.keyprop"), SwingConstants.LEFT));
			jp.add(key);

			JTextField value = new JTextField("", 0);
			jp.setLayout(new GridLayout(0, 2));
			jp.add(new JLabel(resource.getString("wfwindowsmanager.valprop"), SwingConstants.LEFT));
			jp.add(value);

			int option =JOptionPane.showConfirmDialog(null,jp,resource.getString("wfwindowsmanager.newpropproj"),JOptionPane.OK_CANCEL_OPTION,JOptionPane.QUESTION_MESSAGE, icon);

			if (option != JOptionPane.CANCEL_OPTION) {
				while ((key.getText()).equals("")
					&& option != JOptionPane.CANCEL_OPTION) {
					JOptionPane.showMessageDialog(null,resource.getString("wfwindowsmanager.enterprop"),resource.getString("wfwindowsmanager.newpropproj"),JOptionPane.INFORMATION_MESSAGE, icon);
					option =JOptionPane.showConfirmDialog(null,jp,resource.getString("wfwindowsmanager.newprop"),JOptionPane.OK_CANCEL_OPTION,JOptionPane.QUESTION_MESSAGE, icon);		
				}
				if (option != JOptionPane.CANCEL_OPTION) {
					try {
						persistence.addProjectProperty(key.getText(),value.getText());
					} catch (Exception e) {
						JOptionPane.showMessageDialog(null,resource.getString("wfwindowsmanager.adderrorprop"),resource.getString("wfwindowsmanager.newpropproj"),JOptionPane.INFORMATION_MESSAGE, icon);
					}
				}
			}
		}

	public void iterate(String node) {
			JPanel jp = new JPanel();

			JTextField from = new JTextField(node, 0);
			from.setEditable(false);
			jp.setLayout(new GridLayout(0, 2));
			jp.add(new JLabel(resource.getString("wfwindowsmanager.fromnode"), SwingConstants.LEFT));
			jp.add(from);
			
			JTextField to = new JTextField("", 0);
			jp.setLayout(new GridLayout(0, 2));
			jp.add(new JLabel(resource.getString("wfwindowsmanager.tonode"), SwingConstants.LEFT));
			jp.add(to);
			
			JTextField condition = new JTextField("", 30);
			jp.add(new JLabel(resource.getString("wfwindowsmanager.itecond"), SwingConstants.LEFT));
			jp.add(condition);

			int option =JOptionPane.showConfirmDialog(null,jp,resource.getString("wfwindowsmanager.iterate"),JOptionPane.OK_CANCEL_OPTION,JOptionPane.QUESTION_MESSAGE, icon);

			if (option != JOptionPane.CANCEL_OPTION) {
				while ((from.getText()).equals("") && (condition.getText()).equals("") 
					&& option != JOptionPane.CANCEL_OPTION) {
					JOptionPane.showMessageDialog(null,resource.getString("wfwindowsmanager.enternode"),resource.getString("wfwindowsmanager.iterate"),JOptionPane.INFORMATION_MESSAGE, icon);
					option =JOptionPane.showConfirmDialog(null,jp,resource.getString("wfwindowsmanager.iterate"),JOptionPane.OK_CANCEL_OPTION,JOptionPane.QUESTION_MESSAGE, icon);		
				}
				if (option != JOptionPane.CANCEL_OPTION) {
					try {
						persistence.addIteration(node,to.getText(), condition.getText());
						manager.wfGraph.updateIterationNodes(node,to.getText());
					} catch (Exception e) {
						JOptionPane.showMessageDialog(null,resource.getString("wfwindowsmanager.iterno"),resource.getString("wfwindowsmanager.iterate"),JOptionPane.INFORMATION_MESSAGE, icon);
					}
				}
			}
		}



	public Vector addNode() {
		Vector result = new Vector();
		try {
			JPanel jp = new JPanel();
			Vector nodeTypes = new Vector();
			nodeTypes.add("AND JOIN");
			nodeTypes.add("OR JOIN");
			nodeTypes.add("AND JOIN AUTO");
			nodeTypes.add("OR JOIN AUTO");

			JTextField nodeName = new JTextField("", 10);
			jp.add(new JLabel(resource.getString("wfwindowsmanager.namenode"), SwingConstants.LEFT));
			jp.add(nodeName);

			JComboBox types = new JComboBox(nodeTypes);
			jp.setLayout(new GridLayout(0, 2));
			jp.add(new JLabel(resource.getString("wfwindowsmanager.choosetype"), SwingConstants.LEFT));
			jp.add(types);
			int option = JOptionPane.showConfirmDialog(null,jp,resource.getString("wfwindowsmanager.newnode"),JOptionPane.OK_CANCEL_OPTION,JOptionPane.QUESTION_MESSAGE, icon);
			if (option != JOptionPane.CANCEL_OPTION) {
			  	while ((persistence.containsNode(nodeName.getText())
					|| (nodeName.getText()).equals(""))
					&& option != JOptionPane.CANCEL_OPTION) {
					JOptionPane.showMessageDialog(null,nodeName.getText()+ resource.getString("wfwindowsmanager.existnode"),resource.getString("wfwindowsmanager.newnode"),JOptionPane.INFORMATION_MESSAGE, icon);
					option =JOptionPane.showConfirmDialog(null,jp,"New Activity",JOptionPane.OK_CANCEL_OPTION,JOptionPane.QUESTION_MESSAGE, icon);
				}
				if (option != JOptionPane.CANCEL_OPTION) {
					result.add(nodeName.getText());
					result.add((String) types.getSelectedItem());
					return (result);

				}
			}
		} catch (Exception e1) {
			JOptionPane.showMessageDialog(null, resource.getString("wfwindowsmanager.errornode"),resource.getString("wfwindowsmanager.newnode"),JOptionPane.INFORMATION_MESSAGE, icon);
		}
		return (result);
	}
	
	public Vector addNodeSubProcess() {
		Vector result = new Vector();
		try {
			JPanel jp = new JPanel();

			Object[] possibleValues = persistence.getProjects();
			JComboBox projectNames = new JComboBox(possibleValues);
			jp.setLayout(new GridLayout(0, 2));
			jp.add(new JLabel(resource.getString("wfwindowsmanager.choosesub"), SwingConstants.LEFT));
			jp.add(projectNames);
			
			JTextField nodeName = new JTextField("", 10);
			jp.add(new JLabel(resource.getString("wfwindowsmanager.namenode"), SwingConstants.LEFT));
			jp.add(nodeName);

			int option = JOptionPane.showConfirmDialog(null,jp,resource.getString("wfwindowsmanager.newsub"),JOptionPane.OK_CANCEL_OPTION,JOptionPane.QUESTION_MESSAGE, icon);
			if (option != JOptionPane.CANCEL_OPTION) {
				while ((persistence.containsNode(nodeName.getText()) || (nodeName.getText()).equals(""))
									&& option != JOptionPane.CANCEL_OPTION) {
					JOptionPane.showMessageDialog(null,(String) projectNames.getSelectedItem()+ resource.getString("wfwindowsmanager.existnodesub"),resource.getString("wfwindowsmanager.newsub"),JOptionPane.INFORMATION_MESSAGE, icon);
					option =JOptionPane.showConfirmDialog(null,jp,resource.getString("wfwindowsmanager.newsub"),JOptionPane.OK_CANCEL_OPTION,JOptionPane.QUESTION_MESSAGE, icon);
				}
				while (persistence.containsProject(nodeName.getText()) && option != JOptionPane.CANCEL_OPTION) {
					JOptionPane.showMessageDialog(null,(String) projectNames.getSelectedItem()+ resource.getString("wfwindowsmanager.existsub"),resource.getString("wfwindowsmanager.newsub"),JOptionPane.INFORMATION_MESSAGE, icon);
					option =JOptionPane.showConfirmDialog(null,jp,resource.getString("wfwindowsmanager.newsub"),JOptionPane.OK_CANCEL_OPTION,JOptionPane.QUESTION_MESSAGE, icon);
				}
				if (option != JOptionPane.CANCEL_OPTION) {
					result.add(nodeName.getText());
					result.add((String) projectNames.getSelectedItem());
					return (result);
				}
			}
		} catch (Exception e1) {
			JOptionPane.showMessageDialog(null, resource.getString("wfwindowsmanager.errorsystem"),resource.getString("wfwindowsmanager.newsub"),JOptionPane.INFORMATION_MESSAGE, icon);
		}
		return (result);
	}

	public String setEdgeCondition(String edgeName) {
		String result = null;
		try {
		  JPanel jp = new JPanel();
		  JTextField condition = new JTextField("", 30);
		  jp.add(new JLabel(resource.getString("wfwindowsmanager.edgecond"), SwingConstants.LEFT));
		  jp.add(condition);
		  result = persistence.getEdgeCondition(edgeName);
		  condition.setText(result);

		  int option = JOptionPane.showConfirmDialog(null,jp,resource.getString("wfwindowsmanager.setedge"),JOptionPane.OK_CANCEL_OPTION,JOptionPane.QUESTION_MESSAGE, icon);

		  if (option != JOptionPane.CANCEL_OPTION) {
		 	while ((condition.getText()).equals("")
				&& option != JOptionPane.CANCEL_OPTION) {
				JOptionPane.showMessageDialog(null,condition.getText()+ resource.getString("wfwindowsmanager.entercond"),resource.getString("wfwindowsmanager.setedge"),JOptionPane.INFORMATION_MESSAGE, icon);
				option =JOptionPane.showConfirmDialog(null,jp,resource.getString("wfwindowsmanager.setedge"),JOptionPane.OK_CANCEL_OPTION,JOptionPane.QUESTION_MESSAGE, icon);
			}
			if (option != JOptionPane.CANCEL_OPTION) {
				result = condition.getText();
				return (result);

			}
		  }
		  } catch (Exception ec) {
			JOptionPane.showMessageDialog(null, resource.getString("wfwindowsmanager.erroredge"),resource.getString("wfwindowsmanager.setedge"),JOptionPane.INFORMATION_MESSAGE, icon);
		  }
		return (result);
	  }

	public void changeRoleWindow(String node) {
		try {
			Object[] possibleRoles = persistence.getRoles();

			JPanel jp = new JPanel();

			JComboBox roles = new JComboBox(possibleRoles);
			jp.setLayout(new GridLayout(0, 2));
			jp.add(new JLabel(resource.getString("wfwindowsmanager.selectrole"), SwingConstants.LEFT));
			jp.add(roles);

			int option =JOptionPane.showConfirmDialog(null,jp,resource.getString("wfwindowsmanager.changerole"),JOptionPane.OK_CANCEL_OPTION,JOptionPane.QUESTION_MESSAGE, icon);
			if (option != JOptionPane.CANCEL_OPTION) {
				persistence.setNodeRole(node, (String) roles.getSelectedItem());
			}

		} catch (Exception e) {
			JOptionPane.showMessageDialog(null,resource.getString("wfwindowsmanager.errorchangerole"),resource.getString("wfwindowsmanager.changerole"),JOptionPane.INFORMATION_MESSAGE, icon);
		}
	}
	
	
/* Open a dialog and return the filename. Returns null if cancelled. */
protected String dialog(String message, int mode) {
	FileDialog f = new FileDialog(manager.getFrame(), message, mode);
	f.show();
	if (f.getFile() != null)
		return f.getDirectory() + f.getFile();
	else
		return null;
}

	private boolean contains(Object[] data, String elem) {
		for (int i = 0; i < data.length; i++) {
			if (((String) data[i]).equalsIgnoreCase(elem))
				return true;
		}
		return false;
	}

	public void newUser() {
		try {
			Object[] usersIn = persistence.getUsersInProject();
			Object[] allUsers = persistence.getAllUsers();
			int size = allUsers.length - usersIn.length;

			if (size == 0)
				JOptionPane.showMessageDialog(null, resource.getString("wfwindowsmanager.nomoreuser"));
			else {
				Object[] possibleUsers = new Object[size];
				int j = 0;
				for (int i = 0; i < allUsers.length; i++) {
					if (!contains(usersIn, (String) allUsers[i])) {
						possibleUsers[j] = allUsers[i];
						j++;
					}
				}

				JPanel jp = new JPanel();

				JComboBox users = new JComboBox(possibleUsers);
				jp.setLayout(new GridLayout(0, 2));
				jp.add(new JLabel(resource.getString("wfwindowsmanager.selectuser"), SwingConstants.LEFT));
				jp.add(users);

				int option =JOptionPane.showConfirmDialog(null,jp,resource.getString("wfwindowsmanager.newuser"),JOptionPane.OK_CANCEL_OPTION,JOptionPane.QUESTION_MESSAGE, icon);

				if (option != JOptionPane.CANCEL_OPTION) {
					persistence.addUser((String) users.getSelectedItem());
				}
			}
		} catch (Exception e) {e.printStackTrace();}
	}

	public void newRole() {
		JPanel jp = new JPanel();

		JTextField roleName = new JTextField("", 0);
		jp.setLayout(new GridLayout(0, 2));
		jp.add(new JLabel(resource.getString("wfwindowsmanager.namerole"), SwingConstants.LEFT));
		jp.add(roleName);

		JTextField description = new JTextField("", 0);
		jp.setLayout(new GridLayout(0, 2));
		jp.add(new JLabel(resource.getString("wfwindowsmanager.description"), SwingConstants.LEFT));
		jp.add(description);

		int option =JOptionPane.showConfirmDialog(null,jp,resource.getString("wfwindowsmanager.newrole"),JOptionPane.OK_CANCEL_OPTION,JOptionPane.QUESTION_MESSAGE, icon);

		if (option != JOptionPane.CANCEL_OPTION) {
			while ((roleName.getText()).equals("")
				&& option != JOptionPane.CANCEL_OPTION) {
				JOptionPane.showMessageDialog(null,resource.getString("wfwindowsmanager.enterrolename"),resource.getString("wfwindowsmanager.newrole"),JOptionPane.INFORMATION_MESSAGE, icon);
				option =JOptionPane.showConfirmDialog(null,jp,"New Role",JOptionPane.OK_CANCEL_OPTION,JOptionPane.QUESTION_MESSAGE, icon);
			}
			if (option != JOptionPane.CANCEL_OPTION) {
				try {
					persistence.addRole(roleName.getText(),description.getText());
				} catch (Exception e) {
					JOptionPane.showMessageDialog(null,resource.getString("wfwindowsmanager.existrole"),resource.getString("wfwindowsmanager.newrole"),JOptionPane.INFORMATION_MESSAGE, icon);
				}
			}
		}
	}

	public void addUserToRole() {
		try {
			JPanel jp = new JPanel();

			Object[] possibleUsers = persistence.getUsersInProject();

			JComboBox users = new JComboBox(possibleUsers);
			jp.setLayout(new GridLayout(0, 2));
			jp.add(new JLabel(resource.getString("wfwindowsmanager.selectuser"), SwingConstants.LEFT));
			jp.add(users);

			Object[] possibleRoles = persistence.getRoles();

			JComboBox roles = new JComboBox(possibleRoles);
			jp.setLayout(new GridLayout(0, 2));
			jp.add(new JLabel(resource.getString("wfwindowsmanager.selectrole"), SwingConstants.LEFT));
			jp.add(roles);
			int option =JOptionPane.showConfirmDialog(null,	jp,resource.getString("wfwindowsmanager.adduserrole"),JOptionPane.OK_CANCEL_OPTION,JOptionPane.QUESTION_MESSAGE, icon);

			if (option != JOptionPane.CANCEL_OPTION) {
				try {
					persistence.setUserRole((String) users.getSelectedItem(),(String) roles.getSelectedItem());
				} catch (Exception exx) {
					JOptionPane.showMessageDialog(null,	resource.getString("wfwindowsmanager.existuserrole"),resource.getString("wfwindowsmanager.adduserrole"),JOptionPane.INFORMATION_MESSAGE, icon);
				}
			}
		} catch (Exception ex) {
			JOptionPane.showMessageDialog(null, resource.getString("wfwindowsmanager.exerole"),resource.getString("wfwindowsmanager.adduserrole"),JOptionPane.INFORMATION_MESSAGE, icon);
		}
	}
	
	public void addMapperToRole() {
		try {
			JPanel jp = new JPanel();
			
			Vector mapperTypes = new Vector();
			mapperTypes.add(Constants.Mapper.LDAPMAPPER);
			mapperTypes.add(Constants.Mapper.PROPERTIESMAPPER);
			mapperTypes.add(Constants.Mapper.CUSTOMMAPPER);

			Object[] possibleRoles = persistence.getRoles();

			JComboBox roles = new JComboBox(possibleRoles);
			jp.setLayout(new GridLayout(0, 2));
			jp.add(new JLabel(resource.getString("wfwindowsmanager.selectrole"), SwingConstants.LEFT));
			jp.add(roles);
			
			JTextField mapperName = new JTextField("", 0);
			jp.setLayout(new GridLayout(0, 2));
			jp.add(new JLabel(resource.getString("wfwindowsmanager.mapper"), SwingConstants.LEFT));
			jp.add(mapperName);
			
			JComboBox types = new JComboBox(mapperTypes);
			jp.setLayout(new GridLayout(0, 2));
			jp.add(new JLabel(resource.getString("wfwindowsmanager.mappertype"), SwingConstants.LEFT));
			jp.add(types);
			
			int option =JOptionPane.showConfirmDialog(null,	jp,resource.getString("wfwindowsmanager.addmapperrole"),JOptionPane.OK_CANCEL_OPTION,JOptionPane.QUESTION_MESSAGE, icon);

			if (option != JOptionPane.CANCEL_OPTION) {
				try {
					persistence.addRoleMapper((String) roles.getSelectedItem(), mapperName.getText(),(String)types.getSelectedItem());
				} catch (Exception exx) {
					JOptionPane.showMessageDialog(null,	resource.getString("wfwindowsmanager.existmapperrole"),resource.getString("wfwindowsmanager.addmapperrole"),JOptionPane.INFORMATION_MESSAGE, icon);
				}
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			JOptionPane.showMessageDialog(null, resource.getString("wfwindowsmanager.exemapper"),resource.getString("wfwindowsmanager.addmapperrole"),JOptionPane.INFORMATION_MESSAGE, icon);
		}
	}
	
	public void addPerformerAssigment(String nodeName) {
		JPanel jp = new JPanel();
			
		Vector performerTypes = new Vector();
		performerTypes.add(Constants.PerformerAssigment.CALLBACKPA);
		performerTypes.add(Constants.PerformerAssigment.PROPERTIESPA);
			
		JComboBox types = new JComboBox(performerTypes);
		jp.setLayout(new GridLayout(0, 2));
		jp.add(new JLabel(resource.getString("wfwindowsmanager.performertype"), SwingConstants.LEFT));
		jp.add(types);
			
		JTextField performerName = new JTextField("", 0);
		jp.setLayout(new GridLayout(0, 2));
		jp.add(new JLabel(resource.getString("wfwindowsmanager.performername"), SwingConstants.LEFT));
		jp.add(performerName);
		
		JTextField property = new JTextField("", 0);
		jp.setLayout(new GridLayout(0, 2));
		jp.add(new JLabel(resource.getString("wfwindowsmanager.performerprop"), SwingConstants.LEFT));
		jp.add(property);
			

		int option =JOptionPane.showConfirmDialog(null,	jp,resource.getString("wfwindowsmanager.addperformer"),JOptionPane.OK_CANCEL_OPTION,JOptionPane.QUESTION_MESSAGE, icon);
		if (option != JOptionPane.CANCEL_OPTION) {
    		try {
				persistence.addPerformerAssigment(nodeName, performerName.getText(), (String) types.getSelectedItem(),(String)property.getText());
			} catch (Exception exx) {
				JOptionPane.showMessageDialog(null,	resource.getString("wfwindowsmanager.existperformer"),resource.getString("wfwindowsmanager.addperformer"),JOptionPane.INFORMATION_MESSAGE, icon);
			}
		}
	}

	public void usersInProject() {
		try {
			JPanel jp = new JPanel();

			Object[] users = persistence.getUsersInProject();
			String text = resource.getString("wfwindowsmanager.userhtml");
			Object[] nameRoles = persistence.getRoles();
			for (int i = 0; i < nameRoles.length; i++) {
				text = text + "<th>" + (String) nameRoles[i] + "</th>";
			}

			for (int j = 0; j < users.length; j++) {

				text =text+ "<tr bgcolor=white><td>"+ (String) users[j]+ "</td>";

				for (int i = 0; i < nameRoles.length; i++) {
					if (persistence.isInRole((String) users[j], (String) nameRoles[i])) {
						text = text + "<td align=center> X </td>";
					} else {
						text = text + "<td></td>";
					}
				}
				text = text + "</tr>";
			}
			text = text + "</table></html>";
			JLabel jText = new JLabel(text);
			jp.add(jText);
			Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();

			JScrollPane scroll = new JScrollPane(jp);
			scroll.setMaximumSize(new Dimension(screenSize.width / 2, screenSize.height / 2));
			JFrame fr = new JFrame(resource.getString("wfwindowsmanager.userproj"));
			fr.getContentPane().add(scroll, BorderLayout.CENTER);
			fr.pack();

			Dimension jpDim = scroll.getPreferredSize();
			fr.setLocation(screenSize.width / 2 - (jpDim.width / 2),screenSize.height / 2 - (jpDim.height / 2));
			fr.setResizable(true);
			fr.setVisible(true);

		} catch (Exception ex) {
			JOptionPane.showMessageDialog(null, resource.getString("wfwindowsmanager.exeuserrole"),resource.getString("wfwindowsmanager.userole"),JOptionPane.INFORMATION_MESSAGE, icon);
		}
	}
	

} // WFWindowManager
