package hero.client.manager;

/*
*
* JActivityList.java - 
* Copyright (C) 2003 Ecoo Team
* valdes@loria.fr
* 
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/


import hero.interfaces.Constants;
import hero.util.BonitaClient;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.util.Iterator;
import java.util.Collection;

import javax.swing.DefaultListModel;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JPopupMenu;
import javax.swing.JScrollPane;
import javax.swing.ImageIcon;


public class JActivityList extends JPanel implements PropertyChangeListener, MouseListener, Constants.Nd {

static java.util.ResourceBundle resource = java.util.ResourceBundle.getBundle("resources.Traduction")/*#BundleType=List*/;

	private BonitaClient soapclient;
	private JList activityList = null;
	private DefaultListModel model;
	String project = null;
	public final static String imageBase = "images/";
	public final static ImageIcon icon = new ImageIcon(Thread.currentThread().getContextClassLoader().getResource(imageBase + "icon.png"));

	public JActivityList(BonitaClient soapclient, MListener ml)
	{
	  try{
	  this.soapclient = soapclient;
	  ml.addEventActivityListener(this);
	  
	  model = new DefaultListModel();
	  activityList = new JList(model);
	  activityList.setCellRenderer(new ManagerCellRenderer());
	  
	  JScrollPane jspact=new JScrollPane(activityList);
	  jspact.setBackground(new Color(177,177,251));
	  this.setBackground(new Color(177,177,251));
	  this.setLayout(new BorderLayout());
	  this.add(new JLabel(resource.getString("jactivitylist.activity")),BorderLayout.NORTH);
	  this.add(jspact,BorderLayout.CENTER);
	  activityList.addMouseListener(this);
	  }catch(Exception e){JOptionPane.showMessageDialog(null,resource.getString("jactivitylist.error"),resource.getString("jactivitylist.interror"),JOptionPane.INFORMATION_MESSAGE,icon);}
	}

	public void mouseReleased(MouseEvent e){
	try {
		// Popup Menu
		if ((e.getModifiers() & java.awt.event.InputEvent.BUTTON3_MASK) != 0) {
		if (activityList.getSelectedValue() != null)
		{
			JPopupMenu menu = new JPopupMenu();
			PopupMenu(menu);
			Dimension screen = Toolkit.getDefaultToolkit().getScreenSize();
			Dimension   size = menu.getPreferredSize();
		    
			// Flip along screen
			int x = e.getX();
			int y = e.getY();
		    
			menu.show(this, x, y);
		}
		}
		else if (e.getClickCount() == 2)
			BrowserControl.displayURL(java.lang.System.getProperty("bonita.host")+"/bonita/protected/Action.jsp?projectname="+project+"&nodename="+((ListItem)activityList.getSelectedValue()).getValue());

	}catch (Exception ex){};
	  }

	public void PopupMenu(JPopupMenu menu)
	{
	JMenuItem mi;
	ClassLoader cl = this.getClass().getClassLoader();
	
	mi = (JMenuItem) menu.add(new JMenuItem(resource.getString("jactivitylist.terminate")));
	mi.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent e) {
			terminate();
		}
		});

	mi = (JMenuItem) menu.add(new JMenuItem(resource.getString("jactivitylist.cancel")));
	mi.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent e) {
			cancel();
		}
		});
	
	mi = (JMenuItem) menu.add(new JMenuItem(resource.getString("jactivitylist.details")));
	mi.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent e) {
			BrowserControl.displayURL(java.lang.System.getProperty("bonita.host")+"/bonita/protected/Action.jsp?projectname="+project+"&nodename="+((ListItem)activityList.getSelectedValue()).getValue());
		}
		});
	}
    
	void terminate()
	{
	try {
		if (project != null)
		soapclient.terminateActivity(project, ((ListItem)activityList.getSelectedValue()).getValue());
	}catch(Exception term){
		if (term.getMessage().matches("(?i).*You have to terminate subProcess.*"))
			JOptionPane.showMessageDialog(null,resource.getString("jactivitylist.subnofinish"),resource.getString("jactivitylist.terminate"),JOptionPane.INFORMATION_MESSAGE,icon);
		else
			JOptionPane.showMessageDialog(null,resource.getString("jactivitylist.terminateerror")+term.getMessage(),resource.getString("jactivitylist.terminate"),JOptionPane.INFORMATION_MESSAGE,icon);}
	}

	void cancel()
	{
	try {
		if (project != null)
		soapclient.cancelActivity(project, ((ListItem)activityList.getSelectedValue()).getValue());

	}catch(Exception cancel){JOptionPane.showMessageDialog(null,resource.getString("jactivitylist.acterror")+cancel.getMessage(),"Cancel Activity",JOptionPane.INFORMATION_MESSAGE,icon);}
	}

	public void propertyChange(PropertyChangeEvent e)
	{
	   try {
	   if (e.getPropertyName().equals(JProjectList.SELECTED))
	   {
		   model.clear();
		   project = (String)e.getNewValue();
	       
		   Collection activity = soapclient.getActivityList(project);
		   Iterator i = activity.iterator();	    

		   while (i.hasNext())
		   {
		   String node = (String)i.next();
		   ListItem li = new ListItem(getColor(node),node);
		   model.addElement(li);
		   }
	   }
	   }catch(Exception e1){}
	}

	public Color getColor(String name) throws Exception{
	soapclient.openProject(project);	
	int state = soapclient.getNodeState(name);	
	switch (state) {
	case EXECUTING: return (Color.red);
	case ANTICIPATING: return (Color.magenta);
	}
	return(Color.white);
	}   

	public void changeEvent(Object[] e, String projectName)
	{
	  try{
	if (projectName.equals(project))
	{
		model.clear();
		int i=0;
		for (i=0;i<e.length;i++)
		{
		ListItem li = new ListItem(getColor(e[i].toString()),e[i].toString());
		model.add(i,li);
		}
	}
	  }catch(Exception e1){}
	}

	// Rest of mouse listener is empty
	public void mousePressed(MouseEvent e) { }
	public void mouseEntered(MouseEvent e) { }
	public void mouseExited(MouseEvent e) { }
	public void mouseClicked(MouseEvent e) { }


}


