package hero.client.manager;

/*
*
* JProjectList.java - 
* Copyright (C) 2003 Ecoo Team
* valdes@loria.fr
* 
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

import hero.interfaces.Constants;
import hero.util.EventConstants;
import hero.util.BonitaClient;
import hero.net.UserSession.BnProjectLightValue;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.GridLayout;
import java.awt.Toolkit;
import java.awt.Component;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.Collection;
import java.util.ArrayList;
import java.util.Enumeration;

import javax.swing.JComboBox;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JLabel;
import javax.swing.JPopupMenu;
import javax.swing.JScrollPane;
import javax.swing.ImageIcon;
import javax.swing.JTextField;
import javax.swing.SwingConstants;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.MutableTreeNode;
import javax.swing.tree.TreeCellRenderer;
import javax.swing.event.TreeModelListener;
import javax.swing.event.TreeModelEvent;
import javax.swing.tree.DefaultTreeCellRenderer;
import javax.swing.tree.DefaultTreeModel;
import javax.swing.tree.TreeSelectionModel;
import javax.swing.JTree;
import java.beans.PropertyChangeListener;
import java.beans.PropertyChangeEvent;

public class JProjectList
	extends JPanel
	implements PropertyChangeListener, Constants.Nd, EventConstants, MouseListener {
		
		 class MyTreeModelListener implements TreeModelListener {
            // Rest of TreeModelListener is empty
			public void treeNodesChanged(TreeModelEvent e) {
			}
			public void treeNodesInserted(TreeModelEvent e) {
			}
			public void treeNodesRemoved(TreeModelEvent e) {
			}
			public void treeStructureChanged(TreeModelEvent e) {
			}
		}

		protected static class CustomDefaultRenderer
						   extends DefaultTreeCellRenderer {
		  public Component getTreeCellRendererComponent(
					  JTree tree,
					  Object value,
					  boolean selected,
					  boolean expanded,
					  boolean leaf,
					  int row,
					  boolean hasFocus) {
		  // Allow the original renderer to set up the label
		   Component c = super.getTreeCellRendererComponent(
						  tree, value, selected,
						  expanded, leaf, row,
						  hasFocus); 

		   if (leaf) { 
			 // Use a different foreground
			 // color for leaf nodes.
			 if (leafForeground != null) {
			  c.setForeground(leafForeground);
			 } 
		   } 

		   return c; 
		  }
		   public void setLeafForeground(Color color) {
			 this.leafForeground = color;
		   } 

		   private Color leafForeground; 
		} 

		
static java.util.ResourceBundle resource = java.util.ResourceBundle.getBundle("resources.Traduction")/*#BundleType=List*/;

	private JScrollPane jsppl;
	private JTree tree;
	private MListener ml;
	private DefaultMutableTreeNode top;
	private DefaultTreeModel treeModel;
	public final static String SELECTED = "selected";
	public final static String PROJECTCLOSE = "close";
	public Hashtable projects = new Hashtable();
	private hero.client.grapheditor.Frame frame;
	private BonitaClient soapclient;
	private String newStatus=Constants.Pj.ACTIVE;
	private Collection actualProjects;
	public final static String imageBase = "images/";
	public final static ImageIcon icon = new ImageIcon(Thread.currentThread().getContextClassLoader().getResource(imageBase + "icon.png"));
	private Toolkit toolkit = Toolkit.getDefaultToolkit();


	public JProjectList(BonitaClient soapclient,MListener ml,Collection initialProjects) {
		try {
			this.actualProjects = initialProjects;
			ml.addEventProjectListener(this);
			
			this.add(new JLabel(resource.getString("jprojectlist.project")), BorderLayout.NORTH);
			this.soapclient = soapclient;

			top =  new DefaultMutableTreeNode(resource.getString("jprojectlist.project"));
			treeModel = new DefaultTreeModel(top);
			treeModel.addTreeModelListener(new MyTreeModelListener());

			tree = new JTree(treeModel);
			tree.getSelectionModel().setSelectionMode(TreeSelectionModel.SINGLE_TREE_SELECTION);
											
			TreeCellRenderer cr = tree.getCellRenderer(); 
			CustomDefaultRenderer dtcr = new CustomDefaultRenderer();
			tree.setCellRenderer(dtcr); 
			dtcr.setBackgroundNonSelectionColor(Color.white); 
			dtcr.setTextSelectionColor(Color.white); 
			dtcr.setTextNonSelectionColor(Color.black);  
			dtcr.setLeafForeground(Color.blue); 
			
			// Retrieve the three icons
			javax.swing.Icon leafIcon = new ImageIcon("images/ast.gif");
			dtcr.setLeafIcon(leafIcon);
			dtcr.setClosedIcon(leafIcon);
			dtcr.setOpenIcon(leafIcon);
			
			tree.setRowHeight(0); 

			//Finally, set the tree's background color 
			tree.setBackground(Color.white); 
						
			this.createNodes(actualProjects);
			jsppl = new JScrollPane(tree);

			this.setLayout(new BorderLayout());
			this.setBackground(new Color(177,177,251));
			this.add(jsppl, BorderLayout.CENTER);
			tree.addMouseListener(this);
			tree.setVisibleRowCount(10);
			this.setVisible(true);

			
		} catch (Exception e) {}
	}
		
	public void newProject() {
		JPanel jp = new JPanel();			
		ArrayList types = new ArrayList();
		types.add("Model");
		types.add("Cooperative");
		JComboBox processTypes = new JComboBox(types.toArray());
		processTypes.setSelectedItem("Model");
		
		JTextField projectName = new JTextField();			
		jp.add(new JLabel(resource.getString("wfwindowsmanager.newproj"), SwingConstants.LEFT));
		jp.add(projectName);
					
		jp.setLayout(new GridLayout(0, 2));
		jp.add(new JLabel(resource.getString("wfwindowsmanager.choosetype"), SwingConstants.LEFT));
		jp.add(processTypes);
					
		int cloneOption =JOptionPane.showConfirmDialog(null,jp,resource.getString("wfwindowsmanager.newproj"),JOptionPane.OK_CANCEL_OPTION,JOptionPane.QUESTION_MESSAGE, icon);
		if (cloneOption != JOptionPane.CANCEL_OPTION) {
			while ((projectName.getText()).equals("")
				&& cloneOption != JOptionPane.CANCEL_OPTION) {
				JOptionPane.showMessageDialog(null,resource.getString("wfwindowsmanager.enterproj"),resource.getString("wfwindowsmanager.newproj"),JOptionPane.INFORMATION_MESSAGE, icon);
				cloneOption =JOptionPane.showConfirmDialog(null,jp,resource.getString("wfwindowsmanager.newproj"),JOptionPane.OK_CANCEL_OPTION,JOptionPane.QUESTION_MESSAGE, icon);		
			}
			if (cloneOption != JOptionPane.CANCEL_OPTION) {
				try {
					if (exists(projectName.getText())) {
						JOptionPane.showMessageDialog(null,resource.getString("jprojectlist.exist"),resource.getString("jprojectlist.name"), JOptionPane.INFORMATION_MESSAGE,icon);
					} else {
						if (processTypes.getSelectedItem().equals("Model"))
							soapclient.createModel(projectName.getText());
						else
							soapclient.createProject(projectName.getText());
					}
				} catch (Exception ex) {ex.printStackTrace();
					JOptionPane.showMessageDialog(null,resource.getString("jprojectlist.exist"),resource.getString("jprojectlist.new"),JOptionPane.INFORMATION_MESSAGE,icon);
				}
			}
		}
	}
		
		private boolean exists(String project) {
			try {
				Object[] elems = this.actualProjects.toArray();
				for (int i = 0; i < elems.length; i++) {
					if (((String) elems[i]).equalsIgnoreCase(project))
						return true;
				}
				return false;
			} catch (Exception e) {
				e.printStackTrace();
			}
			return true;
		}


	public void mouseReleased(MouseEvent e) {
		try {
			if (!tree.isSelectionEmpty()) {
				DefaultMutableTreeNode node = (DefaultMutableTreeNode)tree.getLastSelectedPathComponent();
				if ((e.getModifiers() & java.awt.event.InputEvent.BUTTON3_MASK)
					!= 0) {
					JPopupMenu menu = new JPopupMenu();
					PopupMenu(menu);

					Dimension screen = Toolkit.getDefaultToolkit().getScreenSize();
					Dimension size = menu.getPreferredSize();

					// Flip along screen

					int x = e.getX();
					int y = e.getY();

					menu.show(this,e.getX()	- (int) jsppl.getViewport().getViewPosition().getX(),e.getY()- (int) jsppl.getViewport().getViewPosition().getY());
				} else if (e.getClickCount() == 1 && !node.isRoot()) {
					String pl = node.getUserObject().toString();
					firePropertyChange(SELECTED, "", pl);
				} else if (e.getClickCount() == 2 && !node.isRoot()) {
					try {
						if (!projects.containsKey(node.getUserObject().toString())) {
							frame =	new hero.client.grapheditor.Frame(node.getUserObject().toString(),soapclient, false);
							frame.setSize(new Dimension(500, 400));
							frame.setVisible(true);
							projects.put(node.getUserObject().toString(),frame);
							frame.addPropertyChangeListener(PROJECTCLOSE, this);
						} else {
							frame =(hero.client.grapheditor.Frame) projects.get(node.getUserObject().toString());
							frame.requestFocus();
						}
					} catch (Exception ce) {
						//JOptionPane.showMessageDialog(null,resource.getString("jprojectlist.modify")+ node.getUserObject().toString()+ resource.getString("jprojectlist.proj"),resource.getString("jprojectlist.open"),JOptionPane.INFORMATION_MESSAGE,icon);
					}
				}
			}
		} catch (Exception e1){
			JOptionPane.showMessageDialog(null,resource.getString("jprojectlist.error"),resource.getString("jprojectlist.interror"),JOptionPane.INFORMATION_MESSAGE,icon);
		}
	}

	public String getProjectType (String projectName) {
		try {
			soapclient.initProject(projectName);
			return (soapclient.getType());
		}catch (Exception e){return null;}
	}
	
	public String getProjectStatus (String projectName) {
		try{
			soapclient.initProject(projectName);
			return (soapclient.getStatus());
		}catch (Exception e){return null;}

	}
	
	public void PopupMenu(JPopupMenu menu) {
		JMenuItem mi;
		ClassLoader cl = this.getClass().getClassLoader();
		
		if (!((DefaultMutableTreeNode)tree.getLastSelectedPathComponent()).isRoot())
		{
			try {
				DefaultMutableTreeNode node = (DefaultMutableTreeNode)tree.getLastSelectedPathComponent();
				String status = this.getProjectStatus(node.getUserObject().toString());						
				if (status != null)					
				{
					String message ="";
					if (status.equals(Constants.Pj.ACTIVE))
					{
						message = resource.getString("jprojectlist.hideproject");
						newStatus = Constants.Pj.HIDDEN;
					}
					else
					{
						message = resource.getString("jprojectlist.activeproject");
						newStatus = Constants.Pj.ACTIVE;
					}
				
					mi = (JMenuItem) menu.add(new JMenuItem(message));
					mi.addActionListener(new ActionListener() {
						public void actionPerformed(ActionEvent e) {
							DefaultMutableTreeNode node = (DefaultMutableTreeNode)tree.getLastSelectedPathComponent();
							setStatus(node.getUserObject().toString());
						}
					});
				}
			}catch (Exception statusEx) {statusEx.printStackTrace();} 
			
			mi = (JMenuItem) menu.add(new JMenuItem(resource.getString("jprojectlist.clone")));
			mi.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				DefaultMutableTreeNode node = (DefaultMutableTreeNode)tree.getLastSelectedPathComponent();
				cloneProject(node.getUserObject().toString());
			}
			});
		
			mi = (JMenuItem) menu.add(new JMenuItem(resource.getString("jprojectlist.inst")));
			mi.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				DefaultMutableTreeNode node = (DefaultMutableTreeNode)tree.getLastSelectedPathComponent();
				instantiateProject(node.getUserObject().toString());
			}
			});

			mi = (JMenuItem) menu.add(new JMenuItem(resource.getString("jprojectlist.details")));
			mi.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				DefaultMutableTreeNode node = (DefaultMutableTreeNode)tree.getLastSelectedPathComponent();
				BrowserControl.displayURL(java.lang.System.getProperty("bonita.host")
						+ "/bonita/protected/Action.jsp?projectname="
						+ node.getUserObject().toString());
			}
			});
			
			mi = (JMenuItem) menu.add(new JMenuItem(resource.getString("jprojectlist.terminate")));
			mi.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				DefaultMutableTreeNode node = (DefaultMutableTreeNode)tree.getLastSelectedPathComponent();
				terminateProject(node.getUserObject().toString());
			}
			});

			mi = (JMenuItem) menu.add(new JMenuItem(resource.getString("jprojectlist.delete")));
			mi.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				DefaultMutableTreeNode node = (DefaultMutableTreeNode)tree.getLastSelectedPathComponent();
				deleteProject(node.getUserObject().toString());
			}
			});
		}
	}

	public void deleteProject(String project) {
		try {
			int option = JOptionPane.showConfirmDialog(null,resource.getString("jprojectlist.deleteproject"),resource.getString("jprojectlist.delete"),JOptionPane.OK_CANCEL_OPTION,JOptionPane.QUESTION_MESSAGE,icon);
			if (option == JOptionPane.OK_OPTION) {
				if (soapclient.deleteProject(project) == true)
					JOptionPane.showMessageDialog(null,resource.getString("jprojectlist.proj") + project + " " +resource.getString("jprojectlist.remove"),resource.getString("jprojectlist.delete"),JOptionPane.INFORMATION_MESSAGE,icon);
			}
		} catch (Exception e) {
			JOptionPane.showMessageDialog(null,e.getMessage(), resource.getString("jprojectlist.delete"),JOptionPane.INFORMATION_MESSAGE,icon);
		}
	}

	public void cloneProject(String project) {
		try {
			String newProject =	(String)JOptionPane.showInputDialog(null,resource.getString("jprojectlist.name"),resource.getString("jprojectlist.clone"),JOptionPane.QUESTION_MESSAGE,icon,null,null);
					
			while (newProject != null && newProject.equals("")) {
				JOptionPane.showMessageDialog(null,resource.getString("jprojectlist.enternew"),resource.getString("jprojectlist.clone"),JOptionPane.INFORMATION_MESSAGE,icon);
				newProject =(String) JOptionPane.showInputDialog(null,resource.getString("jprojectlist.name"),resource.getString("jprojectlist.clone"),JOptionPane.INFORMATION_MESSAGE,icon,null,null);
			}
			if (newProject != null)
				soapclient.cloneProject(project, newProject);

		} catch (Exception e) {
			JOptionPane.showMessageDialog(null,resource.getString("jprojectlist.exist"),resource.getString("jprojectlist.clone"),JOptionPane.INFORMATION_MESSAGE,icon);
		}
	}
	public void setStatus(String project) {
		try {
			String type = this.getProjectType(project);
			if (project.matches(".*_instance.*"))
				soapclient.initProject(project);
			else
			{
				if (type.equals(Constants.Pj.MODEL))
					soapclient.initModel(project);
				else
					soapclient.initProject(project);
			}
			soapclient.setStatus(newStatus);
		} catch (Exception e) {
			JOptionPane.showMessageDialog(null,resource.getString("jprojectlist.status"),resource.getString("jprojectlist.clone"),JOptionPane.INFORMATION_MESSAGE,icon);
		}
	}	
	public void instantiateProject(String project) {
		try {
			soapclient.instantiateProject(project);
		} catch (Exception e) {
			JOptionPane.showMessageDialog(null,resource.getString("jprojectlist.inst.error")+", "+e.getMessage(),resource.getString("jprojectlist.inst"),JOptionPane.INFORMATION_MESSAGE,icon);
		}
	}
	
	public void terminateProject(String project) {
		try {
			soapclient.terminateProject(project);
		} catch (Exception e) {
			JOptionPane.showMessageDialog(null,resource.getString("jprojectlist.term.error") +": "+ e.getMessage(),resource.getString("jprojectlist.inst"),JOptionPane.INFORMATION_MESSAGE,icon);
		}
	}

	public void changeEvent(Object[] e, String projectName) {
		DefaultMutableTreeNode node = this.findParent(projectName);
		if (node != null)
		{
			// Remove node; if node has descendants, all descendants are removed as well
			treeModel.removeNodeFromParent(node);
			this.actualProjects.remove(projectName);
		}
	} 

	public void addElement(String projectName) {
		if (!exists(projectName)){
			this.addObject(projectName);	
		}
	}
	
	public void addObject(String child) {
		 int startRow = 0;
		 String prefix = null;
		 // Find the parent project.
		 if (child.matches(".*_instance.*"))
		 	prefix = child.substring(0,child.indexOf("_instance"));
		 else
		 	prefix = resource.getString("jprojectlist.project");
		 DefaultMutableTreeNode nd = this.findParent(prefix);
		 MutableTreeNode node;
		 if (nd !=null)
		    node = nd;
		 else
		 {
		 	treeModel.insertNodeInto(new DefaultMutableTreeNode(this.getModel(child)), top, top.getChildCount());
			actualProjects.add(this.getModel(child));
			node = this.findParent(prefix);
		 }
		    
		 // Create new node
		 MutableTreeNode newNode = new DefaultMutableTreeNode(child);
    
		 // Insert new node as last child of node
		 treeModel.insertNodeInto(newNode, node, node.getChildCount());
		 actualProjects.add(child);
	}
	
	public void propertyChange(PropertyChangeEvent e) {
		try {
			if (e.getPropertyName().equals(PROJECTCLOSE)) {
				projects.remove(e.getNewValue());
			}
		} catch (Exception e1) {
			e1.printStackTrace();
		}
	}
	
	private void createNodes(Collection iniProj) throws Exception{
		DefaultMutableTreeNode project = null;
		DefaultMutableTreeNode instance = null;
    	    	
		Collection instances = soapclient.getInstances();
    	Iterator inst = instances.iterator();
		while (inst.hasNext())
		{
			String instName = (String)inst.next();
			if (!iniProj.contains(this.getModel(instName)))
				iniProj.add(this.getModel(instName));
		}
		
		Iterator i = iniProj.iterator();
		while (i.hasNext())
		{
			String projectName = (String)i.next();
			project = new DefaultMutableTreeNode(projectName);	
			top.add(project);
		}
					
		Iterator pInst = instances.iterator();
		while (pInst.hasNext())
		{
			String instName = (String)pInst.next();
			(this.findParent(this.getModel(instName))).add(new DefaultMutableTreeNode(instName));
		}
		this.actualProjects.addAll(instances);
	}

    private DefaultMutableTreeNode findParent (String parent) {
    	DefaultMutableTreeNode root = (DefaultMutableTreeNode)treeModel.getRoot();
    	DefaultMutableTreeNode node = null;
    	if (root != null)    
    		for (Enumeration e = root.breadthFirstEnumeration(); e.hasMoreElements();){
    			DefaultMutableTreeNode current = (DefaultMutableTreeNode)e.nextElement(); 
    			if (parent.equals(current.getUserObject()))    
    			{
    				node = current;  
    				break;     
    			}    
    		}if (node != null){// found}
    			return node;
    		}
    		return null;
    }
	
	// Get the name of the project model of this instance       
	private String getModel(String instanceName) {
		int i = instanceName.indexOf("_instance");
		return (instanceName.substring(0, i));
	}
	
	public Collection getActualProjects ()
	{
		return this.actualProjects;
	}

	// Rest of mouse listener is empty
	public void mousePressed(MouseEvent e) {
	}
	public void mouseEntered(MouseEvent e) {
	}
	public void mouseExited(MouseEvent e) {
	}
	public void mouseClicked(MouseEvent e) {
	}

}
