package hero.client.manager;

/*
*
* JTodoList.java - 
* Copyright (C) 2003 Ecoo Team
* valdes@loria.fr
* 
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

import hero.interfaces.Constants;
import hero.util.BonitaClient;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.util.Iterator;
import java.util.Collection;
import java.util.Enumeration;
import java.util.ArrayList;

import javax.swing.DefaultListModel;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JPopupMenu;
import javax.swing.JScrollPane;
import javax.swing.ImageIcon;

public class JTodoList extends JPanel implements PropertyChangeListener, MouseListener, Constants.Nd {

static java.util.ResourceBundle resource = java.util.ResourceBundle.getBundle("resources.Traduction")/*#BundleType=List*/;

	private BonitaClient soapclient;
	private DefaultListModel model;
	private JList todoList;
	private String project = null;
	MListener ml;
	public final static String imageBase = "images/";
	public final static ImageIcon icon = new ImageIcon(Thread.currentThread().getContextClassLoader().getResource(imageBase + "icon.png"));

	public JTodoList(BonitaClient soapclient, MListener ml) {
		try {
			this.soapclient = soapclient;
			ml.addEventTodoListener(this);

			model = new DefaultListModel();
			todoList = new JList(model);
			todoList.setCellRenderer(new ManagerCellRenderer());

			JScrollPane jsptdl = new JScrollPane(todoList);

			JPanel p = new JPanel();
			p.setLayout(new FlowLayout());
			p.setBackground(new Color(177,177,251));

			this.setLayout(new BorderLayout());
			this.setBackground(new Color(177,177,251));
			this.add(new JLabel(resource.getString("jtodolist.todo")), BorderLayout.NORTH);
			this.add(jsptdl, BorderLayout.CENTER);
			this.add(p, BorderLayout.SOUTH);
  		    
			todoList.addMouseListener(this);
		} catch (Exception e) {
			JOptionPane.showMessageDialog(null,resource.getString("jtodolist.error"),resource.getString("jtodolist.inerror"),JOptionPane.INFORMATION_MESSAGE,icon);
		}
	}

	public void mouseReleased(MouseEvent e) {
		try {
			// Popup Menu
			if ((e.getModifiers() & java.awt.event.InputEvent.BUTTON3_MASK) != 0) {
				//		if (todoList.getSelectedValue() != null)
				//	{
				JPopupMenu menu = new JPopupMenu();
				PopupMenu(menu);

				Dimension screen = Toolkit.getDefaultToolkit().getScreenSize();
				Dimension size = menu.getPreferredSize();

				// Flip along screen
				int x = e.getX();
				int y = e.getY();

				menu.show(this, x, y);
				//}
			} else if (e.getClickCount() == 2)
				try {
					BrowserControl.displayURL(java.lang.System.getProperty("bonita.host")+ "/bonita/protected/Action.jsp?projectname="
							+ project
							+ "&nodename="
							+ ((ListItem) todoList.getSelectedValue()).getValue());
				} catch (Exception ex) {
				}
		} catch (Exception ex) {
		};
	}

	public void PopupMenu(JPopupMenu menu) {
		JMenuItem mi;
		ClassLoader cl = this.getClass().getClassLoader();

		if (todoList.getSelectedIndex() != -1) {
			mi = (JMenuItem) menu.add(new JMenuItem(resource.getString("jtodolist.start")));
			mi.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					start();
				}
			});

			mi = (JMenuItem) menu.add(new JMenuItem(resource.getString("jtodolist.details")));
			mi.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					BrowserControl.displayURL(java.lang.System.getProperty("bonita.host")
							+ "/bonita/protected/Action.jsp?projectname="
							+ project
							+ "&nodename="
							+ ((ListItem) todoList.getSelectedValue()).getValue());
				}
			});
		}
	}

	void start() {
		try {
			if (project != null)
				soapclient.startActivity(project, ((ListItem) todoList.getSelectedValue()).getValue());
		} catch (Exception start) {
			JOptionPane.showMessageDialog(null,resource.getString("jtodolist.starterror")+start.getMessage(),resource.getString("jtodolist.start"),JOptionPane.INFORMATION_MESSAGE,icon);			
		}
	}

	public void propertyChange(PropertyChangeEvent e) {
		try {			
			if (e.getPropertyName().equals(JProjectList.SELECTED)) {
				model.clear();
				this.project = (String) e.getNewValue();

				Collection toDo = soapclient.getToDoList(project);
				Iterator i = toDo.iterator();

				while (i.hasNext()) {
					String node = (String) i.next();
					ListItem li = new ListItem(getColor(node), node);
					model.addElement(li);
				}
			}
		} catch (Exception e1) {
			e1.printStackTrace();
		}
	}

	public Color getColor(String name) throws Exception {
		soapclient.openProject(project);
		int state = soapclient.getNodeState(name);        
		switch (state) {
			case READY :
				return (Color.yellow);
			case ANTICIPABLE :
				return (Color.green);
		}
		return (Color.white);
	}

	public void changeEvent(Object[] e, String projectName) {
		try {
			if (projectName.equals(project)) {
				model.clear();
				int i = 0;
				for (i = 0; i < e.length; i++) {
					ListItem li = new ListItem(getColor(e[i].toString()), e[i].toString());
					model.addElement(li);
				}	
			}	
			
		} catch	(Exception ex) {
		}
	}
	
	public boolean isChanged(Object[] elements) {
		Collection listElements = new ArrayList();
		
	     for (Enumeration e = model.elements() ; e.hasMoreElements() ;) {
	         ListItem li = (ListItem)e.nextElement();
	         listElements.add(li.getValue());
	     }
	     Collection newElements = java.util.Arrays.asList(elements);
	     if (listElements.containsAll(newElements))
		 	return false;
		 return true;
	}
	
	// Rest of mouse listener is empty
	public void mousePressed(MouseEvent e) {
	}
	public void mouseEntered(MouseEvent e) {
	}
	public void mouseExited(MouseEvent e) {
	}
	public void mouseClicked(MouseEvent e) {
	}

}


