package hero.client.manager;

/*
*
* MListener.java - 
* Copyright (C) 2003 Ecoo Team
* valdes@loria.fr
* 
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

import hero.interfaces.Constants;
import hero.util.EventConstants;
import hero.client.events.JMSServicesClient;
import hero.util.BonitaClient;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Hashtable;

import javax.jms.Message;
import javax.jms.MessageListener;

public class MListener
	implements MessageListener, Constants.Nd, EventConstants {

	ArrayList projectListener = new ArrayList();
	ArrayList todoListener = new ArrayList();
	ArrayList activityListener = new ArrayList();

	Collection projectele;
	Collection todoele;
	Collection activityele;

	BonitaClient soapclient;
	String actualproject = "nullproject";
	String userName = null;

	private static MListener mjms = null; // Singleton pattern

	public MListener(String userName, String userPassword, String host, int port) {
		try {
        	soapclient = new BonitaClient(host, port, "/bonita_ws/services/");
			soapclient.login(userName, userPassword);
			this.userName = userName;
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	public static MListener getInstance(String userName, String userPassword, String host, int port) {
		if (mjms == null) {
			mjms = new MListener(userName, userPassword, host, port);
		}
		return mjms;
	}

	public void subscription(String subs) throws Exception {
		//JMSServicesClient jms = JMSServicesClient.getInstance();
		JMSServicesClient jms = new JMSServicesClient();
		jms.createSubscription(this, subs);
	}

	public void addEventProjectListener(JProjectList list) {
		projectListener.add(list);
	}

	public void removeEventProjectListener(JProjectList list) {
		int index = projectListener.indexOf(list);
		projectListener.remove(index);
	}

	public void addEventTodoListener(JTodoList list) {
		todoListener.add(list);
	}

	public void removeEventTodoListener(JTodoList list) {
		int index = todoListener.indexOf(list);
		todoListener.remove(index);
	}

	public void addEventActivityListener(JActivityList list) {
		activityListener.add(list);
	}

	public void removeEventActivityListener(JActivityList list) {
		int index = activityListener.indexOf(list);
		activityListener.remove(index);
	}

	public void onMessage(Message message) {
		try {
			Hashtable evt = JMSServicesClient.getEvt(message);
			
			String type = (String) evt.get(EVENT);
			if (type.equals(EventConstants.START)
				|| type.equals(EventConstants.TERMINATED)
				|| type.equals(EventConstants.CANCELED)
				|| type.equals(EventConstants.ANTICIPATING)
				|| type.equals(CHANGEROLE)) {

				Collection todoele = soapclient.getToDoList((String) evt.get(PROJECTNAME));
				Collection activityele = soapclient.getActivityList((String) evt.get(PROJECTNAME));
	
				try {
					int i = 0;
					for (i = 0; i < todoListener.size(); i++)
						((JTodoList) todoListener.get(i)).changeEvent(todoele.toArray(),(String) evt.get(PROJECTNAME));

					for (i = 0; i < activityListener.size(); i++)
						((JActivityList) activityListener.get(i)).changeEvent(activityele.toArray(),(String) evt.get(PROJECTNAME));

				} catch (Exception e) {

				}
			} else if (
				(type.equals(DELETENODE)
					&& ((new Integer((String) evt.get(NODESTATE))).intValue()== READY
						|| (new Integer((String) evt.get(NODESTATE))).intValue()== ANTICIPABLE))
					|| type.equals(READYINITIAL)
					|| type.equals(ADDEDGE)
					|| type.equals(DELETEEDGE)
					|| type.equals(SETUSERROLE)) {
				Collection todoele = soapclient.getToDoList((String) evt.get(PROJECTNAME));

				try {
					int i = 0;
					for (i = 0; i < todoListener.size(); i++)
					{
						if (((JTodoList) todoListener.get(i)).isChanged(todoele.toArray()))
						  ((JTodoList) todoListener.get(i)).changeEvent(todoele.toArray(),(String) evt.get(PROJECTNAME));
					}

				} catch (Exception exmu) {
					exmu.printStackTrace();
				}

			} else if (type.equals(ADDNODE)) {
				Collection todoele = soapclient.getToDoList((String) evt.get(PROJECTNAME));

				try {
					int i = 0;
					for (i = 0; i < todoListener.size(); i++)
					{
						if (((JTodoList) todoListener.get(i)).isChanged(todoele.toArray()))
						((JTodoList) todoListener.get(i)).changeEvent(todoele.toArray(),(String) evt.get(PROJECTNAME));
					}

				} catch (Exception exaddnode) {
					exaddnode.printStackTrace();
				}
			} else if (type.equals(ADDUSERPROJECT)) {
				try {
					int i = 0;
					for (i = 0; i < projectListener.size(); i++) {
						if (((String) evt.get(USERNAME)).equals(userName)) {							
							((JProjectList) projectListener.get(i)).addElement((String) evt.get(PROJECTNAME));
							this.subscription(" projectName = '"+ (String) evt.get(PROJECTNAME)+ "'");
						}
					}

				} catch (Exception exadduser) {
					exadduser.printStackTrace();
				}
			} else if (type.equals(DELETEPROJECT)) {
				try {
					int i = 0; 
					// Remove project from the project list and dispose the frame if exists.
					for (i = 0; i < projectListener.size(); i++) {
						((JProjectList) projectListener.get(i)).changeEvent(new Object[]{},(String) evt.get(PROJECTNAME));
						hero.client.grapheditor.Frame projectFrame = (hero.client.grapheditor.Frame)((JProjectList) projectListener.get(i)).projects.get(evt.get(PROJECTNAME));
						if (projectFrame != null)
							projectFrame.dispose();
						((JProjectList) projectListener.get(i)).projects.remove(evt.get(PROJECTNAME));
						((JTodoList) todoListener.get(i)).changeEvent(new Object[]{},(String) evt.get(PROJECTNAME));
						((JActivityList) activityListener.get(i)).changeEvent(new Object[]{},(String) evt.get(PROJECTNAME));
					}
				} catch (Exception exadduser) {
					exadduser.printStackTrace();
				}
			}
		} catch (Exception jmse) {
		}

	}
}
