package hero.client.manager;

/*
*
* ManagerCellRenderer.java - 
* Copyright (C) 2002 Ecoo Team
* valdes@loria.fr
* 
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/


import java.awt.Color;
import java.awt.Component;

import javax.swing.BorderFactory;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.ListCellRenderer;

class ManagerCellRenderer extends JLabel implements ListCellRenderer {
    
    public ManagerCellRenderer () {
	// Don't paint behind the component
	setOpaque(true);
    }
    
    // Set the attributes of the 
    //class and return a reference
    public Component getListCellRendererComponent(JList list,
						  Object value, // value to display
						  int index,    // cell index
						  boolean iss,  // is selected
						  boolean chf)  // cell has focus?
	{
	    // Set the text and color 
	    //background for rendering
	    setText(((ListItem)value).getValue());
	    setBackground(((ListItem)value).getColor());
	    
	    // Set a border if the list 
	    //item is selected 
            if (iss) {
                setBorder(
			  BorderFactory.createLineBorder(Color.blue, 2));
            } else {
                setBorder(
			  BorderFactory.createLineBorder(list.getBackground(), 2));
            }
	    return this;
        }
}
