package hero.client.manager;

/*
*
* Menubar.java - 
* Copyright (C) 2002 Ecoo Team
* valdes@loria.fr
* 
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.Color;

import javax.swing.ImageIcon;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;

public class Menubar extends JMenuBar {

static java.util.ResourceBundle resource = java.util.ResourceBundle.getBundle("resources.Traduction")/*#BundleType=List*/;

  public Menubar(final Manager m) {
    ClassLoader cl = m.getClass().getClassLoader();

    JMenu menu;
    JMenuItem mi;

    menu = new JMenu(resource.getString("menubar.manager"));
	menu.setBackground(new Color(153, 153, 255));
    add(menu);

    // New
    mi = new JMenuItem(new ImageIcon(cl.getResource("images/new.png")));
    mi.setText(resource.getString("menubar.newproj"));
	mi.setBackground(new Color(153, 153, 255));
    mi.addActionListener (new ActionListener () {
	    public void actionPerformed (ActionEvent e) {
		m.NewProject();
	    }
	});
    menu.add(mi);
    
    // Clone
    mi = new JMenuItem(new ImageIcon(cl.getResource("images/Copy.gif")));
    mi.setText(resource.getString("menubar.cloneproj"));
	mi.setBackground(new Color(153, 153, 255));
    mi.addActionListener (new ActionListener () {
	    public void actionPerformed (ActionEvent e) {
		m.CloneProject();
	    }
	});
    menu.add(mi);
    
    // Instantiate
	 mi = new JMenuItem(new ImageIcon(cl.getResource("images/Copy.gif")));
	 mi.setText(resource.getString("menubar.instproj"));
	 mi.setBackground(new Color(153, 153, 255));
	 mi.addActionListener (new ActionListener () {
		 public void actionPerformed (ActionEvent e) {
		 m.InstantiateProject();
		 }
	 });
	 menu.add(mi);

    menu.addSeparator();

    mi = new JMenuItem(resource.getString("menubar.exit"));
    mi.setIcon(new ImageIcon(cl.getResource("images/exit.png")));
	mi.setBackground(new Color(153, 153, 255));
    mi.addActionListener (new ActionListener () {
	  public void actionPerformed (ActionEvent e) {
	  try {
	      //	      JMSServices jms = JMSServices.getInstance();
	      //	      jms.closeConnection();
	      System.exit(0);
	  }catch(Exception ex){}
      }
    });
    menu.add(mi);
  }
}
