/**
 *
 * Bonita
 * Copyright (C) 1999 Bull S.A.
 * Bull 68 route de versailles  78434 Louveciennes Cedex France
 * Further information: bonita@objectweb.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 *
--------------------------------------------------------------------------
 * $Id: DeadlinesFixedTimesJavaHook.java,v 1.1 2005/01/31 12:14:22 mvaldes Exp $
 *
--------------------------------------------------------------------------
 */

package hero.client.samples;

import java.util.ArrayList;

import javax.security.auth.login.LoginContext;
import hero.client.test.SimpleCallbackHandler;

import hero.interfaces.Constants;
import hero.interfaces.ProjectSession;
import hero.interfaces.ProjectSessionHome;
import hero.interfaces.ProjectSessionUtil;

import hero.interfaces.UserSession;
import hero.interfaces.UserSessionHome;
import hero.interfaces.UserSessionUtil;

public class DeadlinesFixedTimesJavaHook {
	
	static public void main(String[] args) throws Exception{
		// Admin login
		char[] password={'t','o','t','o'};
		SimpleCallbackHandler handler = new SimpleCallbackHandler("admin",password);
		LoginContext lc = new LoginContext("TestClient", handler);
		lc.login();
		
		ProjectSessionHome projectSessionh=ProjectSessionUtil.getHome();
		UserSessionHome usersh=UserSessionUtil.getHome();
		UserSession usr=usersh.create();
		
		ProjectSession pss=projectSessionh.create();
		pss.initModel("LoadJavaHookFixed");
		
		pss.addNode("node1",Constants.Nd.AND_JOIN_NODE);
		pss.setNodeRole("node1","admin");		
		pss.addNode("node2",Constants.Nd.AND_JOIN_NODE);
		pss.addEdge("node1","node2");
			
		// set absolute collection of deadlines	
		ArrayList ar = new ArrayList();
		long date1 = System.currentTimeMillis()+(long)60000;
		long date2= System.currentTimeMillis()+(long)80000;
		ar.add(new Long(date1));
		ar.add(new Long(date2));
		pss.setNodeDeadlines("node1",ar);	
				
		pss.addNodeHook("node1","hero.hook.TestDeadlines",hero.interfaces.Constants.Nd.ONDEADLINE,Constants.Hook.JAVA);
		
		String instName=pss.instantiateProject("LoadJavaHookFixed");
		
		usr.startActivity(instName,"node1");
		
		System.out.println("Wait about 60 sec until the Fixed Deadlines hooks are executed...");
	}
}


