/**
 *
 * Bonita
 * Copyright (C) 1999 Bull S.A.
 * Bull 68 route de versailles  78434 Louveciennes Cedex France
 * Further information: bonita@objectweb.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 *
--------------------------------------------------------------------------
 * $Id: DeployedEntities.java,v 1.3 2005/08/29 13:39:05 mvaldes Exp $
 *
--------------------------------------------------------------------------
 */

package hero.client.samples;

import java.util.Collection;
import java.util.Iterator;

import javax.security.auth.login.LoginContext;
import hero.client.test.SimpleCallbackHandler;

import hero.interfaces.Constants;

import hero.interfaces.AdminSession;
import hero.interfaces.AdminSessionHome;
import hero.interfaces.AdminSessionUtil;

public class DeployedEntities {
	
	static public void main(String[] args) throws Exception{
		// Admin login
		char[] password={'t','o','t','o'};
		SimpleCallbackHandler handler = new SimpleCallbackHandler("admin",password);
		LoginContext lc = new LoginContext("TestClient", handler);
		lc.login();
		
		AdminSessionHome ah=AdminSessionUtil.getHome();
		AdminSession as = ah.create();
		
		// Hooks list
		Collection hooks=as.getJavaHooks(Constants.Nd.BEFORESTART);
		Iterator i = hooks.iterator();
		while (i.hasNext())
			System.out.println("HookName, BeforeStart = "+i.next());

		hooks=as.getJavaHooks(Constants.Nd.AFTERSTART);
		i = hooks.iterator();
		while (i.hasNext())
			System.out.println("HookName, Aftertart = "+i.next());

		hooks=as.getJavaHooks(Constants.Nd.ONDEADLINE);
		i = hooks.iterator();
		while (i.hasNext())
			System.out.println("HookName, OnDeadline = "+i.next());

		hooks=as.getJavaHooks(Constants.Pj.ONINSTANTIATE);
		i = hooks.iterator();
		while (i.hasNext())
			System.out.println("HookName, OnInstantiate = "+i.next());


		// Mapper list
		Collection mappers=as.getCustomMappers();
		i = mappers.iterator();
		while (i.hasNext())
			System.out.println("MapperName = "+i.next());
		
		// Performer assignments list
		Collection performers=as.getCallbackPerformers();
		i = performers.iterator();
		while (i.hasNext())
			System.out.println("PerformerName = "+i.next());							

		// Performer assignments list
		Collection initiators=as.getCustomInitiators();
		i = initiators.iterator();
		while (i.hasNext())
			System.out.println("InitiatorName = "+i.next());							

		
	}
}


