/**
 *
 * Bonita
 * Copyright (C) 1999 Bull S.A.
 * Bull 68 route de versailles  78434 Louveciennes Cedex France
 * Further information: bonita@objectweb.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 *
--------------------------------------------------------------------------
 * $Id: Inscription.java,v 1.3 2004/11/10 17:10:50 mvaldes Exp $
 *
--------------------------------------------------------------------------
 */

package hero.client.samples;

import javax.security.auth.login.LoginContext;
import hero.client.test.SimpleCallbackHandler;

import hero.interfaces.ProjectSession;
import hero.interfaces.ProjectSessionHome;
import hero.interfaces.ProjectSessionUtil;

import hero.interfaces.UserSession;
import hero.interfaces.UserSessionHome;
import hero.interfaces.UserSessionUtil;

import hero.interfaces.UserRegistration;
import hero.interfaces.UserRegistrationHome;
import hero.interfaces.UserRegistrationUtil;

import java.util.*;

public class Inscription {
	
	static public void main(String[] args) throws Exception{
	  // Admin login
	  char[] password={'t','o','t','o'};
	  SimpleCallbackHandler handler = new SimpleCallbackHandler("admin",password);
	  LoginContext lc = new LoginContext("TestClient", handler);
	  lc.login();
		  
	  // Project Session interface instantiation (for admin user)
	  ProjectSessionHome lHome=ProjectSessionUtil.getHome();
	  ProjectSession lProject = lHome.create();
	  String instName = lProject.instantiateProject("e-citizen");
	  
	  // "user1" (e-citizen) creation in Bonita database
	  UserRegistrationHome urHome = UserRegistrationUtil.getHome();
	  UserRegistration userReg=urHome.create();
	  try{
	     userReg.userCreate("user1","user1","miguel.valdes-faura@ext.bull.net");
	  }catch(Exception e){} // Maybe user exists 
	  userReg.remove();
	  
	  // "agent1" creation in Bonita database
	  urHome = UserRegistrationUtil.getHome();
	  userReg=urHome.create();
	  try{
	     userReg.userCreate("agent1","agent1","miguel.valdes-faura@ext.bull.net");
	  }catch(Exception e){} // Maybe user exists 
	  userReg.remove();
	  
	  // admin user adds "user1" (e-citizen) to this workflow instance
	  lProject.addUser("user1");
	  lProject.addUser("agent1");
      // admin user adds "InitialRole" to "user1" (e-citizen) for this instance
	  lProject.setUserRole("user1","InitialRole");
	  // admin user adds "agent" role to "agent1" (Agent) for this instance
	  lProject.setUserRole("agent1","agent");
	  // admin user adds "user1" process properties
	  lProject.setProperty("userId","user1");
	  lProject.setProperty("recordId","1111");
	  lProject.setProperty("orderId","0001");
	  	  
	  // "user1" is logged
	  char[] password2={'u','s','e','r','1'};
	  handler = new SimpleCallbackHandler("user1",password2);
	  lc = new LoginContext("TestClient", handler);
	  lc.login();
	  
	  // user1 creates User Session Bean  
	  UserSessionHome uHome=UserSessionUtil.getHome();
	  UserSession uSession = uHome.create();
	  Collection nodes = uSession.getToDoList(instName);
	  Iterator i = nodes.iterator();
	  while (i.hasNext())
	  {
	  	String activityName = (String)i.next();
	  	uSession.startActivity(instName,activityName);
	  	System.out.println("Start application activity... wait for termination");
		uSession.terminateActivity(instName,activityName);
		System.out.println("Terminate activity");
	  }
	  
	  // "agent1" is logged
	  char[] password3={'a','g','e','n','t','1'};
	  handler = new SimpleCallbackHandler("agent1",password3);
	  lc = new LoginContext("TestClient", handler);
	  lc.login();
	  
	  // agent1 creates User Session Bean  
	  uHome=UserSessionUtil.getHome();
	  UserSession aSession = uHome.create();
	  nodes = aSession.getToDoList(instName);
	  i = nodes.iterator();
	  while (i.hasNext())
	  {
		String activityName = (String)i.next();
		//	The user data is not correct...
		ProjectSessionHome lHomeAgent1=ProjectSessionUtil.getHome();
		ProjectSession lProjectAgent1 = lHome.create();
		lProjectAgent1.initProject(instName);
		
	    lProjectAgent1.setNodeProperty(activityName,"correct","nok");
		aSession.startActivity(instName,activityName);
		System.out.println("Start application activity... wait for termination");
		aSession.terminateActivity(instName,activityName);
		System.out.println("Terminate activity");
	  }
	}
}


