/**
 *
 * Bonita
 * Copyright (C) 1999 Bull S.A.
 * Bull 68 route de versailles  78434 Louveciennes Cedex France
 * Further information: bonita@objectweb.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 *
--------------------------------------------------------------------------
 * $Id: LoadReadyHook.java,v 1.2 2005/03/30 15:16:56 mvaldes Exp $
 *
--------------------------------------------------------------------------
 */

package hero.client.samples;

import javax.security.auth.login.LoginContext;

import hero.client.test.SimpleCallbackHandler;

import hero.interfaces.Constants;
import hero.interfaces.ProjectSession;
import hero.interfaces.ProjectSessionHome;
import hero.interfaces.ProjectSessionUtil;

import hero.interfaces.UserSession;
import hero.interfaces.UserSessionHome;
import hero.interfaces.UserSessionUtil;

public class LoadReadyHook {
	
	static public void main(String[] args) throws Exception{
		// Admin login
		char[] password={'t','o','t','o'};
		SimpleCallbackHandler handler = new SimpleCallbackHandler("admin",password);
		LoginContext lc = new LoginContext("TestClient", handler);
		lc.login();
		
		ProjectSessionHome projectSessionh=ProjectSessionUtil.getHome();
		UserSessionHome usersh=UserSessionUtil.getHome();
		UserSession usr=usersh.create();
		
		ProjectSession pss=projectSessionh.create();
		pss.initModel("LoadReadyHook");
		
		pss.addNode("node1",Constants.Nd.AND_JOIN_NODE);
		pss.setNodeRole("node1","admin");
		pss.addNode("node2",Constants.Nd.AND_JOIN_NODE);
		pss.setNodeTraditional("node2");
		pss.setNodeRole("node2","admin");
		pss.addEdge("node1","node2");	
		pss.addNodeHook("node2","hero.hook.TestReady",hero.interfaces.Constants.Nd.ONREADY,Constants.Hook.JAVA);			
		
		String instance = pss.instantiateProject("LoadReadyHook");
		usr.startActivity(instance,"node1");
		usr.terminateActivity(instance,"node1");					
	}
}


