/**
 *
 * Bonita
 * Copyright (C) 1999 Bull S.A.
 * Bull 68 route de versailles  78434 Louveciennes Cedex France
 * Further information: bonita@objectweb.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 *
--------------------------------------------------------------------------
 * $Id: Sample1AdminWF.java,v 1.3 2005/03/18 14:50:41 mvaldes Exp $
 *
--------------------------------------------------------------------------
 */

package hero.client.samples;

import javax.security.auth.login.LoginContext;
import hero.client.test.SimpleCallbackHandler;

import hero.interfaces.ProjectSession;
import hero.interfaces.ProjectSessionHome;
import hero.interfaces.ProjectSessionUtil;

import hero.interfaces.UserSession;
import hero.interfaces.UserSessionHome;
import hero.interfaces.UserSessionUtil;

import hero.interfaces.UserRegistration;
import hero.interfaces.UserRegistrationHome;
import hero.interfaces.UserRegistrationUtil;

import java.util.*;

public class Sample1AdminWF{
	
	static public void main(String[] args) throws Exception{
	  // Admin login
	  char[] password={'t','o','t','o'};
	  SimpleCallbackHandler handler = new SimpleCallbackHandler("admin",password);
	  LoginContext lc = new LoginContext("TestClient", handler);
	  lc.login();	  
	  	  
	  // User registration interface creation
	  UserRegistrationHome urHome = UserRegistrationUtil.getHome();
	  UserRegistration userReg=urHome.create();
	  
	  // User "jack" (customer) creation in Bonita database
	  try{
	     userReg.userCreate("jack","jack","miguel.valdes-faura@ext.bull.net");
	  }catch(Exception e){System.out.println(e) ;} // Maybe user exists 

	  
	  // User "john" (service customer) creation in Bonita database
	  try{
	     userReg.userCreate("john","john","miguel.valdes-faura@ext.bull.net");
	  }catch(Exception e){System.out.println(e) ;} // Maybe user exists 
	  
	  userReg.remove();
	  
	  // Project Session interface instantiation (for admin user)
	  // And user registration in Order Processing Project instance
	  ProjectSessionHome prjSessionHome=ProjectSessionUtil.getHome();
	  ProjectSession prjSession = prjSessionHome.create();
	  
	  try {
	  String instName = prjSession.instantiateProject("Order Processing");
	  }catch(Exception e){System.out.println(e) ;} // Maybe project does not exists 
	  
	  // User Session interface instanciation (for admin user)
	  // and User registration in "Accept Order" Project instance
	  // For this we need to get the Accpet Order instance
	  UserSessionHome usHome=UserSessionUtil.getHome();
	  UserSession uSession = usHome.create();
	  
	  try {
	  Collection names = uSession.getProjectInstancesNames("Order Processing");
	  Iterator i = names.iterator() ;
      prjSession.initProject((String) i.next());
      	  
	  // admin user adds "jack" (customer) and "john" (customer service) to this workflow instance
	  prjSession.addUser("jack");
	  prjSession.addUser("john");
	  	       
          // admin user sets "customer" role to "miguel"  for this instance
	  prjSession.setUserRole("jack","customer");
	  // admin user sets "agent" role to "john" (Customer Service) for this instance
	  prjSession.setUserRole("john","agent");
	  
	 //}
	}catch(Exception e){e.printStackTrace();} 
	 
	  prjSession.remove() ;	  
	}

	
}


