package hero.client.samples;


/*
*
* Inscription.java - 
* Copyright (C) 2004 Ecoo Team
* miguel.valdes-faura@ext.bull.net
* 
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

/* This class implements the third part of the Business Process example described in the 
*   "BONITA workflow cooperative System Users's Guide
* jack : Custumer 
* john : Custumer Service employee
*/


import javax.security.auth.login.LoginContext;
import hero.client.test.SimpleCallbackHandler;

import hero.interfaces.ProjectSession;
import hero.interfaces.ProjectSessionHome;
import hero.interfaces.ProjectSessionUtil;

import hero.interfaces.UserSession;
import hero.interfaces.UserSessionHome;
import hero.interfaces.UserSessionUtil;

import hero.interfaces.UserRegistration;
import hero.interfaces.UserRegistrationHome;
import hero.interfaces.UserRegistrationUtil;

import java.util.*;

public class Sample1RunningSession {
	
	static public void main(String[] args) throws Exception{
	
      // jackOrderProcessing  	  
	  // "jack" is logged
	  char[] passwordJack={'j','a','c','k'};
	  SimpleCallbackHandler handlerJack = new SimpleCallbackHandler("jack",passwordJack);
	  LoginContext lcJack = new LoginContext("TestClient", handlerJack);
	  lcJack.login();
	  
		  
	  // jack creates User Session Bean  (Activity running)
	  UserSessionHome userHome=UserSessionUtil.getHome();
	  UserSession userSession = userHome.create();
	  
	  Collection names = userSession.getProjectInstancesNames("Order Processing");
	  Iterator i = names.iterator() ;
  	  String instNameOP = (String) i.next();
	  
	  // ProjectSessionBean needed (Activity properties setting )
	  ProjectSessionHome prjHome=ProjectSessionUtil.getHome();
	  ProjectSession prjSession = prjHome.create();
	  
	  
	  System.out.println("SessionBean created");
	 	  
	 // Verifying roles
	 try {
	  	prjSession.initProject(instNameOP) ;
	 } catch(Exception e){System.out.println("initProject : exception raised") ;} 
	  	
	 try {
	 Collection roleNames = prjSession.getUserRolesInProject("jack") ;
	 Iterator j = roleNames.iterator();
	 while (j.hasNext())
	 { 
	 	System.out.println("user jack : rle : "+ j.next());
	 }
	} catch(Exception e){System.out.println("getUserRolesInProject : exception raised : " + e) ;} 
	
	
	// Activity to be started :  
	String activityName = "Receive Order" ;
	
	// etat de l'activit avant lancement 
	int state = 0 ;
	  try {
	  	state = prjSession.getNodeState(activityName);
	  } catch(Exception e){System.out.println("getNodeState : exception raised") ;} 
  
	  System.out.println("Verification : Node State : " + state);
	
	   
	  try {
	  	userSession.startActivity(instNameOP,activityName);
	  	System.out.println("(Jack) Activity started : "+ activityName);
	 } catch(Exception e){System.out.println("startActivity : exception raised : "+ e) ;} // Maybe instance or activity does not exists 
	  
	   
	  try {
	  	state = prjSession.getNodeState(activityName);
	  } catch(Exception e){System.out.println("getNodeState : exception raised") ;} 
  
	  System.out.println("Verification : Node State : " + state);
	

	 // Now He has to set the Order Data : setting the values for the properties associated to this activities
	 try {
	 	prjSession.setNodeProperty(activityName,"customer_name","jack",true) ;
	 	prjSession.setNodeProperty(activityName,"product_name","tv",true) ;
	 	prjSession.setNodeProperty(activityName,"items","1",true) ;
	 } catch(Exception e){System.out.println("setNodeProperty : exception raised : "+ e) ;} // maybe it raises some exception
	 
	 System.out.println("properties set");
	 
	 try {
	 Collection Properties = prjSession.getNodeProperties(activityName) ;
	 Iterator k = Properties.iterator();
	 while (k.hasNext())
	 { 
	 	System.out.println("Activity  "+ activityName +" property : "+ k.next());
	 }
	} catch(Exception e){System.out.println("getNodeProperties : exception raised : " + e) ;} 
	
	  
	   try {
	  	userSession.terminateActivity(instNameOP,activityName);
	  	System.out.println("(Jack) Activity terminated : " + activityName);
	 } catch(Exception e){System.out.println("terminateActivity : exception raised : "+ e) ;} // Maybe instance or activity does not exists 

// johnStartAcceptOrder
	  // "john" is logged
	  char[] passwordJohn ={'j','o','h','n'};
	  SimpleCallbackHandler handlerJohn = new SimpleCallbackHandler("john",passwordJohn);
	  LoginContext lcJohn = new LoginContext("TestClient", handlerJohn);
	  lcJohn.login();

  	  names = userSession.getProjectInstancesNames("Accept Order");
	  i = names.iterator() ;
	  String instNameAO = (String) i.next();;

// jackStartAskCustomer
	// Jack context
	lcJack.login();

	// Session bean already created
	  	  // Activity to be started :  
	activityName = "Ask Customer" ;
	  
	try {
	  	userSession.startActivity(instNameAO,activityName);
	  	System.out.println("(Jack) Activity started : "+ activityName);
	 } catch(Exception e){System.out.println("startActivity : exception raised : "+ e) ;} // Maybe instance or activity does not exists 
	  	  
	   try {
	  	userSession.terminateActivity(instNameAO,activityName);
	  	System.out.println("(Jack) Activity terminated : "+ activityName);
	 } catch(Exception e){System.out.println("terminateActivity : exception raised : "+ e) ;} // Maybe instance or activity does not exists 

	 //johnTermAcceptOrder
	 // John context
	 lcJohn.login();

	// Session bean already created
	
	// John starts and terminates "Notify Sales"
	activityName = "Notify Sales" ;
	try {
	  	userSession.startActivity(instNameAO,activityName);
	  	System.out.println("(John) Activity started : "+ activityName);
	 } catch(Exception e){System.out.println("startActivity : exception raised : "+ e) ;} // Maybe instance or activity does not exists 
	  	  
	 try {
	  	userSession.terminateActivity(instNameAO,activityName);
	  	System.out.println("(John) Activity terminated : "+ activityName);
	 } catch(Exception e){System.out.println("terminateActivity : exception raised : "+ e) ;} // Maybe instance or activity does not exists 


	System.out.println(" ");
	System.out.println(" ------------------------------------------");
	System.out.println(" First Iteration terminated");
	System.out.println(" Play other iterations with Bonita manager tool (jack and john users)");
	System.out.println(" To stop : just use Bonita Web admin page (admin user) and ") ;
	System.out.println(" position the once_more property to KO for the Accept Order_Instance1 SUB PROJECT ") ;
	System.out.println("(and not activity) before terminating the Notify Sales activity ");
	System.out.println(" ------------------------------------------");

	}




}


