package hero.client.samples;

/*
*
* Inscription.java - 
* Copyright (C) 2004 Ecoo Team
* Anne.Geron@bull.net
* 
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/


import javax.security.auth.login.LoginContext;
import hero.client.test.SimpleCallbackHandler;

import hero.interfaces.UserSession;
import hero.interfaces.UserSessionHome;
import hero.interfaces.UserSessionUtil;

import hero.interfaces.Constants;

import java.util.*;

public class SampleUserApi {
	
	static public void main(String[] args) throws Exception{
	
          // User Admin login
          char[] password={'t','o','t','o'};
          SimpleCallbackHandler handler = new SimpleCallbackHandler("admin",password);
          LoginContext lc = new LoginContext("TestClient", handler);
          lc.login();              	  

         // User Session Bean Creation using Remote Interface
          UserSessionHome usrHome= (UserSessionHome) UserSessionUtil.getHome();
          UserSession usrSession = usrHome.create();
	
          //***************************************************************/
          //************** API Documentation - Sample 6   ***************/
          //************** Users and Activities		*****************/
          //***************************************************************/

	  System.out.println("Current User Name/Passwd : " + usrSession.getUser() + "/" + usrSession.getUserPassword());

	  usrSession.setUserProperty("Language","Spanish");

	  System.out.println("Getting Current User properties values" );
          Collection properties = usrSession.getUserProperties() ;
          Iterator i = properties.iterator();
          while (i.hasNext())
          {
                hero.interfaces.BnUserPropertyValue property = (hero.interfaces.BnUserPropertyValue)i.next();
                try {
                        String propertyKeyName = property.getTheKey();
                        String propertyValue = (String)property.getTheValue();
                        System.out.println("Property (Key, Value) : " + propertyKeyName + "/" + propertyValue);
                } catch(Exception e) {System.out.println(e);} //Maybe there is a problem
          }

	  System.out.println("\n Getting project names for this user");
	  try {
            Collection prjNames = usrSession.getProjectListNames() ;
            Iterator j = prjNames.iterator();
            while (j.hasNext())
            {
                String prjName = (String)j.next();
                System.out.println(" --> Project :  " + prjName ); }
	  } catch(Exception e) {System.out.println(" --> " + e);} //Maybe something is wrong


	  System.out.println("\n Starting & terminating Activities available for this user");
	  try {
            Collection instNames = usrSession.getInstancesListNames() ;
            Iterator j = instNames.iterator();
            while (j.hasNext())
            {
                String instName = (String)j.next();
                System.out.println("--> INSTANCE :  " + instName ); 

	      System.out.println("Getting ToDo list for this instance");
              Collection activityNames = usrSession.getToDoList(instName) ;
              Iterator k = activityNames.iterator();
              while (k.hasNext())
              {
                String activityName = (String)k.next();
                System.out.println("   --> activity :  " + activityName ); 
	  	try {
			usrSession.startActivity(instName,activityName) ;
                	System.out.println("   --> activity started" ); 
	  	} catch(Exception e) {System.out.println(" --> " + e);} //Maybe something is wrong
	      } // End ToDo list

	      System.out.println("Getting the activity List (executing or anticipating) for the user");
              activityNames = usrSession.getActivityList(instName) ;
              k = activityNames.iterator();
              while (k.hasNext())
              {
                String activityName = (String)k.next();
                System.out.println("   --> activity :  " + activityName ); 
	  	try {
			usrSession.terminateActivity(instName,activityName) ;
                	System.out.println("   --> activity terminated" ); 
	  	} catch(Exception e) {System.out.println(" --> " + e);} //Maybe something is wrong
	      } // End ToDo list

	    } // End Intances List

	  } catch(Exception e) {System.out.println(" --> " + e);} //Maybe something is wrong

	} //End Main

} // End SampleProjectApi Class

