package hero.client.test;

/*
*
* BonitaTestSuite.java - 
* Copyright (C) 2002 Ecoo Team
* charoy@loria.fr
*
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

import javax.security.auth.login.LoginContext;
import javax.security.auth.login.LoginException;

import junit.framework.TestSuite;

public class BonitaTestSuite extends TestSuite {

    public BonitaTestSuite(String testname) {
		super(testname);
    }

    public static TestSuite suite() throws LoginException{
		char[] password={'t','o','t','o'};  
		SimpleCallbackHandler handler = new SimpleCallbackHandler("admin",password);
		LoginContext lc = new LoginContext("TestClient", handler);
		lc.login();
		TestSuite st=new TestSuite();
		st.addTest(new TestSuite(hero.client.test.UserRegistrationTests.class));
		st.addTest(new TestSuite(hero.client.test.EngineTests.class));
		st.addTest(new TestSuite(hero.client.test.ProjectSessionTests.class));
		st.addTest(new TestSuite(hero.client.test.UserSessionTests.class));
		st.addTest(new TestSuite(hero.client.test.AdminSessionTests.class));
		st.addTest(new TestSuite(hero.client.test.IterationTests.class)); 
		return st;
    }
}
