package hero.client.test;

import junit.framework.*;

import hero.interfaces.ProjectSession;
import hero.interfaces.ProjectSessionHome;
import hero.interfaces.ProjectSessionUtil;
import hero.interfaces.Constants;
import hero.hook.Hook;

public class Clone extends TestCase {
	private ProjectSessionHome projectSessionh;
	
	public Clone(String testname) {
	super(testname);
	}
    
	public static TestSuite suite() {

	return new TestSuite(DbInit.class);
	}

	public void setUp() throws Exception {
	}

	public void testClone() throws Exception {
		ProjectSessionHome lHome=ProjectSessionUtil.getHome();
		ProjectSession lProject = lHome.create();
		lProject.initProject("stressClone");
		lProject.addNode("node1",Constants.Nd.AND_JOIN_NODE);
		lProject.addNode("node2",Constants.Nd.AND_JOIN_NODE);
		lProject.addNode("node3",Constants.Nd.AND_JOIN_NODE);
		lProject.addNode("node4",Constants.Nd.AND_JOIN_NODE);
		lProject.addNode("node5",Constants.Nd.AND_JOIN_NODE);
		lProject.addEdge("node1","node2");
		lProject.addEdge("node1","node3");
		lProject.addEdge("node2","node4");
		lProject.addEdge("node3","node4");
		lProject.addEdge("node4","node5");
		lProject.setNodeRole("node1","admin");
		lProject.setNodeRole("node4","admin");
		lProject.setNodeRole("node5","admin");
		String script =
				"import hero.interfaces.BnProjectLocal;\n"
				+ "import hero.interfaces.BnNodeLocal;\n"
				+ "afterStart (Object b,Object n) {\n\n\n"
				+ "System.out.println(\"InteractiveBnNodee Hook test, node: \"+n.getName());"
				+ "}";
		lProject.addNodeInterHook("node1","interTest",hero.interfaces.Constants.Nd.AFTERSTART,Constants.Hook.BSINTERACTIVE,script);
		lProject.addNodeInterHook("node4","interTest",hero.interfaces.Constants.Nd.AFTERSTART,Constants.Hook.BSINTERACTIVE,script);				
		int i=0;
		for (i=0;i<100;i++){
			lProject.initProject("stressClone","stressClone"+i);
		}
	}
}
