package hero.client.test;

/*
*
* NodeTests.java - 
* Copyright (C) 2002 Ecoo Team
* valdes@loria.fr
*
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

import javax.security.auth.callback.Callback;
import javax.security.auth.callback.CallbackHandler;
import javax.security.auth.callback.NameCallback;
import javax.security.auth.callback.PasswordCallback;
import javax.security.auth.callback.UnsupportedCallbackException;


public class SimpleCallbackHandler implements CallbackHandler {
    private String username;
    private char[] password;
    
    public SimpleCallbackHandler(String username, char[] password)
    {
	this.username = username;
	this.password = password;
    }
    
    public void handle(Callback[] callbacks) throws
	java.io.IOException, UnsupportedCallbackException
    {
	for (int i = 0; i < callbacks.length; i++)
            {
                if (callbacks[i] instanceof NameCallback)
		    {
			NameCallback nc = (NameCallback)callbacks[i];
			nc.setName(username);
		    }
                else if (callbacks[i] instanceof PasswordCallback)
		    {
			PasswordCallback pc = (PasswordCallback)callbacks[i];
			pc.setPassword(password);
		    }
              /*  else
		    {
			throw new UnsupportedCallbackException(callbacks[i], "Unrecognized Callback");
		    }*/
            }
    }
}
