package hero.client.test;

/*
*
* NodeTests.java - 
* Copyright (C) 2002 Ecoo Team
* charoy@loria.fr
*
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

import hero.interfaces.BnUserLightValue;
import hero.interfaces.Constants;
import hero.interfaces.ProjectSession;
import hero.interfaces.ProjectSessionHome;
import hero.interfaces.ProjectSessionUtil;
import hero.interfaces.UserSession;
import hero.interfaces.UserSessionHome;
import hero.interfaces.UserSessionUtil;

import javax.security.auth.login.LoginContext;

/*
  UserSession.getName();
  UserSession.getPassword();
  UserSession.getUserLightValue();
  ProjectSession.initProject();
  ProjectSession.addNode();
  ProjectSession.addNode();
  ProjectSession.addEdge();
  UserSession.startActivity();
*/


public class TestRmi {

    public TestRmi() {
	try{
	    UserSessionHome userh=UserSessionUtil.getHome();
	    UserSession userSession = userh.create();
	    userSession.getUser();
	    System.out.println("getUser");
	    userSession.getUserPassword();
	    System.out.println("getPassword");
	    BnUserLightValue ulv = userSession.getUserLightValue();
	    System.out.println("getUserLightValue");
	    
	    ProjectSessionHome projecth=ProjectSessionUtil.getHome();
	    String projectName= "BnProject-"+System.currentTimeMillis();
	    ProjectSession projectSession = projecth.create();
	    projectSession.initProject(projectName);
	    System.out.println("initProject");
            String node1=projectName+"-node1-"+System.currentTimeMillis();
	    projectSession.addNode(node1,Constants.Nd.AND_JOIN_NODE); 
	    System.out.println("addNode");
            String node2=projectName+"-node2-"+System.currentTimeMillis();
	    projectSession.addNode(node2,Constants.Nd.AND_JOIN_NODE); 
	    System.out.println("addNode");
	    projectSession.addEdge(node1,node2); 
	    System.out.println("addEdge");
	    userSession.startActivity(projectName,node1);
	    System.out.println("startActivity");
	    

	}catch(Exception e){e.printStackTrace();}
    }
    
    
    static public void main(String[] args)
    {
	try{
	    char[] password={'t','o','t','o'};
	    SimpleCallbackHandler handler = new SimpleCallbackHandler("admin",password);
	    LoginContext lc = new LoginContext("TestClient", handler);
	    lc.login();
	    TestRmi tr = new TestRmi();
	}catch(Exception e){e.printStackTrace();}
	
    }
}
