/**
 *
 * Bonita
 * Copyright (C) 1999 Bull S.A.
 * Bull 68 route de versailles  78434 Louveciennes Cedex France
 * Further information: bonita@objectweb.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 *
--------------------------------------------------------------------------
 * $Id: InstancesPerfTest.java,v 1.1 2005/01/06 10:58:37 anneg Exp $
 *
--------------------------------------------------------------------------
 */

package hero.client.test.perf;

import javax.security.auth.login.LoginContext;
import hero.client.test.SimpleCallbackHandler;

import hero.interfaces.ProjectSession;
import hero.interfaces.ProjectSessionHome;
import hero.interfaces.ProjectSessionUtil;
import hero.interfaces.UserSession;
import hero.interfaces.UserSessionHome;
import hero.interfaces.UserSessionUtil;
import hero.interfaces.UserRegistration;
import hero.interfaces.UserRegistrationHome;
import hero.interfaces.UserRegistrationUtil;
import junit.framework.TestCase;
import junit.framework.TestSuite;
import hero.interfaces.Constants;
import java.util.Collection;
import java.util.Iterator;

public class InstancesPerfTest {


       static public void main(String[] args) throws Exception{

	int argNb = 2;
	if (args.length != argNb) {
	    System.out.println("Number of arguments needed : "+argNb);
	    System.out.println("Args :  userId nbInstances");
	} else {
	
	String uNb="0" ;
	int instNb = 10 ;

	long startTime = System.currentTimeMillis();

	try {
	uNb = new String(args[0]);
	String instanceNum = new String(args[1]);
	System.out.println("Parametres : uNb: "+ uNb+" - instanceNum: "+instanceNum) ;
	instNb = Integer.valueOf(instanceNum).intValue() ;
	}catch(Exception e){System.out.println(" --> " + e);}

	String uName= "user"+uNb;
	char[] password=uName.toCharArray();
	SimpleCallbackHandler handler = new SimpleCallbackHandler(uName,password);
	LoginContext lc = new LoginContext("TestClient", handler);
	lc.login();

	ProjectSessionHome pHome = ProjectSessionUtil.getHome();
	int i=0;
	for (i=0;i<instNb;i++) {
		ProjectSession ps = pHome.create();
		ps.instantiateProject("Stress");
		System.out.println(" --> User: " + uName +" -- Instanciate Stress Model");
		Thread.sleep(100);
		ps.remove();
	}
		
	UserSessionHome uHome = UserSessionUtil.getHome();
	UserSession us = uHome.create();
	Collection instances = us.getInstancesListNames();
	Iterator index = instances.iterator();
	UserSession usUser = uHome.create();
	while (index.hasNext())
	{
		String name = (String)index.next();
		Collection task = usUser.getToDoList(name);
		Iterator it = task.iterator();
		while (it.hasNext())
		{
		  String activity = (String)it.next();
		  usUser.startActivity(name,activity);
		  System.out.println(" --> User: " + uName +" Instance: "+name+" -- Start Act: " + activity);
		  if (activity.matches(".*_instance.*"))
			 executeSubProcess(activity);

		  Thread.sleep(100);
		  usUser.terminateActivity(name,activity);
		  System.out.println(" --> User: " + uName +" -- Stop Act: " + activity);
		  task = usUser.getToDoList(name);
		  it = task.iterator();
		}
	}

	long time = System.currentTimeMillis();
	long tmp = (time - startTime)/1000;
	long h = tmp/3600;
	long m = (tmp-3600*h)/60;
	long s = tmp-3600*h-60*m;
	System.out.println("  --> Stress Model system time elapsed : " + h + ":"+ m + ":" + s );
     }
     
   }

   public static void executeSubProcess(String subProcess) throws Exception{
	 UserSessionHome uHome = UserSessionUtil.getHome();
	 UserSession us = uHome.create();
	 us.startActivity(subProcess,"subNode1");
	 us.terminateActivity(subProcess,"subNode1");
	 us.startActivity(subProcess,"subNode2");
	 us.terminateActivity(subProcess,"subNode2");
   }
   
}
