/**
 *
 * Bonita
 * Copyright (C) 1999 Bull S.A.
 * Bull 68 route de versailles  78434 Louveciennes Cedex France
 * Further information: bonita@objectweb.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 *
--------------------------------------------------------------------------
 * $Id: ThreadInstancesPerfTest.java,v 1.1 2005/03/18 14:51:23 mvaldes Exp $
 *
--------------------------------------------------------------------------
 */

package hero.client.test.perf;

import javax.security.auth.login.LoginContext;
import hero.client.test.SimpleCallbackHandler;

import hero.interfaces.BnProject;
import hero.interfaces.BnProjectHome;
import hero.interfaces.BnProjectPK;
import hero.interfaces.BnProjectValue;
import hero.interfaces.ProjectSession;
import hero.interfaces.ProjectSessionHome;
import hero.interfaces.ProjectSessionUtil;
import hero.interfaces.UserSession;
import hero.interfaces.UserSessionHome;
import hero.interfaces.UserSessionUtil;
import hero.interfaces.UserRegistration;
import hero.interfaces.UserRegistrationHome;
import hero.interfaces.UserRegistrationUtil;
import junit.framework.TestCase;
import junit.framework.TestSuite;
import hero.interfaces.Constants;
import hero.util.BonitaServiceException;

import java.util.Collection;
import java.util.Iterator;

public class ThreadInstancesPerfTest extends Thread {

     private int userNb = 0;
     private String uNb = "0" ;
     private int instNb = 10 ;
     private int tpsRunDbtInst = 3;
     
     SimpleCallbackHandler handler = null;
     LoginContext lc=null;
     ProjectSessionHome pHome;
     static int instRunEnCours = 0;
     static int instTotales = 0;
     static int userCrees = 0;
     String uName=null;
     
     public ThreadInstancesPerfTest(int user, int inst, int tpsdbtinst) 
     {
	   this.userNb = user ;
	   this.uNb = String.valueOf(user) ;
	   this.instNb = inst;
	   this.tpsRunDbtInst=tpsdbtinst;
	   
	   uName = "user"+uNb;
	   char[] password=uName.toCharArray();
		try
		{
		handler = new SimpleCallbackHandler(uName,password);
		lc = new LoginContext("TestClient", handler);
		lc.login();
		pHome = ProjectSessionUtil.getHome();
		} 
		catch (Exception e)
		{
			System.out.println("pffffffff....meme pas en reve "+e);
		}
     }


     
     public void run() 
     {
	     
        //System.out.println("Starting really runInstance (using " + uNb +", "+instNb + ")...");
     	String result="";
     	long startTime = 0;
		int instRunDebut = instRunEnCours;		
		int userCreesDbt = userCrees;
		
      try 
	  { 
      	

		int i=0;
		
		Thread.sleep(tpsRunDbtInst * 1000);
		startTime = System.currentTimeMillis();
		ProjectSession ps = pHome.create();
		instRunEnCours +=1;
		instTotales +=1;
		//for (i=0;i<instNb;i++) {
			// threader CA :::::::: + timer par instance + stats instances en cours
			ps.instantiateProject("Stress");
			//System.out.println(" --> User: " + uName +" -- Instanciate Stress Model");
			
		//}
			
		ps.remove();
		/*
		UserSessionHome uHome = UserSessionUtil.getHome();
		UserSession us = uHome.create();
		Collection instances = us.getInstancesListNames();
		Iterator index = instances.iterator();
		UserSession usUser = uHome.create();
		while (index.hasNext())
		{
			String name = (String)index.next();
			Collection task = usUser.getToDoList(name);
			Iterator it = task.iterator();
			while (it.hasNext())
			{
			  String activity = (String)it.next();
			  usUser.startActivity(name,activity);
			  System.out.println(" --> User: " + uName +" Instance: "+name+" -- Start Act: " + activity);
			  if (activity.matches(".*_instance.*"))
				 executeSubProcess(activity);
	
			  Thread.sleep(100);
			  usUser.terminateActivity(name,activity);
			  System.out.println(" --> User: " + uName +" -- Stop Act: " + activity);
			  task = usUser.getToDoList(name);
			  it = task.iterator();
			}
		}*/
	       } catch(Exception e){System.out.println(" --> " + e);}
	
		long time = System.currentTimeMillis();
		long tmp = time - startTime; // tps en millisecondes
		long h = tmp/3600000;
		long m = (tmp-3600000*h)/60000;
		long s = (tmp-3600000*h-60000*m)/1000;
		long millis = tmp-3600000*h-60000*m-1000*s;
		System.out.println( "  --> "+ uName + " / ( "+userCreesDbt+"  -> "+ userCrees +" ) " +" Stressed Model ( "+ instRunDebut+" -> "+instRunEnCours +" / " + instTotales +" ) : system time elapsed : " + h + ":"+ m + ":" + s + ":" + millis );
		instRunEnCours -=1;

     }

   public static void executeSubProcess(String subProcess) throws Exception
   {
	 UserSessionHome uHome = UserSessionUtil.getHome();
	 UserSession us = uHome.create();
	 us.startActivity(subProcess,"subNode1");
	 us.terminateActivity(subProcess,"subNode1");
	 us.startActivity(subProcess,"subNode2");
	 us.terminateActivity(subProcess,"subNode2");
   }
}


