/**
 *
 * Bonita
 * Copyright (C) 1999 Bull S.A.
 * Bull 68 route de versailles  78434 Louveciennes Cedex France
 * Further information: bonita@objectweb.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 *
--------------------------------------------------------------------------
 * $Id: ThreadLanceurPerfTest.java,v 1.1 2005/03/18 14:51:23 mvaldes Exp $
 *
--------------------------------------------------------------------------
 */

package hero.client.test.perf;

import javax.security.auth.login.LoginContext;
import hero.client.test.SimpleCallbackHandler;

import hero.interfaces.ProjectSession;
import hero.interfaces.ProjectSessionHome;
import hero.interfaces.ProjectSessionUtil;
import hero.interfaces.UserSession;
import hero.interfaces.UserSessionHome;
import hero.interfaces.UserSessionUtil;
import hero.interfaces.UserRegistration;
import hero.interfaces.UserRegistrationHome;
import hero.interfaces.UserRegistrationUtil;
import junit.framework.TestCase;
import junit.framework.TestSuite;
import hero.interfaces.Constants;

import java.sql.Time;
import java.util.Collection;
import java.util.Iterator;

public class ThreadLanceurPerfTest 
{
	public static int injectes = 0 ;
	public static int userCreesEnCours = 0;
	
       public static void main(String[] args) throws Exception
	   {

	int argNb = 8;
	int userNb = 0;
	String uNb = "0";
	int instNb = 1;
	int nbUsersParPallier = userNb;
	int tpsPallier = 10; // secondes
	int tpsEntreUsers = 1 ;
	int tpsEntreInjInst = 1 ;
	int tpsEntreInst = 1 ;
	int tpsRunDbtInst = 3 ;
	
	if (args.length != argNb) 
	{
	    System.out.println("Number of arguments needed : "+argNb);
	    
	    System.out.println("Args :  -DuserId -DnbInst -Dnbuserspallier= -Dtpspallier= -DtpsEntreUsers= -DtpsEntreInjInst= -DtpsEtreInst -DtpsRunDbtInst");
	} 
	else 
	{

	  try 
	  {
	   uNb = new String(args[0]);
	   userNb = Integer.valueOf(uNb).intValue() ;
	  } 
	  catch(Exception e){System.out.println(" --> " + e);}

	  try 
	  {
	  String instanceNum = new String(args[1]);
	  instNb = Integer.valueOf(instanceNum).intValue() ;
	  }
	  catch(Exception e){System.out.println(" --> " + e);}

	  try 
	  {
	  String usersParPallier = new String(args[2]);
	  nbUsersParPallier = Integer.valueOf(usersParPallier).intValue() ;
	  }
	  catch(Exception e){System.out.println(" --> " + e);}
	  
	  try 
	  {
	  String tpsSecParPallier = new String(args[3]);
	  tpsPallier = Integer.valueOf(tpsSecParPallier).intValue() ;
	  }
	  catch(Exception e){System.out.println(" --> " + e);}
	  
	  try 
	  {
	  	String tps_entre_users = new String(args[4]);
	  	tpsEntreUsers = Integer.valueOf(tps_entre_users).intValue() ;
	  }
	  catch(Exception e){System.out.println(" --> " + e);}
	  
	  try 
	  {
	  	String tps_entre_inj_inst = new String(args[5]);
	  	tpsEntreInjInst = Integer.valueOf(tps_entre_inj_inst).intValue() ;
	  }
	  catch(Exception e){System.out.println(" --> " + e);}
	  
	  try 
	  {
	  	String tps_entre_inst = new String(args[6]);
	  	tpsEntreInst = Integer.valueOf(tps_entre_inst).intValue() ;
	  }
	  catch(Exception e){System.out.println(" --> " + e);}
	  
	  try 
	  {
	  	String tps_run_dbt_inst = new String(args[7]);
	  	tpsRunDbtInst = Integer.valueOf(tps_run_dbt_inst).intValue() ;
	  }
	  catch(Exception e){System.out.println(" --> " + e);}
	}
	
	////////// TEST ////////////////////////////////////////////////

	  UserRegistrationHome urHome = UserRegistrationUtil.getHome();
	  UserRegistration userReg=urHome.create();
	  
	  
	  int userRestant = userNb;
	  int userInj = 0;
	  int maxInj = 0;
	  
	  while(userRestant > 0)
	  {
		try 
		{
		   maxInj = Math.min( nbUsersParPallier , userRestant )	;
		   
	       for (userInj=injectes ; userInj < injectes+maxInj ; userInj++) 
	       {
	       	userCreesEnCours +=1;
			// user creation
	       		try
				{
	       			userReg.userCreate("user"+userInj,"user"+userInj,"Anne.Geron@bull.net");			
	       			ThreadInstancesPerfTest.userCrees = userCreesEnCours ;
	       			Thread.sleep(tpsEntreUsers * 1000);
	       			// System.out.println("---> Creation user "+ userInj) ;
				}
	    		catch (Exception e)
				{
					System.out.println(" --> " + e);
				}
		  }
	   
	      Thread.sleep(tpsEntreInjInst * 1000);
	      
		  for (int userInst=injectes ; userInst < injectes+maxInj ; userInst++) 
		  {
			  	//System.out.println("Main : User : " + userInst + " - Instance : "+instNb);
				try
				{
					for(int i=0;i<instNb;i++)
					{
						// Creation du thread
						
						ThreadInstancesPerfTest thisInst = new ThreadInstancesPerfTest(userInst,i,tpsRunDbtInst);
						// Lancement du thread
						thisInst.start();
						Thread.sleep(tpsEntreInst * 1000);
					}
				}
				catch (Exception e)
				{
					System.out.println(" --> " + e);
				}
		  }
		  
		} 
		catch (Exception se)
		{
			System.out.println(" // " + se);
		}
		finally
		{
			System.out.println(" ///////// ATTENTE ( " + tpsPallier +" sec) " );
			Thread.sleep(tpsPallier * 1000);
			System.out.println(" ///////// NOUVELLE INJECTION ");
			injectes += maxInj ;
			userRestant = userNb - injectes;
		}
		  
	  } // fin boucle while  

	}
       
    private void mode1()
    {
    	
    }
    
    private void mode2()
    {
    	
    }
    
    private void regUser()
    {
    	
    }
    
    private void creaInst()
    {
    	
    }
}


