/**
 *
 * Bonita
 * Copyright (C) 1999 Bull S.A.
 * Bull 68 route de versailles  78434 Louveciennes Cedex France
 * Further information: bonita@objectweb.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 *
--------------------------------------------------------------------------
 * $Id: PerformanceTests.java,v 1.1 2004/07/30 14:57:58 mvaldes Exp $
 *
--------------------------------------------------------------------------
 */


package hero.client.test.performance;

/*
*
* PerformanceTests.java - 
* Copyright (C) 2003 Ecoo Team
* valdes@loria.fr
*
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

import hero.interfaces.UserSession;
import hero.interfaces.UserSessionHome;
import hero.interfaces.UserSessionUtil;
import hero.interfaces.ProjectSession;
import hero.interfaces.ProjectSessionHome;
import hero.interfaces.ProjectSessionUtil;
import junit.framework.TestCase;
import junit.framework.TestSuite;
import javax.security.auth.login.LoginContext;
import hero.client.test.SimpleCallbackHandler;
import java.util.Collection;
import java.util.Iterator;

public class PerformanceTests extends TestCase {
 
    public PerformanceTests(String testname) {
	super(testname);
    }
    
    public static TestSuite suite() {
	return new TestSuite(PerformanceTests.class);
    }

    public void setUp() throws Exception {
    }
    
    public void testUsersInteraction() throws Exception {
    int i=0;
	UserSessionHome uHome = UserSessionUtil.getHome();
    for (i=0;i<15;i++)
    {
		String uName= "user"+i;
		char[] password=uName.toCharArray();
		SimpleCallbackHandler handler = new SimpleCallbackHandler(uName,password);
		LoginContext lc = new LoginContext("TestClient", handler);
		lc.login();
		UserSession us = uHome.create();
		Collection instances = us.getProjectListNames();
		Iterator index = instances.iterator();
		while (index.hasNext())
		{
			String name = (String)index.next();
			if (name.matches("Stress.*"))
			{
				ProjectSessionHome pHome = ProjectSessionUtil.getHome();
				ProjectSession ps = pHome.create();
				ps.initProject(name);
				ps.setUserRole("user"+i,"InitialRole");
				Collection task = us.getToDoList(name);
				Iterator tsk = task.iterator();
				while (tsk.hasNext())
				{
					us.startActivity(name,(String)tsk.next());
					task = us.getToDoList(name);
					tsk = task.iterator();
				}
				ps.remove();
			}
		}
		us.remove();
     }	
    	
	}
}
