package hero.entity;
/*
* 02/11/2002 - 17:31:40
*
* AutomaticNodeState.java - 
* Copyright (C) 2002 Ecoo Team
* charoy@loria.fr
* 
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
import hero.interfaces.BnNodeLocal;
import hero.interfaces.Constants;

public class AutomaticSubNodeState extends NodeState implements java.io.Serializable {

    private static int[][] nodeTransition= {
	{
	    Constants.Nd.BAD_TRANSITION, // START, INITIAL
	    Constants.Nd.EXECUTING, // START, READY
	    Constants.Nd.BAD_TRANSITION, // START, DEAD
	    Constants.Nd.BAD_TRANSITION, // START, ANTICIPABLE
	    Constants.Nd.BAD_TRANSITION, // START, EXPIRED
	    Constants.Nd.BAD_TRANSITION, // START, ANTICIPATING
	    Constants.Nd.BAD_TRANSITION, // START, EXECUTING
	    Constants.Nd.BAD_TRANSITION, // START, EXECUTED
	    Constants.Nd.BAD_TRANSITION, // START, INERROR
	    Constants.Nd.BAD_TRANSITION, // START, FINISHED
	    Constants.Nd.BAD_TRANSITION, // START, TERMINATED
	    Constants.Nd.BAD_TRANSITION, // START, CHECKEDOUT
	    Constants.Nd.BAD_TRANSITION, // START, ANT_SUSPENDED
	    Constants.Nd.BAD_TRANSITION, // START, EXEC_SUSPENDED
	},{
	    Constants.Nd.BAD_TRANSITION, // TERMINATE, INITIAL
	    Constants.Nd.BAD_TRANSITION, // TERMINATE, READY
	    Constants.Nd.BAD_TRANSITION, // TERMINATE, DEAD
	    Constants.Nd.BAD_TRANSITION, // TERMINATE, ANTICIPABLE
	    Constants.Nd.BAD_TRANSITION, // TERMINATE, EXPIRED
	    Constants.Nd.BAD_TRANSITION, // TERMINATE, ANTICIPATING
	    Constants.Nd.TERMINATED, // TERMINATE, EXECUTING
	    Constants.Nd.BAD_TRANSITION, // TERMINATE, EXECUTED
	    Constants.Nd.BAD_TRANSITION, // TERMINATE, INERROR
	    Constants.Nd.BAD_TRANSITION, // TERMINATE, FINISHED
	    Constants.Nd.BAD_TRANSITION, // TERMINATE, TERMINATED
	    Constants.Nd.BAD_TRANSITION, // TERMINATE, CHECKEDOUT
	    Constants.Nd.BAD_TRANSITION, // TERMINATE, ANT_SUSPENDED
	    Constants.Nd.BAD_TRANSITION, // TERMINATE, EXEC_SUSPENDED
	},{
	    Constants.Nd.BAD_TRANSITION, // SUSPEND, INITIAL
	    Constants.Nd.BAD_TRANSITION, // SUSPEND, READY
	    Constants.Nd.BAD_TRANSITION, // SUSPEND, DEAD
	    Constants.Nd.BAD_TRANSITION, // SUSPEND, ANTICIPABLE
	    Constants.Nd.BAD_TRANSITION, // SUSPEND, EXPIRED
	    Constants.Nd.BAD_TRANSITION, // SUSPEND, ANTICIPATING
	    Constants.Nd.BAD_TRANSITION, // SUSPEND, EXECUTING
	    Constants.Nd.BAD_TRANSITION, // SUSPEND, EXECUTED
	    Constants.Nd.BAD_TRANSITION, // SUSPEND, INERROR
	    Constants.Nd.BAD_TRANSITION, // SUSPEND, FINISHED
	    Constants.Nd.BAD_TRANSITION, // SUSPEND, TERMINATED
	    Constants.Nd.BAD_TRANSITION, // SUSPEND, CHECKEDOUT
	    Constants.Nd.BAD_TRANSITION, // SUSPEND, ANT_SUSPENDED
	    Constants.Nd.BAD_TRANSITION, // SUSPEND, EXEC_SUSPENDED
	},{
	    Constants.Nd.BAD_TRANSITION, // RESUME, INITIAL
	    Constants.Nd.BAD_TRANSITION, // RESUME, READY
	    Constants.Nd.BAD_TRANSITION, // RESUME, DEAD
	    Constants.Nd.BAD_TRANSITION, // RESUME, ANTICIPABLE
	    Constants.Nd.BAD_TRANSITION, // RESUME, EXPIRED
	    Constants.Nd.BAD_TRANSITION, // RESUME, ANTICIPATING
	    Constants.Nd.BAD_TRANSITION, // RESUME, EXECUTING
	    Constants.Nd.BAD_TRANSITION, // RESUME, EXECUTED
	    Constants.Nd.BAD_TRANSITION, // RESUME, INERROR
	    Constants.Nd.BAD_TRANSITION, // RESUME, FINISHED
	    Constants.Nd.BAD_TRANSITION, // RESUME, TERMINATED
	    Constants.Nd.BAD_TRANSITION, // RESUME, CHECKEDOUT
	    Constants.Nd.BAD_TRANSITION, // RESUME, ANT_SUSPENDED
	    Constants.Nd.BAD_TRANSITION, // RESUME, EXEC_SUSPENDED
	},{
	    Constants.Nd.INITIAL, // EDGEINITIAL, INITIAL
	    Constants.Nd.INITIAL, // EDGEINITIAL, READY
	    Constants.Nd.BAD_TRANSITION, // EDGEINITIAL, DEAD
	    Constants.Nd.INITIAL, // EDGEINITIAL, ANTICIPABLE
	    Constants.Nd.BAD_TRANSITION, // EDGEINITIAL, EXPIRED
	    Constants.Nd.BAD_TRANSITION, // EDGEINITIAL, ANTICIPATING
	    Constants.Nd.BAD_TRANSITION, // EDGEINITIAL, EXECUTING
	    Constants.Nd.BAD_TRANSITION, // EDGEINITIAL, EXECUTED
	    Constants.Nd.BAD_TRANSITION, // EDGEINITIAL, INERROR
	    Constants.Nd.BAD_TRANSITION, // EDGEINITIAL, FINISHED
	    Constants.Nd.BAD_TRANSITION, // EDGEINITIAL, TERMINATED
	    Constants.Nd.BAD_TRANSITION, // EDGEINITIAL, CHECKEDOUT
	    Constants.Nd.BAD_TRANSITION, // EDGEINITIAL, ANT_SUSPENDED
	    Constants.Nd.BAD_TRANSITION, // EDGEINITIAL, EXEC_SUSPENDED
	},{
	    Constants.Nd.INITIAL, // ANTACTIVE, INITIAL
	    Constants.Nd.INITIAL, // ANTACTIVE, READY
	    Constants.Nd.BAD_TRANSITION, // ANTACTIVE, DEAD
	    Constants.Nd.INITIAL, // ANTACTIVE, ANTICIPABLE
	    Constants.Nd.BAD_TRANSITION, // ANTACTIVE, EXPIRED
	    Constants.Nd.INITIAL, // ANTACTIVE, ANTICIPATING
	    Constants.Nd.EXECUTING, // ANTACTIVE, EXECUTING
	    Constants.Nd.BAD_TRANSITION, // ANTACTIVE, EXECUTED
	    Constants.Nd.BAD_TRANSITION, // ANTACTIVE, INERROR
	    Constants.Nd.BAD_TRANSITION, // ANTACTIVE, FINISHED
	    Constants.Nd.TERMINATED,     // ANTACTIVE, TERMINATED
	    Constants.Nd.BAD_TRANSITION, // ANTACTIVE, CHECKEDOUT
	    Constants.Nd.BAD_TRANSITION, // ANTACTIVE, ANT_SUSPENDED
	    Constants.Nd.BAD_TRANSITION, // ANTACTIVE, EXEC_SUSPENDED
	},{
	    Constants.Nd.EXECUTING, // ACTIVE, INITIAL
	    Constants.Nd.EXECUTING, // ACTIVE, READY
	    Constants.Nd.BAD_TRANSITION, // ACTIVE, DEAD
	    Constants.Nd.BAD_TRANSITION, // ACTIVE, ANTICIPABLE
	    Constants.Nd.BAD_TRANSITION, // ACTIVE, EXPIRED
	    Constants.Nd.BAD_TRANSITION, // ACTIVE, ANTICIPATING
	    Constants.Nd.EXECUTING, // ACTIVE, EXECUTING
	    Constants.Nd.BAD_TRANSITION, // ACTIVE, EXECUTED
	    Constants.Nd.BAD_TRANSITION, // ACTIVE, INERROR
	    Constants.Nd.BAD_TRANSITION, // ACTIVE, FINISHED
	    Constants.Nd.TERMINATED,     // ACTIVE, TERMINATED
	    Constants.Nd.BAD_TRANSITION, // ACTIVE, CHECKEDOUT
	    Constants.Nd.BAD_TRANSITION, // ACTIVE, ANT_SUSPENDED
	    Constants.Nd.BAD_TRANSITION, // ACTIVE, EXEC_SUSPENDED
	},{
	    Constants.Nd.DEAD, // CANCEL, INITIAL
	    Constants.Nd.DEAD, // CANCEL, READY
	    Constants.Nd.DEAD, // CANCEL, DEAD
	    Constants.Nd.BAD_TRANSITION, // CANCEL, ANTICIPABLE
	    Constants.Nd.BAD_TRANSITION, // CANCEL, EXPIRED
	    Constants.Nd.DEAD, // CANCEL, ANTICIPATING
	    Constants.Nd.DEAD, // CANCEL, EXECUTING
	    Constants.Nd.BAD_TRANSITION, // CANCEL, EXECUTED
	    Constants.Nd.BAD_TRANSITION, // CANCEL, INERROR
	    Constants.Nd.BAD_TRANSITION, // CANCEL, FINISHED
	    Constants.Nd.BAD_TRANSITION, // CANCEL, TERMINATED
	    Constants.Nd.BAD_TRANSITION, // CANCEL, CHECKEDOUT
	    Constants.Nd.BAD_TRANSITION, // CANCEL, ANT_SUSPENDED
	    Constants.Nd.BAD_TRANSITION, // CANCEL, EXEC_SUSPENDED
	}
    };

    public AutomaticSubNodeState() {
    }

    public int computeState(BnNodeLocal node,int operation) {
	return nodeTransition[operation][node.getState()];
    }
	
    
}















