package hero.historic;

/**
*
* Bonita
* Copyright (C) 1999 Bull S.A.
* Bull 68 route de versailles  78434 Louveciennes Cedex France
* Further information: bonita@objectweb.org
*
* This library is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or any later version.
*
* This library is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this library; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
* USA
*
*
--------------------------------------------------------------------------
* $Id: NodeHistoric.java,v 1.1 2004/10/01 15:32:18 mvaldes Exp $
*
--------------------------------------------------------------------------
*/

import java.io.Serializable;
import java.util.Vector;

public final class NodeHistoric implements Serializable, java.lang.Cloneable {

    // --------------------------------------------------- Instance Variables

    /**
     * The name of the node
     */
    private String name = "";

    /**
     * The state of the node
     */
    private String state = "";

    /**
     * The role of the node
     */
    private String role = "";
    
    /**
     * The executor of the node
     */
    private String executor = "";

    /**
     * The type of the node
     */
    private String type = "";

    /**
     * If this node is anticipable 
     */
    private boolean anticipable = true ;

    /**
     * The description of the node
     */
    private String description= "";
    
    /**
     * The start date of the node
     */
    private String startDate = "";
    
    /**
     * The end date of the node
     */
    private String endDate = "";
    
    /**
     * Node properties
     */
    private Vector properties;


    // ----------------------------------------------------------- Properties

    /**
     * Get the name
     *@return String 
     */
    public String getName() {
    	return (name);
    }

    /**
     * Set the name.
     * @param name
     */
    public void setName(String name) {
        this.name = name;
    }

    /**
     * Get the state
     *@return String 
     */
    public String getState() {
    	return (state);
    }

    /**
     * Set the state.
     * @param state
     */
    public void setState(String state) {
        this.state = state;
    }

    /**
     * Get the type
     *@return String 
     */
    public String getType() {
    	return (type);
    }

    /**
     * Set the type.
     * @param type
     */
    public void setType(String type) {
        this.type = type;
    }

    /**
     * Get the role
     *@return String 
     */
    public String getRole() {
    	return (role);
    }

    /**
     * Set the role.
     * @param role
     */
    public void setRole(String role) {
        this.role = role;
    }

    /**
     * Get the anticipable property
     *@return boolean 
     */
    public boolean getAnticipable() {
    	return (anticipable);
    }

    /**
     * Set the anticipable property
     * @param anticipable
     */
    public void setAnticipable(boolean anticipable) {
        this.anticipable = anticipable;
    }

    /**
     * Get the description of the activity
     *@return String 
     */
    public String getDescription() {
    	return (description);
    }

    /**
     * Set the description of the activity
     * @param description
     */
    public void setDescription(String description) {
        this.description = description;
    }

    /**
     * Get the startDate of the activity
     *@return String 
     */
    public String getStartDate() {
    	return (startDate);
    }

    /**
     * Set the startDate of the activity
     * @param startDate
     */
    public void setStartDate(String startDate) {
        this.startDate = startDate;
    }
    
    /**
     * Get the endate of the activity
     *@return String 
     */
    public String getEndDate() {
    	return (endDate);
    }

    /**
     * Set the endDate of the activity
     * @param endDate
     */
    public void setEndDate(String endDate) {
        this.endDate = endDate;
    }
    
    /**
     * Get the executor of the activity
     *@return String 
     */
    public String getExecutor() {
    	return (executor);
    }

    /**
     * Set the executor of the activity
     * @param executor
     */
    public void setExecutor(String executor) {
        this.executor = executor;
    }
    
    public Vector getProperties() {
    	return (properties);
    }

    public void setProperties(Vector properties) {
        this.properties = properties;
    }

    public NodeHistoric(){}

    public Object clone() throws java.lang.CloneNotSupportedException{
	return super.clone();
    }

}
