/*
*
* BeanShellHook.java - 
* Copyright (C) 2003 Ecoo Team
* valdes@loria.fr
* 
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

package hero.hook;

import hero.interfaces.BnNodeLocal;
import hero.util.HeroHookException;
import bsh.Interpreter;

public class BeanShellHook extends Hook {

    public BeanShellHook(String name, String event, int type) {
	super(name,event,type);
    }

    public void execute(Object bean,String eventName,BnNodeLocal node) throws HeroHookException {
	try {

	    Interpreter i = new Interpreter();
	    i.set("node",node);
	    i.set("bean",bean);
	    ClassLoader cl = this.getClass().getClassLoader();
	    if (cl.getResource("/"+this.getName()+".bsh") != null)
	    {		
		i.source((cl.getResource("/"+this.getName()+".bsh")).toString());
		//i.source("/"+this.getName()+".bsh");
		i.eval(eventName+"(bean,node)");
	    }
	    
	} catch (Exception t) {	    
	    throw new HeroHookException("Cannot execute JAVA hook "+t.getMessage());
	}
    }

}
