/*
*
* BeanShellHook.java - 
* Copyright (C) 2003 Ecoo Team
* valdes@loria.fr
* 
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

package hero.hook;

import hero.interfaces.BnNodeInterHookLocal;
import hero.interfaces.BnNodeLocal;
import hero.interfaces.BnNodePropertyLocal;
import hero.interfaces.BnProjectPropertyLocal;
import hero.interfaces.BnProjectInterHookLocal;
import hero.interfaces.BnProjectLocal;
import hero.util.HeroHookException;

import java.util.Collection;
import java.util.Iterator;

import bsh.Interpreter;

public class InteractiveBSHook extends Hook {

    public InteractiveBSHook(String name, String event, int type, String script) {
	super(name,event,type,script);
    }

    public void execute(Object bean,String eventName,BnNodeLocal node) throws HeroHookException {
	try {
	    String value = this.getScript();
	    BnNodeLocal nd=node;		

	    Interpreter i = new Interpreter();
	    i.set("node",node);
	    i.set("bean",bean);

		//	BnNode properties mapping

	    Collection prop = node.getBnProperties();
		for (Iterator props=prop.iterator();props.hasNext();) {
			BnNodePropertyLocal pl=(BnNodePropertyLocal)props.next();
			i.set(pl.getTheKey(),pl.getTheValue());
	    }
	    
		// Project properties mapping
		BnProjectLocal project = node.getBnProject();
		Collection projectProp = project.getBnProperties();
		for (Iterator props=projectProp.iterator();props.hasNext();) {
			 BnProjectPropertyLocal pP=(BnProjectPropertyLocal)props.next();
  		     i.set(pP.getTheKey(),pP.getTheValue());
		}

	    i.eval(value);
	    i.eval(eventName+"(bean,node)");
	    
	} catch (Exception t) {t.printStackTrace();
		if (node.getType()==hero.interfaces.Constants.Nd.SUB_PROCESS_NODE && eventName.equals(hero.interfaces.Constants.Nd.BEFORETERMINATE))
			throw new HeroHookException("You have to terminate subProcess activities previuosly"); 
	else if (eventName.equals(hero.interfaces.Constants.Nd.AFTERSTART) || eventName.equals(hero.interfaces.Constants.Nd.BEFORETERMINATE)
		|| eventName.equals(hero.interfaces.Constants.Nd.ANTICIPATE) || eventName.equals(hero.interfaces.Constants.Nd.ONCANCEL))
		
		throw new HeroHookException("Cannot execute beanshell hook "+t.getMessage());
		}
    }
}
   