package hero.hook;

/*
* 02/01/2002 - 15:24:07
*
* JavaProcessHook.java - 
* Copyright (C) 2002 Ecoo Team
* charoy@loria.fr
* 
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

import hero.interfaces.BnProjectLocal;
import hero.util.HeroHookException;

import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;

public class JavaProcessHook extends ProcessHook {

    public JavaProcessHook(String name, String event, int type) {
	super(name,event,type);
    }

    public void execute(Object bean,String eventName,BnProjectLocal project) throws HeroHookException {
	try {
		ClassLoader cl = Thread.currentThread().getContextClassLoader();
	    Class clhook=cl.loadClass(this.getName());
	    ProcessHookI prh =(ProcessHookI)clhook.newInstance();
	    Class[] param={
		java.lang.Object.class,
		hero.interfaces.BnProjectLocal.class};
	    Method evth=clhook.getMethod(eventName,param);
	    Object[] o={bean,project};
	    evth.invoke(prh,o);
	} catch (InvocationTargetException ite) {
	    throw new HeroHookException("Failure during Process hook execution"+ite.getMessage());
	} catch (Exception e) {
	    throw new HeroHookException("Dynamic invocation failed :"+this.getName()+"#"+project.getName()+"-->"+eventName+" ///"+e);
	}
    }


}
