/*
*
* Hook.java - 
* Copyright (C) 2003 Ecoo Team
* charoy@loria.fr
* 
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

package hero.hook;

import hero.interfaces.BnProjectLocal;
import hero.util.HeroException;
import hero.util.HeroHookException;
import java.io.Serializable;
import hero.interfaces.Constants;

public abstract class ProcessHook implements Serializable{

    private String name;
    private String event;
    private int type;
    private String script;

    public static ProcessHook make(String name, String event, int type) throws HeroException {
    	if (type==Constants.Hook.JAVA) {return new JavaProcessHook(name,event,type);}
	throw new HeroException("Wrong Process Hook Type "+type);
    }
   
    /* To be completed in future
    public static ProcessHook make(String name, String event, int type, String script) throws HeroException {
   		if (type==Constants.Hook.BSINTERACTIVE) {return new InteractiveBSProcessHook(name,event,type,script);}
    	throw new HeroException("Wrong Hook Type "+type);
        }
    */
    
    protected ProcessHook(String name, String event, int type) {
	this.name=name;
	this.event=event;
	this.type=type;
    }
    
    protected ProcessHook(String name, String event, int type, String script) {
    	this.name=name;
    	this.event=event;
    	this.type=type;
    	this.script=script;
      }

    public String getName() {return this.name;}
    public void setName(String name) {this.name=name;}

    public int getType() {return this.type;}
    public void setType(int type) {this.type=type;}

    public String getEvent() {return this.event;}
    public void setEvent(String event) {this.event=event;}
    
    public String getScript() {return this.script;}
    public void setScript(String script) {this.script=script;}

    public String toXML() {
	String result=new String();
	result="<Process hook name=\""+this.getName()+
	    "\" type=\""+this.getType()+
	    "\" event=\""+this.getEvent()+"\"/>";
	return result;
    }

    public abstract void execute(Object bean,String eventName, BnProjectLocal project) throws HeroHookException;

}
