package hero.hook;

/*
*
* TCLHook.java - 
* Copyright (C) 2003 Ecoo Team
* charoy@loria.fr
* 
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

import hero.interfaces.BnNodeLocal;
import hero.util.HeroHookException;
import tcl.lang.Interp;
import tcl.lang.ReflectObject;
import tcl.lang.TclObject;

public class TclHook extends Hook {

    public TclHook(String name, String event, int type) {
	super(name,event,type);
    }

    public void execute(Object bean,String eventName,BnNodeLocal node) throws HeroHookException {
	try {
	    Interp interp=new Interp();
	    interp.evalResource("/"+this.getName()+".tcl");
	    TclObject tclNode=ReflectObject.newInstance(interp,BnNodeLocal.class,node);
	    TclObject tclEJB=ReflectObject.newInstance(interp,Object.class,bean);
	    interp.setVar("node",tclNode,1);
	    interp.setVar("bean",tclEJB,1);
	    interp.eval(this.getName()+"::"+eventName+" $bean $node");
	} catch (Exception t) {	    
	    throw new HeroHookException("Cannot execute tcl hook "+t.getMessage());
	}
    }

}
