package hero.initiatorMapper;

/*
*
* CustomInitiatorMapper.java - 
* 
* 
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

import hero.interfaces.BnProjectLocal;
import hero.util.HeroException;

import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import org.apache.log4j.Category;

import java.util.Collection;

public class CustomInitiatorMapper extends InitiatorMapper {

    // Utility variable
    private static final Category log = Category.getInstance(LdapInitiatorMapper.class);


    public CustomInitiatorMapper(String name, int type) {
	super(name,type);
    }

    public Collection execute(Object bean, int type, BnProjectLocal project, String userName) throws HeroException {
	log.debug("execute: type="+type+" project="+project.getName());
		
	try {
		// The name of the class depend only on the mapper type	    
		Class clmapper=Class.forName(this.getName(), true, Thread.currentThread().getContextClassLoader());
	    InitiatorMapperI ndh =(InitiatorMapperI)clmapper.newInstance();
	    Class[] param={
		Class.forName("java.lang.Object"),
		Class.forName("hero.interfaces.BnProjectLocal", true, Thread.currentThread().getContextClassLoader()),
		Class.forName("java.lang.String")};
	    // call method searchMembers() of clmapper class
	    Method evth=clmapper.getMethod("searchMembers",param);
	    Object[] o={bean,project,userName};
	    return((Collection)evth.invoke(ndh,o));
	} catch (InvocationTargetException ite) {
	    throw new HeroException("Failure during mapper execution : " + ite.getMessage());
	} catch (Exception e) {
	    throw new HeroException("Dynamic invocation of mapper failed :"+this.getName()+"#"+project.getName()+"--> mapper type = "+type+" ///"+e);
	}
    }


}
