/*
*
* InitiatorMapper.java - 
* 
* 
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

package hero.initiatorMapper;

import hero.interfaces.BnProjectLocal;
import hero.initiatorMapper.LdapInitiatorMapper;
import hero.util.HeroException;
import java.io.Serializable;
import java.util.Collection;

public abstract class InitiatorMapper implements Serializable{


    public static final int LDAP=0;
    public static final int CUSTOM=1;

    private String name;
    private int type;

    public static InitiatorMapper make(String name, int type) throws HeroException {
	if (type==LDAP) {return new LdapInitiatorMapper(name,type);}
	if (type==CUSTOM) {return new CustomInitiatorMapper(name,type);}

	throw new HeroException("Wrong Mapper Type " + type);
    }

    protected InitiatorMapper(String name, int type) {
	this.name=name;
	this.type=type;
    }

    public String getName() {return this.name;}
    public void setName(String name) {this.name=name;}

    public int getType() {return this.type;}
    public void setType(int type) {this.type=type;}

    public String toXML() {
	String result=new String();
	result="<initiator mapper name=\""+this.getName()+
	    "\" type=\""+this.getType()+"\"/>";
	return result;
    }

    public abstract Collection execute(Object bean, int type, BnProjectLocal project, String userName) throws HeroException;

}
