package hero.interfaces;

/*
*
* Constants.java -
* Copyright (C) 2002 Ecoo Team
* charoy@loria.fr
* valdes@loria.fr
*
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

public interface Constants {

	public static final String ADMIN = "admin";
	public static final String SECURITY_ROLE = "SuperAdmin";
	public static final String USER_SECURITY_ROLE = "BONITAUSER";
	public static final String INITIALROLE = "InitialRole";
	public static final int CONDITION_FALSE = 0;
	public static final int CONDITION_TRUE = 1;
	public static final int AND = 1;
	public static final int OR = 2;

	// JMX Config
	public static final String PURGE = "Purge";
	public static final String TRANSFER = "Transfer";
	public static final String DEBUG = "Debug";
	public static final String INFO = "Info";
	public static final String ERROR = "Error";

    public interface Hook {
		public static final int JAVA=0;
	    public static final int JYTHON=1;
		public static final int EXTERNAL=2;
		public static final int CLIENT =3;
		public static final int TCL =4;
		public static final int BEANSHELL =5;
		public static final int BSINTERACTIVE =6;
    }

    public interface Mapper {
		public static final int LDAP=0;
		public static final int PROPERTIES=1;
		public static final int CUSTOM=2;

		public static final String LDAPMAPPER = "LDAP";
		public static final String PROPERTIESMAPPER = "Properties";
		public static final String CUSTOMMAPPER = "Custom";

    }

    public interface InitiatorMapper {
		public static final int LDAP=0;
		public static final int CUSTOM=1;

		public static final String LDAPLABEL = "LDAP";
		public static final String CUSTOMLABEL = "Custom";

    }

	public interface PerformerAssigment {
		public static final int CALLBACK=0;
		public static final int PROPERTIES=1;

		public static final String CALLBACKPA = "Callback";
		public static final String PROPERTIESPA = "Property";

	}

	public interface Pj {
		public static final int INITIAL = 0;
		public static final int STARTED = 1;
		public static final int TERMINATED = 2;

		// Process status
		public static final String ACTIVE = "Active";
		public static final String HIDDEN = "Hidden";
        public static final String UNDEPLOYED = "Undeployed";

		// Process Type

		public static final String MODEL = "Model";
		public static final String COOPERATIVE = "Cooperative";
		public static final String 	INSTANCE = "Instance";
		public static final String 	ACTIVITY = "Activity";

		public static final String[] projectStateName =
			{ "INITIAL", "STARTED", "TERMINATED" };

		// Events
		public static final String ONINSTANTIATE = "onInstantiate";
		public static final String ONTERMINATE = "onTerminate";

		// Lists Count
		public static final String GETACTIVITIES = "getActivities";
		public static final String GETINSTANCES = "getInstances";
		public static final String GETMODELS = "getModels";
		public static final String GETTERMINATEDLISTALLINSTANCES = "getTerminatedListAllInstances";
		public static final String GETUSERINSTANCESPROJECTNODES = "getUserInstancesProjectNodes";
		public static final String GETINSTANCESACTIVITYTERMINATED = "getInstancesActivityTerminated";
		public static final String GETINSTANCESACTIVITYTODOLIST = "getInstancesActivityTodoList";
		public static final String GETACTIVITYDONELIST = "getActivityDoneList";
		public static final String GETALLUSERS = "getAllUsers";
		public static final String GETACTIVITYLIST = "getActivityList";
		public static final String GETTODOLIST = "getToDoList";
		public static final String GETPROJECTS = "getProjects";

	}

	// BnEdge constants
	public interface Ed {
		public static final int INITIAL = 0;
		public static final int ACTIVE = 1;
		public static final int ANTICIPATING = 2;
		public static final int DEAD = 3;

		public static final String[] edgeStateName =
			{ "INITIAL", "ACTIVE", "ANTICIPATING", "DEAD" };

	}

	// BnAgent constants
	public interface Ag {
	    public static final int INACTIVE = 0;
	    public static final int ACTIVE = 1;

	    public static final String[] agentStateName =
			{ "INACTIVE", "ACTIVE"};

	    public static final int ALARM = 0;

	}

	// BnNode constants
	public interface Nd {

		// BnNode states
		public static final int INITIAL = 0;
		public static final int READY = 1;
		public static final int DEAD = 2;
		public static final int ANTICIPABLE = 3;
		public static final int EXPIRED = 4;
		public static final int ANTICIPATING = 5;
		public static final int EXECUTING = 6;
		public static final int EXECUTED = 7;
		public static final int INERROR = 8;
		public static final int FINISHED = 9;
		public static final int TERMINATED = 10;
		public static final int CHECKEDOUT = 11;
		public static final int ANT_SUSPENDED = 12;
		public static final int EXEC_SUSPENDED = 13;
		public static final int BAD_TRANSITION = 14;

		public static final String[] nodeStateName =
			{
				"INITIAL",
				"READY",
				"DEAD",
				"ANTICIPABLE",
				"EXPIRED",
				"ANTICIPATING",
				"EXECUTING",
				"EXECUTED",
				"INERROR",
				"FINISHED",
				"TERMINATED",
				"CHECKEDOUT",
				"ANT_SUSPENDED",
				"EXEC_SUSPENDED",
				"BAD_TRANSITION" };

		// BnNode types

		public static final int AND_JOIN_NODE = 1;
		public static final int OR_JOIN_NODE = 2;
		public static final int AND_JOIN_AUTOMATIC_NODE = 3;
		public static final int OR_JOIN_AUTOMATIC_NODE = 4;
		public static final int SUB_PROCESS_NODE = 5;

		public static final String[] nodeTypeName =
			{
				"NULL_NODE",
				"AND_JOIN_NODE",
				"OR_JOIN_NODE",
				"AND_JOIN_AUTOMATIC_NODE",
				"OR_JOIN_AUTOMATIC_NODE",
				"SUB_PROCESS_NODE",
				};

		// Operations

		public static final int START = 0;
		public static final int TERMINATE = 1;
		public static final int SUSPEND = 2;
		public static final int RESUME = 3;
		public static final int EDGEINITIAL = 4;
		public static final int ANTACTIVE = 5;
		public static final int ACTIVE = 6;
		public static final int CANCEL = 7;

		public static final String[] operationName =
			{
				"START",
				"TERMINATE",
				"SUSPEND",
				"RESUME",
				"EDGEINITIAL",
				"ANTACTIVE",
				"ACTIVE",
				"CANCEL" };

		// Events
		public static final String BEFORESTART = "beforeStart";
		public static final String AFTERSTART = "afterStart";
		public static final String BEFORETERMINATE = "beforeTerminate";
		public static final String AFTERTERMINATE = "afterTerminate";
		public static final String ONCANCEL = "onCancel";
		public static final String ANTICIPATE = "anticipate";
		public static final String ONDEADLINE = "onDeadline";
		public static final String ONREADY = "onReady";

		// Operations mode

		public static final int AUTOMATIC = 0;
		public static final int NO_AUTOMATIC = 1;

		public static final String[] operationMode =
			{ "AUTOMATIC", "NO_AUTOMATIC" };

		// BnNode property
		public static final int TRADITIONAL = 0;
		public static final int FLEXIBLE = 1;

		public static final String[] executionMode =
			{ "TRADITIONAL", "FLEXIBLE" };
	}

	public static int[][] edgeTransition = {
	    {
		Ed.DEAD, // DEAD
		Ed.DEAD, // DEAD
		Ed.DEAD, // DEAD
		Ed.DEAD, // DEAD
		Ed.DEAD, // DEAD
		Ed.DEAD, // DEAD
		Ed.DEAD, // DEAD
		Ed.DEAD, // DEAD
		Ed.DEAD, // DEAD
		Ed.DEAD, // DEAD
		Ed.DEAD, // DEAD
		Ed.DEAD, // DEAD
		Ed.DEAD, // DEAD
		Ed.DEAD, // DEAD
	    },{
		Ed.INITIAL, //INITIAL
		Ed.INITIAL, // READY
		Ed.DEAD, // DEAD
		Ed.INITIAL, //ANTICIPABLE
		Ed.DEAD, // EXPIRED
		Ed.ANTICIPATING, // ANTICIPATING
		Ed.ANTICIPATING, // EXECUTING
		Ed.ACTIVE, // EXECUTED
		Ed.DEAD, // INERROR
		Ed.ACTIVE, // FINISHED
		Ed.ACTIVE, // TERMINATED
		Ed.ACTIVE, // CHECKEDOUT
		Ed.ANTICIPATING, // ANT SUSPENDED
		Ed.ANTICIPATING, // EXEC_SUSPENDED
	    }
	};
	public static final String AFTERSTART = "import hero.interfaces.*;\n"
																+ "import hero.interfaces.BnNodeLocal;\n"
																+ "afterStart (Object b,Object n) {\n\n\n"
																+ "}";

	public static final String BEFORESTART = "import hero.interfaces.*;\n"
																+ "import hero.interfaces.BnNodeLocal;\n"
																+ "beforeStart (Object b,Object n) {\n\n\n"
																+ "}";

	public static final String AFTERTERMINATE = "import hero.interfaces.*;\n"
																+ "import hero.interfaces.BnNodeLocal;\n"
																+ "afterTerminate (Object b,Object n) {\n\n\n"
																+ "}";

	public static final String BEFORETERMINATE = "import hero.interfaces.*;\n"
																+ "import hero.interfaces.BnNodeLocal;\n"
																+ "beforeTerminate (Object b,Object n) {\n\n\n"
																+ "}";

	public static final String ONCANCEL = "import hero.interfaces.*;\n"
																+ "import hero.interfaces.BnNodeLocal;\n"
																+ "onCancel (Object b,Object n) {\n\n\n"
																+ "}";

	public static final String ANTICIPATE = "import hero.interfaces.*;\n"
																+ "import hero.interfaces.BnNodeLocal;\n"
																+ "anticipate (Object b,Object n) {\n\n\n"
																+ "}";

	public static final String ONDEADLINE = "import hero.interfaces.*;\n"
		+ "import hero.interfaces.BnNodeLocal;\n"
		+ "onDeadline (Object b,Object n) {\n\n\n"
		+ "}";

	public static final String ONREADY = "import hero.interfaces.*;\n"
		+ "import hero.interfaces.BnNodeLocal;\n"
		+ "onReady (Object b,Object n) {\n\n\n"
		+ "}";
}
