 /*
* 02/01/2002 - 15:24:07
*
* NotificationBean.java - 
* Copyright (C) 2002 Ecoo Team
* charoy@loria.fr
* 
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

package hero.message;

// MDB imports
import hero.interfaces.BnUserLocal;
import hero.interfaces.BnUserPropertyLocal;
import hero.interfaces.BnProjectLocal;
import hero.interfaces.BnProjectLocalHome;
import hero.interfaces.BnProjectUtil;
import hero.interfaces.UserServiceUtil;
import hero.util.EventConstants;
import hero.interfaces.UserServiceLocalHome;
import hero.interfaces.UserServiceLocal;


import java.util.Collection;
import java.util.Iterator;
import java.util.List;
import java.util.ArrayList;
import java.util.Map;

import javax.ejb.EJBException;
import javax.ejb.MessageDrivenBean;
import javax.ejb.MessageDrivenContext;
import javax.jms.Message;
import javax.jms.MessageListener;

import hero.util.MailNotification;

import javax.management.MBeanServer;
import javax.management.MBeanServerFactory;
import javax.management.ObjectName;


/**
 * This is a Message Driven Bean
 *
 * @ejb:message-driven
 * @ejb:bean name="NotificationBean"
 *           transaction-type="Container"
 *           acknowledge-mode="Auto-acknowledge"
 *           destination-type="javax.jms.Topic"
 *           subscription-durability="NonDurable"
 *
 * @jboss:destination-jndi-name name="topic/testTopic"
 * @ejb.security-identity run-as="SuperAdmin"
 * @ejb.permission unchecked="yes"   
 * 
 * 
 * @jonas.message-driven-destination jndi-name="testTopic"
 * @jonas.bean  ejb-name="NotificationBean"    
 *              jndi-name="testTopic"
 * @ejb.transaction type= "NotSupported"
 *
 * @jboss.container-configuration name="Standard Message Driven Bean for Bonita" 
 *
 * @author $Author: brice $
 * @version $Revision: 1.12 $
 */

public class NotificationBean implements MessageDrivenBean, MessageListener{  

    //private MessageDrivenContext ctx = null;
    private transient MessageDrivenContext ctx;
	private MailNotification mailNotif = new MailNotification();
   
    private void sendJabber(String toAccount, String subject, String message) throws Exception{ 
	ObjectName jabber = new ObjectName("bonita:type=bonitaservice,name=Jabber");
	List list = MBeanServerFactory.findMBeanServer(null);
	MBeanServer mServer = (MBeanServer)list.iterator().next();
	Object id = (Object) mServer.invoke( jabber,
						 "sendMessage",
						 new Object[] { 
						     toAccount, //JID 
						     null  ,    //Resource
						     subject,   //Subject
						     message    //message
						 },
						 new String[] {
						     "".getClass().getName(),
						     "".getClass().getName(), 
						     "".getClass().getName(), 
						     "".getClass().getName()
						 }
					      );
    }


    public void setMessageDrivenContext(MessageDrivenContext ctx) throws EJBException
    {
    	this.ctx = ctx;
    }

    private Collection usersRegistered(String project, String event) throws Exception {
    	try{
    		BnProjectLocalHome phome=BnProjectUtil.getLocalHome();
    		BnProjectLocal plocal = phome.findByName(project);
    		if (plocal!=null)
    			return (plocal.getBnUsers());
    		else
    			return(new ArrayList());
    	}catch(Exception usersRegistered) {
    		Collection users = new ArrayList();
    		return (users);
    	}
    } 

    public void ejbCreate()
    { 
    }

    public void ejbRemove() 
    { 
	//    	ctx=null;
    }
    
    public void onMessage(Message message)
    {
      /* TODO This code has been commented out because of its bad performances.
              When rewritten, we should take into account the fact that 
              usersRegistered might return non human users such as SuperAdmin
              and therefore ul.getUserInfos() should not be called in that case.
	BnUserLocal mUser;
	UserServiceLocalHome ushome;
	UserServiceLocal ul;
	try{
		ushome = UserServiceUtil.getLocalHome();
		ul=ushome.create();			
		
	    String event= (String)message.getObjectProperty(EventConstants.EVENT);
	    String projectName = (String)message.getObjectProperty(EventConstants.PROJECTNAME);
	    if((event.equalsIgnoreCase(EventConstants.START) || event.equalsIgnoreCase(EventConstants.TERMINATED))&&!event.equalsIgnoreCase(EventConstants.DELETEPROJECT)){
		Collection c=usersRegistered(projectName,event);
		for(Iterator i=c.iterator();i.hasNext();){
		    mUser=(BnUserLocal)i.next();
		    Map infos = ul.getUserInfos(mUser.getName());
		    Collection props=mUser.getBnProperties();
		    for(Iterator it=props.iterator();it.hasNext();){
			BnUserPropertyLocal pValue= (BnUserPropertyLocal)it.next();
			if((pValue.getTheKey()).equalsIgnoreCase(event+"Mail") && pValue.getTheValue()!= null){
				if(infos.get("email")!=null)
				mailNotif.sendMail((String)infos.get("email"),"Event Notification","BnProject:"+projectName+" Event:"+event);
			}
			if((pValue.getTheKey()).equalsIgnoreCase(event+"Jabber") && pValue.getTheValue()!= null ){
				if(infos.get("jabber")!=null){				    
					sendJabber((String)infos.get("jabber"),"Event Notification","Event Notification:"+projectName+" Event:"+event);
			    }
			}    
		    }
		}
	    }  
	}catch(Exception e1){
		ctx.setRollbackOnly();
		e1.printStackTrace();}
    */
    }
    
}
