/**
 *
 * Bonita
 * Copyright (C) 1999 Bull S.A.
 * Bull 68 route de versailles  78434 Louveciennes Cedex France
 * Further information: bonita@objectweb.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 *
--------------------------------------------------------------------------
 * $Id: PerformerAssign.java,v 1.1 2004/07/30 14:57:58 mvaldes Exp $
 *
--------------------------------------------------------------------------
 */

package hero.performerAssign;

import hero.interfaces.BnNodeLocal;
import hero.util.HeroException;
import java.io.Serializable;

public abstract class PerformerAssign implements Serializable{


    public static final int CALLBACK=0;
	public static final int PROPERTY=1;
	
    private String name;
    private int type;

    public static PerformerAssign make(String name, int type) throws HeroException {
	if (type==CALLBACK) return new CallbackPerformerAssign(name,type);
	if (type==PROPERTY) return new PropertyPerformerAssign(name,type);
	throw new HeroException("Wrong PerformerAssign Type " + type);
    }

    protected PerformerAssign(String name, int type) {
	this.name=name;
	this.type=type;
    }

    public String getName() {return this.name;}
    public void setName(String name) {this.name=name;}

    public int getType() {return this.type;}
    public void setType(int type) {this.type=type;}

    public String toXML() {
	String result=new String();
	result="<performerAssign name=\""+this.getName()+
	    "\" type=\""+this.getType()+"\"/>";
	return result;
    }

    public abstract void execute(Object bean, int type, BnNodeLocal role, String userName) throws HeroException;

}
