/**
 *
 * Bonita
 * Copyright (C) 1999 Bull S.A.
 * Bull 68 route de versailles  78434 Louveciennes Cedex France
 * Further information: bonita@objectweb.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 *
--------------------------------------------------------------------------
 * $Id: PropertyPerformerAssign.java,v 1.2 2005/11/16 22:31:59 brice Exp $
 *
--------------------------------------------------------------------------
 */

package hero.performerAssign;

import hero.interfaces.BnNodeLocal;
import hero.util.HeroException;

import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;

import org.apache.log4j.Category;

public class PropertyPerformerAssign extends PerformerAssign {

    // Utility variable
    private static final Category log = Category.getInstance(PropertyPerformerAssign.class);


    public PropertyPerformerAssign(String name, int type) {
	super(name,type);
    }

    public void execute(Object bean, int type, BnNodeLocal node, String userName) throws HeroException {
	log.debug("execute: type="+type+" node="+node.getName());
		
	try {    
		Class clperformerAssign=Class.forName("hero.performerAssign.PropertySelectActors", true, Thread.currentThread().getContextClassLoader());
	    NodePerformerAssignI ndh =(NodePerformerAssignI)clperformerAssign.newInstance();
	    Class[] param={
		Class.forName("java.lang.Object"),
		Class.forName("hero.interfaces.BnNodeLocal", true, Thread.currentThread().getContextClassLoader()),
		Class.forName("java.lang.String")};
	    Method evth=clperformerAssign.getMethod("selectActors",param);
	    Object[] o={bean,node,userName};
	    evth.invoke(ndh,o);
	} catch (InvocationTargetException ite) {
		ite.printStackTrace();
	    throw new HeroException("Failure during performerAssign execution : " + ite.getMessage());
	} catch (Exception e) {
	    throw new HeroException("Dynamic invocation of performerAssign failed :"+this.getName()+" Node:"+node.getName()+"--> performerAssign type = "+type+" ///"+e);
	}
    }


}
