package hero.user;

import hero.util.HeroHookException;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Properties;
import java.io.File;
import java.io.FileInputStream;
import java.lang.reflect.InvocationTargetException;

/**
 * @author charoy 27 avr. 2004 - UserBaseService.java This program is free
 *         software; you can redistribute it and/or modify it under the terms of
 *         the GNU Lesser General Public License as published by the Free
 *         Software Foundation; either version 2 of the License, or (at your
 *         option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, write to the Free Software Foundation, Inc.,
 * 675 Mass Ave, Cambridge, MA 02139, USA.
 */

public class UserBaseService {
	private ArrayList userbases;
	static private UserBaseService ubs=null;
	
	private UserBaseService() {
		userbases=new ArrayList();
		ArrayList result = new ArrayList();
		try {
		  Properties usersProps = new Properties();		
		  ReadEnv re = new ReadEnv();
    	  String bonitaHome=re.getVariable("BONITA_HOME");
		  usersProps.load(new FileInputStream(bonitaHome+File.separator+".ant.properties"));
		  result.add(constructor((String)usersProps.getProperty("user.base")));
		  userbases=result;		  
		  if (result.isEmpty())
		  {
		  	result.add(new DefaultUserBase());
			userbases=result;
		  }
	  }catch(Exception userEx){
	  	result.add(new DefaultUserBase());
		userbases=result;
	  	userEx.printStackTrace();}
	}
		
	 public Object constructor(String name) throws HeroHookException {
		try {
			ClassLoader cl = Thread.currentThread().getContextClassLoader();
		    Class clName=cl.loadClass(name);
		    Class[] o={};
		    java.lang.reflect.Constructor cons = clName.getConstructor(o);
		    return(cons.newInstance((Object[])o));
		} catch (Exception ite) {ite.getCause().printStackTrace();
			throw new HeroHookException("Dynamic invocation failed :"+ite.getCause().getMessage());
	    }	
	 }
	
	public static UserBaseService getInstance() {
		if (ubs!=null) {
			return ubs;
		} else {
			ubs=new UserBaseService();
			return ubs;
		}
	}
	
	public Collection getUserBases() {
		return userbases;
	}
}
