package hero.util;

/*
 *
 * Bonita
 * Copyright (C) 1999 Bull S.A.
 * Bull 68 route de versailles  78434 Louveciennes Cedex France
 * Further information: bonita@objectweb.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 *
 --------------------------------------------------------------------------
 * $Id$
 *
 --------------------------------------------------------------------------
 */

/**
 * This class works on the server and provides method to retrieve information
 * specific to the server type, ie JOnAS, JBoss.
 */

public class ServerType
{
	private static final String jonasDir =
		(String) System.getProperties().get("jonas.base");
	private static final String jbossDir =
		(String) System.getProperties().get("jboss.home.dir");
	
	public static boolean isJonas()
	{
		return jonasDir != null;
	}
	
	public static boolean isJBoss()
	{
		return jbossDir != null;
	}
	
	public static String getServerBase()
	{
		if(isJonas())
		{
			return jonasDir;
		}
		else if(isJBoss())
		{
			return jbossDir;
		}
		
		throw new RuntimeException("The server base is not found.");
	}
}
