/*
*
* StrutsEdgeValue.java - 
* Copyright (C) 2002 Ecoo Team
* valdes@loria.fr
* 
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/


package hero.util;

import java.io.Serializable;

public final class StrutsEdgeValue implements Serializable, java.lang.Cloneable {

    // --------------------------------------------------- Instance Variables

    /**
     * The name of the node
     */
    private String name = null;

    /**
     * The state of the node
     */
    private String state = null;

    /**
     * The in node
     */
    private String inNode = null;

    /**
     * The out node
     */
    private String outNode = null;

    // ----------------------------------------------------------- Properties

    /**
     * Get the name
     *@return String 
     */
    public String getName() {
    	return (name);
    }

    /**
     * Set the name.
     * @param name
     */
    public void setName(String name) {
        this.name = name;
    }

    /**
     * Get the state
     *@return String 
     */
    public String getState() {
    	return (state);
    }

    /**
     * Set the state.
     * @param state
     */
    public void setState(String state) {
        this.state = state;
    }

    /**
     * Get the in node
     *@return String 
     */
    public String getInNode() {
    	return (inNode);
    }

    /**
     * Set the in node.
     * @param inNode
     */
    public void setInNode(String inNode) {
        this.inNode = inNode;
    }

    /**
     * Get the out node
     *@return String 
     */
    public String getOutNode() {
    	return (outNode);
    }

    /**
     * Set the out node.
     * @param outNode
     */
    public void setOutNode(String outNode) {
        this.outNode = outNode;
    }


    public StrutsEdgeValue(){}

    public Object clone() throws java.lang.CloneNotSupportedException{
	return super.clone();
    }

}
