/*
*
* StrutsNodeValue.java - 
* Copyright (C) 2002 Ecoo Team
* valdes@loria.fr
* 
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/


package hero.util;

import java.io.Serializable;

public final class StrutsNodeValue implements Serializable, java.lang.Cloneable {

    // --------------------------------------------------- Instance Variables


    /**
     * The name of the project
     */
    private String projectName = null;

    /**
     * The name of the node
     */
    private String name = null;

    /**
     * The creator of the node
     */
    private String creator = null;

    /**
     * The state of the node
     */
    private String state = null;

    /**
     * The role of the node
     */
    private String role = null;

    /**
     * The type of the node
     */
    private String type = null;

    /**
     * If this node is anticipable 
     */
    private boolean anticipable = true ;

    /**
     * The deadline of the node
     */
    private String deadline = "Deadline needed";

    /**
     * The description of the node
     */
    private String description = "Not description yet";

    /**
     * The executor of the node
     */
    private String executor = "This activity is not executing";


    // ----------------------------------------------------------- Properties

    /**
     * Get the project name
     *@return String 
     */
    public String getProjectName() {
    	return (projectName);
    }

    /**
     * Set the project name.
     * @param projectName
     */
    public void setProjectName(String projectName) {
        this.projectName = projectName;
    }

    /**
     * Get the name
     *@return String 
     */
    public String getName() {
    	return (name);
    }

    /**
     * Set the name.
     * @param name
     */
    public void setName(String name) {
        this.name = name;
    }

    /**
     * Get the creator
     *@return String 
     */
    public String getCreator() {
    	return (creator);
    }

    /**
     * Set the creator.
     * @param creator
     */
    public void setCreator(String creator) {
        this.creator = creator;
    }

    /**
     * Get the state
     *@return String 
     */
    public String getState() {
    	return (state);
    }

    /**
     * Set the state.
     * @param state
     */
    public void setState(String state) {
        this.state = state;
    }

    /**
     * Get the type
     *@return String 
     */
    public String getType() {
    	return (type);
    }

    /**
     * Set the type.
     * @param type
     */
    public void setType(String type) {
        this.type = type;
    }

    /**
     * Get the role
     *@return String 
     */
    public String getRole() {
    	return (role);
    }

    /**
     * Set the role.
     * @param role
     */
    public void setRole(String role) {
        this.role = role;
    }

    /**
     * Get the anticipable property
     *@return boolean 
     */
    public boolean getAnticipable() {
    	return (anticipable);
    }

    /**
     * Set the anticipable property
     * @param anticipable
     */
    public void setAnticipable(boolean anticipable) {
        this.anticipable = anticipable;
    }

    /**
     * Get the deadline of the activity
     *@return String 
     */
    public String getDeadline() {
    	return (deadline);
    }

    /**
     * Set the deadline of the activity
     * @param deadline
     */
    public void setDeadline(String deadline) {
        this.deadline = deadline;
    }

    /**
     * Get the description of the activity
     *@return String 
     */
    public String getDescription() {
    	return (description);
    }

    /**
     * Set the description of the activity
     * @param description
     */
    public void setDescription(String description) {
        this.description = description;
    }

    /**
     * Get the executor of the activity
     *@return String 
     */
    public String getExecutor() {
    	return (executor);
    }

    /**
     * Set the executor of the activity
     * @param executor
     */
    public void setExecutor(String executor) {
        this.executor = executor;
    }

    public StrutsNodeValue(){}

    public Object clone() throws java.lang.CloneNotSupportedException{
	return super.clone();
    }

}
