/*
*
* StrutsProjectValue.java - 
* Copyright (C) 2002 Ecoo Team
* valdes@loria.fr
* 
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/


package hero.util;

import java.io.Serializable;

public final class StrutsProjectValue implements Serializable, java.lang.Cloneable {

    // --------------------------------------------------- Instance Variables

    /**
     * The name of the project
     */
    private String name = null;

    /**
     * The creator of the project
     */
    private String creator = null;

    /**
     * The state of the project
     */
    private String state = null;

    /**
     * The number of activities of the project
     */
    private int nact = 0 ;

    /**
     * The number of users of the project
     */
    private int nusers = 0;

    // ----------------------------------------------------------- Properties

    /**
     * Get the name
     *@return String 
     */
    public String getName() {
    	return (name);
    }

    /**
     * Set the name.
     * @param name
     */
    public void setName(String name) {
        this.name = name;
    }

    /**
     * Get the creator
     *@return String 
     */
    public String getCreator() {
    	return (creator);
    }

    /**
     * Set the creator.
     * @param creator
     */
    public void setCreator(String creator) {
        this.creator = creator;
    }

    /**
     * Get the state
     *@return String 
     */
    public String getState() {
    	return (state);
    }

    /**
     * Set the state.
     * @param state
     */
    public void setState(String state) {
        this.state = state;
    }

    /**
     * Get the number of activities
     *@return int 
     */
    public int getNact() {
    	return (nact);
    }

    /**
     * Set the number of activities.
     * @param nact
     */
    public void setNact(int nact) {
        this.nact = nact;
    }

    /**
     * Get the number of users
     *@return int 
     */
    public int getNusers() {
    	return (nusers);
    }

    /**
     * Set the number of users.
     * @param nusers
     */
    public void setNusers(int nusers) {
        this.nusers = nusers;
    }

    public StrutsProjectValue(){}

    public Object clone() throws java.lang.CloneNotSupportedException{
	return super.clone();
    }

}
