package hero.util;

import java.io.Serializable;

import hero.util.HeroException;
import javax.ejb.Timer;

public class TimerData implements Serializable {

		   protected String _type;
		   protected long _ms;

		   public TimerData(String type, long ms) {
		      _type = type;
		      _ms = ms;
		   }

		   public String getType() {
		      return _type;
		   }

		   public long getMs() {
		      return _ms;
		   }

		   protected void setType(String type) {
		      _type = type;
		   }

		   protected void setMs(long ms) {
		      _ms = ms;
		   }

		   public void onStart(Timer t) throws HeroException {
			  // not used at now
		      System.out.println("----------> TimerData: starting Timer " + getType() + " date = " + getMs());
		   }

		   public void onStop(Timer t) throws HeroException {
		      //System.out.println("----------> TimerData: Stopping timer " + getType());
		      try {
		         t.cancel();
		      } catch (Exception e) {
		         throw new HeroException(e.getMessage());
		      }
		   }

		   public void onTimeout(Timer t) throws HeroException {
			  // not used at now.
		      System.out.println("----------> TimerData: Timer " + getType() + " timed out !!!!!! ");
		   }
}
