
package hero.util.values;


import java.io.Serializable;
import java.util.Collection;
import java.util.ArrayList;

public final class BonitaNodeValue implements Serializable {

    // --------------------------------------------------- Instance Variables

    private String projectName = null;
    
    private String projectParent = null;      

    private String name = null;

    private String creator = null;
    
    private String reference = null;

    private String state = null;

    private String role = null;

    private int type;

    private boolean anticipable = false ;
    
    private Collection deadlines = new ArrayList();
    
    private Collection relativeDeadlines= new ArrayList();
    
    private Collection properties= new ArrayList();
    
    private Collection hooks = new ArrayList();
    
    private Collection interHooks = new ArrayList();
    
    private Collection inEdges = new ArrayList();
    
    private Collection outEdges = new ArrayList();
    
    private String description = "Not description yet";

    private String executor = "This activity is not executing";
    
    private BonitaPerformerValue performer = null;


    // ----------------------------------------------------------- Properties

    public String getProjectName() {
    	return (projectName);
    }

    public void setProjectName(String projectName) {
        this.projectName = projectName;
    }
    
    public String getProjectParent() {
    	return (projectParent);
    }

    public void setProjectParent(String projectParent) {
        this.projectParent = projectParent;
    }

    public Collection getInEdges() {
    	return (inEdges);
    }

    public void setInEdges(Collection inEdges) {
        this.inEdges = inEdges;
    }
    
    public Collection getOutEdges() {
    	return (outEdges);
    }

    public void setOutEdges(Collection outEdges) {
        this.outEdges = outEdges;
    }
    
     public String getName() {
    	return (name);
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getCreator() {
    	return (creator);
    }

    public void setCreator(String creator) {
        this.creator = creator;
    }
    
    public String getReference() {
    	return (reference);
    }

    public void setReference(String reference) {
        this.reference = reference;
    }

    public String getState() {
    	return (state);
    }

    public void setState(String state) {
        this.state = state;
    }

    public int getType() {
    	return (type);
    }

    public void setType(int type) {
        this.type = type;
    }

    public String getRole() {
    	return (role);
    }

    public void setRole(String role) {
        this.role = role;
    }

    public boolean getAnticipable() {
    	return (anticipable);
    }

    public void setAnticipable(boolean anticipable) {
        this.anticipable = anticipable;
    }

    public Collection getDeadlines() {
    	return (deadlines);
    }

    public void setDeadlines(Collection deadlines) {
        this.deadlines = deadlines;
    }
    
    public Collection getRelativeDeadlines() {
    	return (relativeDeadlines);
    }

    public void setRelativeDeadlines(Collection relativeDeadlines) {
        this.relativeDeadlines = relativeDeadlines;
    }
    
    public Collection getProperties() {
    	return (properties);
    }

    public void setProperties(Collection properties) {
        this.properties = properties;
    }

    public Collection getHooks() {
    	return (this.hooks);
    }

    public void setHooks(Collection hooks) {
        this.hooks = hooks;
    }

    public Collection getInterHooks() {
    	return (this.interHooks);
    }

    public void setInterHooks(Collection interHooks) {
        this.interHooks = interHooks;
    }
    
    
    public String getDescription() {
    	return (description);
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public String getExecutor() {
    	return (executor);
    }

    public void setExecutor(String executor) {
        this.executor = executor;
    }

    public BonitaPerformerValue getPerformer() {
    	return (performer);
    }

    public void setPerformer(BonitaPerformerValue performer) {
        this.performer = performer;
    }

    
    public BonitaNodeValue(){}

}
