package hero.xpdl;

import org.xml.sax.ErrorHandler;
import org.xml.sax.SAXException;
import org.xml.sax.SAXParseException;

/**
 * Define an error handler which throw an exception
 * as Digester not (only print stack trace).
 * Security service use this handler for throwing/catching in
 * a convenient way the xml parsing error of jonas-realm.xml file.
 */
public class JErrorHandler implements ErrorHandler {

    /**
     * Receive notification of a warning.
     * @param exception exception to throw
     * @throws SAXException if an error is thrown
     */
    public void warning(SAXParseException exception) throws SAXException {

    }

    /**
     * Receive notification of a recoverable error.
     * @param exception exception to throw
     * @throws SAXException if an error is thrown
     */
    public void error(SAXParseException exception) throws SAXException {
        throw exception;
    }

    /**
     * Receive notification of a non-recoverable error.
     * @param exception exception to throw
     * @throws SAXException if an error is thrown
     */
    public void fatalError(SAXParseException exception) throws SAXException {
        throw exception;
    }
}
