package hero.xpdl;

/**
*
* Bonita
* Copyright (C) 1999 Bull S.A.
* Bull 68 route de versailles  78434 Louveciennes Cedex France
* Further information: bonita@objectweb.org
*
* This library is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or any later version.
*
* This library is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this library; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
* USA
*
*
--------------------------------------------------------------------------
* $Id: XPDLActivity.java,v 1.4 2007/06/20 12:01:00 blachonm Exp $
*
--------------------------------------------------------------------------
*/

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Hashtable;


public final class XPDLActivity implements Serializable, java.lang.Cloneable {

    // --------------------------------------------------- Instance Variables

    private String name = "";
    private String id = "";
    private String description = "";
    private String mode = "";
    private String split = "";
    private String join = "";
    private String performer = "";
    private boolean deadline = false;
    private ArrayList deadlineExecution = new ArrayList();
    private ArrayList deadlineCondition = new ArrayList();
    private ArrayList deadlineFixedTimes = new ArrayList();
    private ArrayList deadlineRelativeTimes = new ArrayList();
    private ArrayList properties = new ArrayList();
    private ArrayList propagations = new ArrayList();
    private String exceptionName = "";
    private ArrayList xpdlHooks = new ArrayList();
    private String performerAssignName = "";
    private String performerAssignType = "";
    private String performerAssignProperty = "";
    private ArrayList actualParameters = new ArrayList();
    //patch defect #307177 iteration: 1 multiple per activity
    /*
    private String iterationName = "";
    private String iterationCondition = "";
    private String iterationFrom = "";
    private String iterationTo = "";
    */
    private Hashtable iteration = new Hashtable();
    private String tempIterationCondition = "";

    private String implementation = "";
    private String subFlowVersion = "";
    private String subFlowName = "";



    // ----------------------------------------------------------- Properties

    public String getName() {
    	return (name);
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getId() {
    	return (id);
    }

    public void setId(String id) {
        this.id = id;
    }

    public String getMode() {
    	return (mode);
    }

    public void setMode(String mode) {
        this.mode = mode;
    }

    public String getDescription() {
    	return (description);
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public String getSplit() {
    	return (split);
    }

    public void setSplit(String split) {
        this.split = split;
    }

    public String getJoin() {
    	return (join);
    }

    public void setJoin(String join) {
        this.join = join;
    }

    public String getPerformer() {
    	return (performer);
    }

    public void setPerformer(String performer) {
        this.performer = performer;
    }

    public boolean getDeadline() {
    	return (deadline);
    }

    public void setDeadline(boolean deadline) {
        this.deadline = deadline;
    }

    public ArrayList getDeadlineExecution() {
    	return (deadlineExecution);
    }

    public void setDeadlineExecution(String deadlineExecution) {
        this.deadlineExecution.add(deadlineExecution);
    }

    // deadline condition
    public ArrayList getDeadlineCondition() {
    	return (deadlineCondition);
    }

    public void setDeadlineCondition(String deadlineCondition) {
        this.deadlineCondition.add(deadlineCondition);
    }

    // fixed deadline
    public ArrayList getFixedTimeDeadline() {
    	return (deadlineFixedTimes);
    }

    public void setFixedTimeDeadline(String deadlineTime) {
        this.deadlineFixedTimes.add(new Long(deadlineTime));
    }

    // relative deadline
    public ArrayList getRelativeTimeDeadline() {
    	return (deadlineRelativeTimes);
    }

    public void setRelativeTimeDeadline(String deadlineTime) {
        this.deadlineRelativeTimes.add(new Long(deadlineTime));
    }

    // extended Bonita properties : contains Ids of the datafields to be created
    public ArrayList getProperties() {
    	return (properties);
    }

    public void setProperties(String datafieldId) {
        this.properties.add(datafieldId);
    }

    //  Complexe type for Extended Bonita properties :
    public ArrayList getPropagations() {
    	return (propagations);
    }

    public void setPropagations(Boolean bool) {
        this.propagations.add(bool);
    }

    // Exception
    public String getExceptionName() {
    	return (exceptionName);
    }

    public void setExceptionName(String exceptionName) {
        this.exceptionName = exceptionName;
    }

    //  hook bean feature
    public ArrayList getXpdlHook() {
    	return (xpdlHooks);
    }

    public void setXpdlHook(XPDLHook xpdlHook) {
        this.xpdlHooks.add(xpdlHook);
    }

    // performer Assignment
    public String getPerformerAssignName() {
    	return (performerAssignName);
    }

    public void setPerformerAssignName(String performerAssignName) {
        this.performerAssignName = performerAssignName;
    }

    public String getPerformerAssignType() {
    	return (performerAssignType);
    }

    public void setPerformerAssignType(String performerAssignType) {
        this.performerAssignType = performerAssignType;
    }

    public String getPerformerAssignProperty() {
    	return (performerAssignProperty);
    }

    public void setPerformerAssignProperty(String performerAssignProperty) {
        this.performerAssignProperty = performerAssignProperty;
    }

    //  ActualParameters
    public ArrayList getActualParameter() {
    	return (actualParameters);
    }

    public void setActualParameter(String actualParameter) {
        this.actualParameters.add(actualParameter);
    }

    // tempIterationCondition
    public String getTempIterationCondition() {
    	return (tempIterationCondition);
    }

    public void setTempIterationCondition(String tempIterationCondition) {
        this.tempIterationCondition = tempIterationCondition;
    }

    public Hashtable getIteration() {
    	return (iteration);
    }

    public void setIteration(String iterationTo, String iterationCondition) {
        this.iteration.put(iterationTo, iterationCondition);
    }

    //  implementation
    public String getImplementation() {
    	return (implementation);
    }

    public void setImplementation(String implementation) {
        this.implementation = implementation;
    }

    // subflowVersion
    public String getSubFlowVersion() {
    	return (subFlowVersion);
    }

    public void setSubFlowVersion(String subFlowVersion) {
        this.subFlowVersion = subFlowVersion;
    }

    //  subflowName
    public String getSubFlowName() {
        return (subFlowName);
    }

    public void setSubFlowName(String subFlowName) {
        this.subFlowName = subFlowName;
    }

    public XPDLActivity(){}

    public Object clone() throws java.lang.CloneNotSupportedException{
	return super.clone();
    }

}
