package hero.xpdl;

/**
*
* Bonita
* Copyright (C) 1999 Bull S.A.
* Bull 68 route de versailles  78434 Louveciennes Cedex France
* Further information: bonita@objectweb.org
*
* This library is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or any later version.
*
* This library is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this library; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
* USA
*
*
--------------------------------------------------------------------------
* $Id: XPDLApplication.java,v 1.1 2006/06/06 08:16:08 mvaldes Exp $
*
--------------------------------------------------------------------------
*/

import java.io.Serializable;
import java.util.ArrayList;

public final class XPDLApplication implements Serializable, java.lang.Cloneable {

    // --------------------------------------------------- Instance Variables

    private String name = "";
    private String id = "";
    // formalParams contains "Index" as Key and "Id" as value of the Hashtable
    private ArrayList formalParams = new ArrayList();
    //field containing either : projectName, either the cste : PACKAGE_LEVEL
    private String projectName = "";
    
    
    // ----------------------------------------------------------- Properties
    
    public String getName() {
    	return (name);
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getId() {
    	return (id);
    }

    public void setId(String id) {
        this.id = id;
    }
    
    // projectName (or "Package_level")
    // to prevent an application defined within a WFProcess does not be used within others WFProcess
    public String getProjectName() {
    	return (projectName);
    }

    public void setProjectName(String projectName) {
        this.projectName = projectName;
    }
    
    // Formal parameters
    // Key = Id  Value = XPDLFormalParameter
    public ArrayList getFormalParam() {
    	return (formalParams);
    }

    public void setFormalParam(XPDLFormalParameter xpdlFormalParameter) {
        this.formalParams.add(xpdlFormalParameter);
    }
        
    public XPDLApplication(){}

    public Object clone() throws java.lang.CloneNotSupportedException{
	return super.clone();
    }

}
