/*
*
* XPDLConstants.java -
* Copyright (C) 2003 Ecoo Team
* valdes@loria.fr
*
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

package hero.xpdl;


public interface XPDLConstants
{

	 //Separator into the activitySetMapping value: %#%
	 public static final String ACT_SET_MAP_SEPARATOR="\u0025\u0023\u0025";
	 public static final int ACT_SET_MAP_SEPARATOR_LENGTH=3;

	 // Package Constants
	 public static final String EXTERNAL_PACKAGES="ExternalPackages";
	 public static final String EXTERNAL_PACKAGE="ExternalPackage";
	 public static final String EXTERNAL_PACKAGE_HREF="href";

	 //	 Process Constants
	 public static final String WORKFLOW_PROCESSES="WorkflowProcesses";
	 public static final String WORKFLOW_PROCESS = "WorkflowProcess";
	 public static final String WORKFLOW_PROCESS_ID = "Id";
	 public static final String WORKFLOW_PROCESS_NAME = "Name";
	 public static final String WORKFLOW_PROCESS_VERSION = "Version";
	 public static final String WORKFLOW_PROCESS_REDEFINABLEHEADER = "RedefinableHeader";

	 // Activity Constants
	 public static final String ACTIVITIES = "Activities";
	 public static final String ACTIVITY = "Activity";
	 public static final String ACTIVITY_ID = "Id";
	 public static final String ACTIVITY_NAME = "Name";
	 public static final String ACTIVITY_PERFORMER = "Performer";
	 public static final String ACTIVITY_DESCRIPTION = "Description";
	 public static final String ACTIVITY_JOIN = "Join";
	 public static final String ACTIVITY_SPLIT = "Split";
	 public static final String ACTIVITY_TYPE = "Type";
	 public static final String ACTIVITYSETS = "ActivitySets";
	 public static final String ACTIVITYSET = "ActivitySet";
	 public static final String ACTIVITYSETID = "Id";
	 public static final String ACTIVITYDEADLINE = "Deadline";
 	 public static final String SUBFLOW_ID = "Id";
 	 public static final String BLOCK_ID = "BlockId";
 	 public static final String ROUTE = "Route";
 	 public static final String BLOCK = "BlockActivity";
 	 public static final String TOOL = "Tool";
 	 public static final String IMPLEMENTATION = "Implementation";
 	 public static final String IMPLEMENTATION_NO = "No";
 	 public static final String IMPLEMENTATION_TOOL = "Tool";
 	 public static final String IMPLEMENTATION_SUBFLOW = "SubFlow";
 	 public static final String MODE = "Mode";
 	 public static final String MODE_TYPE_XOR = "Xor";
 	 public static final String MODE_TYPE_AND = "And";
 	 public static final String TYPE = "Type";
	 public static final String AUTOMATIC = "Automatic";
	 public static final String MANUAL = "Manual";
	 public static final String STARTMODE = "StartMode";
	 public static final String DEADLINE_EXECUTION = "Execution";
	 public static final String SYNCHR = "Synchr";
	 public static final String ASYNCHR = "Asynchr";
	 public static final String DEADLINECONDITION = "DeadlineCondition";
	 public static final String EXCEPTIONNAME = "ExceptionName";
	 public static final String ACTUALPARAMETER = "ActualParameter";

	 // Participants Constants
	 public static final String PARTICIPANTS = "Participants";
	 public static final String PARTICIPANT = "Participant";
	 public static final String PARTICIPANT_ID = "Id";
	 public static final String PARTICIPANT_NAME = "Name";
	 public static final String PARTICIPANT_DESCRIPTION = "Description";
	 public static final String PARTICIPANT_TYPE = "ParticipantType";
	 public static final String PARTICIPANT_TYPE_TYPE = "Type";
	 public static final String PARTICIPANT_TYPE_ROLE = "Role";
	 public static final String PARTICIPANT_TYPE_ORGANIZATIONAL_UNIT = "Organizational_unit";
	 public static final String PARTICIPANT_TYPE_HUMAN = "Human";
	 public static final String PARTICIPANT_TYPE_SYSTEM = "System";
	 public static final String PARTICIPANTS_ROLE = "XPDLRole";

	 //Applications
	 public static final String APPLICATIONS = "Applications";
	 public static final String APPLICATION = "Application";
	 public static final String APPLICATION_ID = "Id";
	 public static final String APPLICATION_NAME = "Name";
	 public static final String APPLICATION_DESCRIPTION = "Description";
	 public static final String FORMAL_PARAMETERS = "FormalParameters";
	 public static final String FORMAL_PARAMETER = "FormalParameter";
	 public static final String FORMAL_PARAMETER_ID = "Id";
	 public static final String FORMAL_PARAMETER_INDEX = "Index";
	 public static final String FORMAL_PARAMETER_MODE = "Mode";

	 //	DataFields
	 public static final String DATAFIELDS = "DataFields";
	 public static final String DATAFIELD = "DataField";
	 public static final String DATAFIELD_ID = "Id";
	 public static final String DATAFIELD_NAME = "Name";
	 public static final String DATATYPE = "DataType";
	 public static final String DATATYPE_TYPE = "Type";
	 public static final String INITIALVALUE = "InitialValue";
	 public static final String BASICTYPE = "BasicType";
	 public static final String ENUMERATIONTYPE = "EnumerationType";
	 public static final String ENUMERATIONVALUE = "EnumerationValue";
	 public static final String ENUMERATIONVALUENAME = "Name";

	 public static final String PACKAGE_LEVEL = "Package_level";

	 // Type declarations : not used at now
	 public static final String TYPEDECLARATIONS = "TypeDeclarations";
	 public static final String TYPEDECLARATION = "TypeDeclaration";

	 // Transitions Constants
	 public static final String TRANSITIONS = "Transitions";
	 public static final String TRANSITION = "Transition";
	 public static final String TRANSITION_FROM = "From";
	 public static final String TRANSITION_ID = "Id";
	 public static final String TRANSITION_NAME = "Name";
	 public static final String TRANSITION_TO = "To";
	 public static final String TRANSITION_CONDITION = "Condition";

	 // Extended Attributs general constantes
	 public static final String EXTENDED_ATTRIBUTES = "ExtendedAttributes";
	 public static final String EXTENDED_ATTRIBUTE = "ExtendedAttribute";
	 public static final String EXTENDED_ATTRIBUTE_NAME = "Name";
	 public static final String EXTENDED_ATTRIBUTE_VALUE = "Value";

	 // Extended attributes for Role Mapper within Participant
	 // 1st extended attribut for The mapper type (the name is automatically build)
	 public static final String EXTENDED_ATTRIBUTE_NAME_MAPPER = "Mapper";
	 public static final String EXTENDED_ATTRIBUTE_VALUE_LDAP = "LDAP";
	 public static final String EXTENDED_ATTRIBUTE_VALUE_PROPERTIES = "Properties";
	 public static final String EXTENDED_ATTRIBUTE_VALUE_CUSTUM = "Custom";
	 // 2nd extended attribut for the classname (custom attribute)
	 public static final String EXTENDED_ATTRIBUTE_NAME_MAPPER_CLASSNAME = "MapperClassName";
	 // ext. attrib name="DN" (cnx ldap de jawe)
	 public static final String EXTENDED_ATTRIBUTE_NAME_DN = "DN";


	 // Extended attribut for Datafield definition meaning the property is dedicated for activity
	 public static final String EXTENDED_ATTRIBUTE_NAME_PROPERTY_ACTIVITY = "PropertyActivity";
	 //	Extended attribut for Datafield definition meaning the property is used to store the UUID
	 // (created 1st time with empty doc in the repository)
	 public static final String EXTENDED_ATTRIBUTE_NAME_DOCUMENT = "Document";

	 // Extended attribut for the definition of Bonita property within Activities (use of defined datafield)
	 public static final String EXTENDED_ATTRIBUTE_NAME_PROPERTY = "Property";
	 public static final String PROPAGATED_PROPERTY = "Propagated";

	 //	Extended attribut for Hooks (within activity or process)
	 public static final String EXTENDED_ATTRIBUTE_NAME_HOOK = "Hook";
	 public static final String HOOKEVENTNAME = "HookEventName";
	 public static final String HOOKSCRIPT = "HookScript";

	 // Extended attribut for Process Initiator Mapper
	 public static final String EXTENDED_ATTRIBUTE_NAME_INITIATORMAPPER = "InitiatorMapper";
	 public static final String EXTENDED_ATTRIBUTE_INITIATOR_NAME = "InitiatorName";

	 //	Extended attribut for iteration (within activity)
	 public static final String EXTENDED_ATTRIBUTE_NAME_ITERATION = "Iteration";
	 public static final String ITERATIONFROM = "From";
	 public static final String ITERATIONTO = "To";

	 //	Extended attribut for Performer Assignment (within activity)
	 public static final String EXTENDED_ATTRIBUTE_NAME_PERFORMER_ASSIGN = "PerformerAssign";
	 public static final String PERFORMER_ASSIGN_PROPERTY = "Property";
	 public static final String PERFORMER_ASSIGN_CALLBACK = "Callback";

	 // Extended attribut for Subflow version within activivity with subflow implementation
	 public static final String EXTENDED_ATTRIBUTE_NAME_SUBFLOW_VERSION = "SubFlowVersion";
     public static final String EXTENDED_ATTRIBUTE_NAME_SUBFLOW_NAME = "SubFlowName";
}

