package hero.xpdl;

/**
*
* Bonita
* Copyright (C) 1999 Bull S.A.
* Bull 68 route de versailles  78434 Louveciennes Cedex France
* Further information: bonita@objectweb.org
*
* This library is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or any later version.
*
* This library is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this library; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
* USA
*
*
--------------------------------------------------------------------------
* $Id: XPDLDataField.java,v 1.1 2006/06/06 08:16:08 mvaldes Exp $
*
--------------------------------------------------------------------------
*/

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Vector;

public final class XPDLDataField implements Serializable, java.lang.Cloneable {

    // --------------------------------------------------- Instance Variables

    private String name = "";
    private String id = "";
    private String initialValue = "";
    private String dataType = "";
    private String basicType = "";
    private ArrayList enumeration = new ArrayList();
    private boolean propertyActivity = false;
    private boolean document = false;
    // field containing either : projectName, either the cste : PACKAGE_LEVEL
    private String projectName = "";
    
    
    
    // ----------------------------------------------------------- Properties
    
    // Name
    public String getName() {
    	return (name);
    }

    public void setName(String name) {
        this.name = name;
    }

    //id
    public String getId() {
    	return (id);
    }

    public void setId(String id) {
        this.id = id;
    }
    
    //dataType  : BasicType or EnumerationType   at now
    public String getDataType() {
    	return (dataType);
    }

    public void setDataType(String dataType) {
        this.dataType = dataType;
    }
    
    //BasicType : String    at now
    public String getBasicType() {
    	return (basicType);
    }

    public void setBasicType(String basicType) {
        this.basicType = basicType;
    }
    
    //initialValue
    public String getInitialValue() {
    	return (initialValue);
    }

    public void setInitialValue(String initialValue) {
        this.initialValue = initialValue;
    }
    
    // enumeration
    public ArrayList getEnumeration() {
    	return (enumeration);
    }

    public void setEnumeration(String enumeration) {
        this.enumeration.add(enumeration);
    } 
    
    // boolean indicating the datafield is for activity (not for process WF Relevant Data)
    public boolean getPropertyActivity() {
    	return (propertyActivity);
    }

    public void setPropertyActivity() {
        this.propertyActivity = true;              
    }
    
    // boolean indicating the datafield is an proed document type
    public boolean getDocument() {
    	return (document);
    }

    public void setDocument() {
        this.document = true;              
    }
    
    // projectName (or "Package_level")
    public String getProjectName() {
    	return (projectName);
    }

    public void setProjectName(String projectName) {
        this.projectName = projectName;
    }
    
    public XPDLDataField(){}

    public Object clone() throws java.lang.CloneNotSupportedException{
	return super.clone();
    }

}
