package hero.xpdl;

import java.net.URL;
import java.util.ArrayList;
import java.util.List;


/**
 * This class defines the declarations of the default J2EE 1.4 Schemas
 * @author Florent Benoit
 */
public class XPDLSchemas implements Schemas {


    /**
     * List of schemas used by components
     */
    private static final String[] DEFAULT_SCHEMAS = new String[] {
        "TC-1025_schema_10_xpdl.xsd",
    };


    /**
     * List where the local schemas URLs are stored
     */
    private static ArrayList localSchemas = null;


    /**
     * Build a new object for Schemas handling
     */
    public XPDLSchemas() {
        localSchemas = new ArrayList();
        addSchemas(DEFAULT_SCHEMAS);
    }

    /**
     * Gets the URLs of the local schemas
     * @return the URLs of the local schemas
     */
    public List getlocalSchemas() {
        return localSchemas;
    }


    /**
     * Add to our repository the given local schemas
     * @param schemas schemas to add to the repository
     * @throws IllegalStateException if the dtds is not found as resource
     */
    protected static void addSchemas(String[] schemas) throws IllegalStateException {
        URL url = null;
        for (int i = 0; i <  schemas.length; i++) {
            url = XPDLSchemas.class.getResource("/etc/xml/xpdl/" +  schemas[i]);
            if (url == null) {
                throw new IllegalStateException("'" +  schemas[i] + "' was not found in the current classloader !");
            }
            localSchemas.add(url.toString());
        }
    }

    /**
     * @param element name of the root element (jonas-ejb-jar, ...)
     * @param schemas array of Schemas (to be always up to date)
     * @return a header for the right element with last element
     */
   /* public static String getHeaderForElement(String element, String[] schemas) {
        StringBuffer header = new StringBuffer();
        header.append("<");
        header.append(element);
        header.append(" xmlns=\"http://www.objectweb.org/jonas/ns\"\n");
        header.append("               xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\"\n");
        header.append("               xsi:schemaLocation=\"http://www.objectweb.org/jonas/ns\n");
        header.append("                                   http://www.objectweb.org/jonas/ns/");

        // Get the last XSD
        header.append(schemas[schemas.length - 1]);
        header.append("\" >\n");

        return header.toString();
    }*/

}
