package hero.xpdl;

/**
*
* Bonita
* Copyright (C) 1999 Bull S.A.
* Bull 68 route de versailles  78434 Louveciennes Cedex France
* Further information: bonita@objectweb.org
*
* This library is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or any later version.
*
* This library is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this library; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
* USA
*
*
--------------------------------------------------------------------------
* $Id: XPDLWFProcess.java,v 1.1 2006/06/06 08:16:08 mvaldes Exp $
*
--------------------------------------------------------------------------
*/

import java.io.Serializable;
import java.util.ArrayList;

public final class XPDLWFProcess implements Serializable, java.lang.Cloneable {

    // --------------------------------------------------- Instance Variables

    private String name = "";    
    private String id = "";
    private XPDLInitiatorMapper initiatorMapper = null;

    // Hook feature  :
    // TBD. :  As Process Hook is dedicated to initialize Process properties 
    //         Array is no more useful. (with older Hook process more than one hook could be set)
    private ArrayList xpdlHooks = new ArrayList(); 
    

    // ----------------------------------------------------------- Properties
    
    public String getName() {
    	return (name);
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getId() {
    	return (id);
    }

    public void setId(String id) {
        this.id = id;
    } 
    
    // hook bean feature
    public ArrayList getXpdlHook() {
    	return (xpdlHooks);
    }

    public void setXpdlHook(XPDLHook xpdlHook) {
        this.xpdlHooks.add(xpdlHook);
    }
    
    // initiator mapper
    public XPDLInitiatorMapper getInitiatorMapper() {
    	return (initiatorMapper);
    }
    
    public void setInitiatorMapper(XPDLInitiatorMapper initiatorMapper) {
        this.initiatorMapper = initiatorMapper;
    }

    public XPDLWFProcess(){}

    public Object clone() throws java.lang.CloneNotSupportedException{
	return super.clone();
    }

}
