/**
 *
 * Bonita
 * Copyright (C) 1999 Bull S.A.
 * Bull 68 route de versailles  78434 Louveciennes Cedex France
 * Further information: bonita@objectweb.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 *
--------------------------------------------------------------------------
 * $Id: TestDeadlines.java,v 1.4 2006/05/17 17:39:37 mvaldes Exp $
 *
--------------------------------------------------------------------------
 */


package hero.hook;

import java.sql.Date;
import java.sql.Timestamp;
import java.util.Calendar;
import java.util.Collection;
import java.util.GregorianCalendar;
import java.util.Iterator;

import hero.util.HeroHookException;
import hero.interfaces.BnNodeLocal;
import hero.interfaces.Constants;


public class TestDeadlines implements hero.hook.NodeHookI {

	public String getMetadata() {
		return Constants.Nd.ONDEADLINE;
	}
	
    public void create(Object b,BnNodeLocal n) throws HeroHookException {

    }

    public void beforeStart(Object b,BnNodeLocal n) throws HeroHookException {
    }
    public void afterStart(Object b,BnNodeLocal n) throws HeroHookException {
    } 
    public void beforeTerminate(Object b,BnNodeLocal n) throws HeroHookException {}
    public void afterTerminate(Object b,BnNodeLocal n) throws HeroHookException {}
    public void onCancel(Object b,BnNodeLocal n) throws HeroHookException {}
    public void anticipate(Object b,BnNodeLocal n) throws HeroHookException {}
    public void onReady(Object b,BnNodeLocal n) throws HeroHookException {}
    public void onDeadline(Object b,BnNodeLocal n) throws HeroHookException {
	try{
		String name=n.getName();
		if (n.getDeadlines().size()!=0){
			Collection co = n.getDeadlines();
			Iterator it = co.iterator();
			System.out.println("Deadlines Test, node name: "+name);
			System.out.println("One of the following deadline has been executed");
			while (it.hasNext()){
				Timestamp date = (Timestamp)it.next();
				long lt = date.getTime();				
				Calendar calendar = new GregorianCalendar();
				calendar.setTime(date);
				System.out.println("date (long) = " + lt + " - date (YY/MM/DD/HH/MM/SS)= " + calendar.get(Calendar.YEAR) + "/" + calendar.get(Calendar.MONTH) + "/" + 
						calendar.get(Calendar.DAY_OF_MONTH) + "/" + calendar.get(Calendar.HOUR) + "/" + calendar.get(Calendar.MINUTE) +
						"/" + calendar.get(Calendar.SECOND));
			}	 
		}
		if (n.getRelativeDeadlines().size()!=0){
			Collection co = n.getRelativeDeadlines();
			Iterator it = co.iterator();
			System.out.println("Deadlines Test, node name: "+name);
			System.out.println("One of the following relative deadline has been executed");
			while (it.hasNext()){
				Timestamp date = (Timestamp)it.next();
				long lt = date.getTime();
				Calendar calendar = new GregorianCalendar();
				calendar.setTime(date);
				System.out.println("date (long) = " + lt + " - date (YY/MM/DD/HH/MM/SS) = " + calendar.get(Calendar.YEAR) + "/" + calendar.get(Calendar.MONTH) + "/" + 
						calendar.get(Calendar.DAY_OF_MONTH) + "/" + calendar.get(Calendar.HOUR) + "/" + calendar.get(Calendar.MINUTE) +
						"/" + calendar.get(Calendar.SECOND));
			}	 
		}
	}catch(Exception e){e.printStackTrace();}
    }

}















