/**
 *
 * Bonita
 * Copyright (C) 1999 Bull S.A.
 * Bull 68 route de versailles  78434 Louveciennes Cedex France
 * Further information: bonita@objectweb.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 *
--------------------------------------------------------------------------
 * $Id: LdapGroupMembers.java,v 1.3 2005/07/06 12:26:51 blachonm Exp $
 *
--------------------------------------------------------------------------
 */

package hero.mapper;

import hero.util.HeroException;
import hero.interfaces.BnRoleLocal;

// Use of BnLdap session Bean
import hero.interfaces.BnLdap;
import hero.interfaces.BnLdapHome;
import hero.interfaces.BnLdapUtil;
import java.util.*;


public class LdapGroupMembers implements hero.mapper.RoleMapperI {

    public Collection searchMembers(Object b,BnRoleLocal n, String userName) throws HeroException {
	
	    String roleName=n.getName();
	    String projectName=n.getBnProject().getName();	    
//System.out.println("[Search Group Members] BnRole name:"+roleName + " - Project name = " + projectName);
		ArrayList al =null;
		
		BnLdapHome home = null;
		try {
			home = BnLdapUtil.getHome();		      
		} catch (Exception e) {
		    System.err.println( "Cannot lookup BnLdapHome: " + e);
		    System.exit(2);
		}
	
		BnLdap t1 = null;
		try {
// logs trace
//System.out.println("Create a bean bnLdap");
		    t1 = home.create();
		} catch (Exception e) {
			throw new HeroException("Cannot create  BnLdapBean : " + e);
		}
		try {
		al = (ArrayList)t1.getGroupMembers(roleName);
		} catch (Exception e){
			throw new HeroException("Error getting group members for group: " + roleName + " " + e.getMessage());
		}
		return al;
			  
    } 

}















