/**
 *
 * Bonita
 * Copyright (C) 1999 Bull S.A.
 * Bull 68 route de versailles  78434 Louveciennes Cedex France
 * Further information: bonita@objectweb.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 *
--------------------------------------------------------------------------
 * $Id: PropertySelectActors.java,v 1.3 2005/11/15 15:24:49 dparisek Exp $
 *
--------------------------------------------------------------------------
 */

package hero.performerAssign;

import hero.util.HeroException;
import hero.interfaces.BnNodeLocal;
import hero.interfaces.BnNodePropertyLocal;
import hero.interfaces.BnProjectPropertyLocal;

public class PropertySelectActors implements hero.performerAssign.NodePerformerAssignI {

    public void selectActors(Object b,BnNodeLocal n, String userName) throws HeroException {   		
	    String nodeName=n.getName();
	    String projectName=n.getBnProject().getName();	    
	    // logs trace	    
	    System.out.println("[PropertySelectActors] BnNode name:"+nodeName + " - Project name = " + projectName);
		try {
			String user = "";
			// get the property name
			String propertyName = n.getBnNodePerformerAssign().getPropertyName();
			// get the property value
			java.util.Collection coN = null;
			java.util.Collection coP = null;
			coN = n.getBnProperties();
			coP = n.getBnProject().getBnProperties();
			BnProjectPropertyLocal propertyPl;
			BnNodePropertyLocal propertyL;
			java.util.Iterator it =coN.iterator();
			while (it.hasNext()){
				propertyL = (BnNodePropertyLocal)it.next();
				if ( (propertyL.getTheKey()).equals(propertyName) ) 
				user = propertyL.getTheValue();
			}	
			if (user.equals("")) {
				it =coP.iterator();
				while (it.hasNext()){
					propertyPl = (BnProjectPropertyLocal)it.next();
					if ( (propertyPl.getTheKey()).equals(propertyName) ) 
					user = propertyPl.getTheValue();
				}	
			}
			//	logs trace
			System.out.println("[PropertySelectActors] user = " + user);
			n.setActivityPerformer(user);
		} catch (Exception e){
			e.printStackTrace();
			throw new HeroException("[PropertySelectActors]: " + e.getMessage());
		}
    } 
}















