package hero.struts.actions;

import java.io.IOException;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import javax.naming.Context;


/**
 * This is the base class from which all Action classes that use
 * Struts can be derived from.
 *
 * @author Miguel Valdes Faura
 * 
 */
public abstract class AbstStrutsActionBase extends Action
{

    /* Generic typical returns used so that the structs-config.xml can
     * default global forwards.
     */

    protected static final String INITIAL = "initial";    
    protected static final String SUCCESS = "success";
    protected static final String FAILURE = "failure";
    protected static final String ERROR   = "error";
    protected static final String LOGIN   = "login";
    protected static final String NEWUSER   = "newuser";
    protected static final String CONFIRM = "confirm";
    protected static final String ACTIVITY = "activity";
    protected static final String EDITACTIVITY = "editactivity";
    protected static final String PROJECT = "project";
    protected static final String ADMIN = "admin";
    protected static final String USER = "user";
    protected static final String ADDPROJECT = "addproject";
    protected static final String CLONEPROJECT = "cloneproject";
    protected static final String PROJECTDETAILS = "projectdetails";
    protected static final String USERNOTLOGGED = "usernotlogged";
    protected static final String WORKLIST = "worklist";
    protected static final String CONFIGPROJECT = "configproject";

    protected Context jndiContext = null;
    
    
    /**
     * Default constructor
     */
    public AbstStrutsActionBase()
    {
    }
        
    /**
     * @param mapping The ActionMapping used to select this instance
     * @param actionForm The optional ActionForm bean for this request (if any)
     * @param request The HTTP request we are processing
     * @param response The HTTP response we are creating
     * @throws IOException if an input/output error occurs
     * @throws ServletException if a servlet exception occurs
     * @return where control will be forwarded to after this request is processed
     */
    public abstract ActionForward perform(ActionMapping mapping, ActionForm form,
        HttpServletRequest request, HttpServletResponse response) throws IOException,ServletException;
    {
    }
       
    
}
