package hero.struts.actions;

import java.io.IOException;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import javax.servlet.http.HttpServletResponse;
import org.apache.struts.action.ActionError;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionForward;

import java.util.*;

import hero.interfaces.*;
import hero.util.*;
import hero.struts.forms.*;

/**
 * <strong>ActivityAction</strong>
 * Action that allows the user to edit activity properties
 * 
 *@author Miguel Valdes Faura
 */

public class ActivityAction extends AbstStrutsActionBase
{
  public boolean authenticate(String username, String password)
  {
	return(true);
  }
    /**
     * @param mapping The ActionMapping used to select this instance
     * @param actionForm The optional AbstActionFormBase bean for this request (if any)
     * @param request The HTTP request we are processing
     * @param response The HTTP response we are creating
     * @exception IOException if an input/output error occurs
     * @exception ServletException if a servlet exception occurs
     */
    public ActionForward perform(ActionMapping mapping, ActionForm form,
        HttpServletRequest request, HttpServletResponse response) throws IOException, ServletException
    {

        ActionForward actionForward = mapping.findForward(EDITACTIVITY);
        // Create the container for any errors that occur
        ActionErrors errors = new ActionErrors();

	String action = request.getParameter("action");
	HttpSession session = request.getSession();
	String name = (String)session.getAttribute("nodename");
	String project = (String)session.getAttribute("projectname");

	try 
	{
	    hero.interfaces.ProjectSessionLocalHome projecth = (ProjectSessionLocalHome)hero.interfaces.ProjectSessionUtil.getLocalHome();
	    hero.interfaces.ProjectSessionLocal projectsession = projecth.create();
	    projectsession.initProject(project);

	    if (!isCancelled(request))
	    {
		if (action.equals("Edit"))
		{
		    request.getSession(true).setAttribute("edit", "true");
		    // Forward control to the specified 'success' URI specified in the structs-config.xml
		    actionForward = mapping.findForward(EDITACTIVITY);
		}
		if (action.equals("Add"))
		{
			
		    ActivityForm activityForm = (ActivityForm) form;
		    String role = request.getParameter("role");
		    String description = activityForm.getDescription();
		    String anticipable = activityForm.getAnticipable();
		    String type = activityForm.getType();
		    String automatic = activityForm.getAutomatic();
		    String deadline = activityForm.getDeadline()+" 00:00:00";
		    
		    java.sql.Timestamp dl = java.sql.Timestamp.valueOf(deadline);
		    if (dl.getTime() <= (new java.util.Date()).getTime())
			errors.add("activity_error", new ActionError("error.deadlineIncorrect"));
		    else {
			if (anticipable.equals("true"))
			    projectsession.setNodeAnticipable(name);
			else
			    projectsession.setNodeTraditional(name);
			
			projectsession.setNodeDeadline(name, java.sql.Timestamp.valueOf(deadline).getTime());
			projectsession.setNodeRole(name,role);
			projectsession.setNodeDescription(name,description);
			
			StrutsNodeValue node = projectsession.getStrutsNode(name);
			request.getSession(true).setAttribute("node", node);
			request.getSession(true).setAttribute("edges", projectsession.getStrutsNodeEdges(node.getName()));
      
		    }
		    request.getSession(true).setAttribute("edit", "false");
		    actionForward = mapping.findForward(EDITACTIVITY);
		}
		
		if (action.equals("editactivity"))
		    {
		 
			StrutsNodeValue node = projectsession.getStrutsNode(name);
			request.getSession(true).setAttribute("node", node);
			request.getSession(true).setAttribute("edges", projectsession.getStrutsNodeEdges(node.getName()));
			
			Vector roles = new Vector();
      			Collection pRoles = projectsession.getRoles();
      			Iterator iproles = pRoles.iterator();
     			request.getSession(true).setAttribute("pRoles", pRoles);
     		
      			while(iproles.hasNext())
      			{
        			BnRoleLocal actualpRole = (BnRoleLocal)iproles.next();
        			roles.add(actualpRole.getName());

      			}
      			request.getSession(true).setAttribute("roles", roles);
      			
      			Vector prop = new Vector(projectsession.getNodeProperties(node.getName()));
    			Vector hooks = new Vector(projectsession.getNodeHooks(node.getName()));
    			Vector interhooks = new Vector(projectsession.getNodeInterHooks(node.getName()));
    			request.getSession(true).setAttribute("properties", prop);
    			request.getSession(true).setAttribute("hooks", hooks);
    			request.getSession(true).setAttribute("interhooks", interhooks);		  
		  actionForward = mapping.findForward(EDITACTIVITY);
		    }
		
		if (action.equals("viewactivity"))
		    actionForward = mapping.findForward(ACTIVITY);
	    }
	    else
		request.getSession().setAttribute("edit", "false");
	}catch(Exception e){e.printStackTrace();errors.add("activity_error", new ActionError("error.deadline.mismatch"));}
	
	if (!errors.empty()) {
	    saveErrors(request, errors);
        }
	
	// Forward control to the appropriate URI as determined by the action.
	return (actionForward);
    }
}
