package hero.struts.actions;

import java.io.IOException;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import javax.servlet.http.HttpServletResponse;
import org.apache.struts.action.ActionError;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionForward;

import hero.interfaces.*;


/**
 * <strong>EdgeAction</strong> 
 * Action that allows the user to add a new edge in the current project
 * 
 *@author Miguel Valdes Faura
 */
public class EdgeAction extends AbstStrutsActionBase 
{

  public boolean authenticate(String username, String password)
  {
	return(true);
  }

    /**
     * @param mapping The ActionMapping used to select this instance
     * @param actionForm The optional AbstActionFormBase bean for this request (if any)
     * @param request The HTTP request we are processing
     * @param response The HTTP response we are creating
     * @exception IOException if an input/output error occurs
     * @exception ServletException if a servlet exception occurs
     */
    public ActionForward perform(ActionMapping mapping, ActionForm form,
        HttpServletRequest request, HttpServletResponse response) throws IOException, ServletException
    {

        ActionForward actionForward = mapping.findForward(PROJECT);
        // Create the container for any errors that occur
        ActionErrors errors = new ActionErrors();

	String action = request.getParameter("edgeAction");
	HttpSession session = request.getSession();
	String project = (String)session.getAttribute("projectname");

	try 
	{
	    hero.interfaces.ProjectSessionLocalHome projecth = (ProjectSessionLocalHome)hero.interfaces.ProjectSessionUtil.getLocalHome();
	    hero.interfaces.ProjectSessionLocal projectsession = projecth.create();
		projectsession.initProject(project);
	    
	    if (!isCancelled(request))
	    {		
		if (action.equals("Edit"))
		{
		    // Forward control to the specified 'success' URI specified in the structs-config.xml
		    actionForward = mapping.findForward(PROJECT);
		}
		if (action.equals("Add"))
		{

		    String in = request.getParameter("nodeIn");
		    String out = request.getParameter("nodeOut");
		    projectsession.addEdge(in, out);
		    request.getSession(true).setAttribute("project", projectsession);
		    
		    // Forward control to the specified 'success' URI specified in the structs-config.xml
		    actionForward = mapping.findForward(PROJECT);
		}
		if (action.equals("Delete"))
		{
		    try {
			String edgeName = request.getParameter("name");
			projectsession.deleteEdge(edgeName);
		    }catch(Exception e3){errors.add("edge_error", new ActionError("error.deleteedge.mismatch"));}
		    request.getSession(true).setAttribute("project", projectsession);
		    
		    // Forward control to the specified 'success' URI specified in the structs-config.xml
		    actionForward = mapping.findForward(PROJECT);   
		}
	    }
	    //	}catch(DuplicatedEdgeException e){errors.add("edge_error", new ActionError("error.duplicateedge.mismatch"));
	    //}catch(NodeStartedException e1){errors.add("edge_error", new ActionError("error.startededge.mismatch"));
	}catch(Exception e2){errors.add("edge_error", new ActionError("error.edge.mismatch"));}
	
	if (!errors.empty()) {
	    saveErrors(request, errors);
        }
	
	// Forward control to the appropriate URI as determined by the action.
	return (actionForward);
    }
    
}
