package hero.struts.actions;

import java.io.IOException;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import javax.servlet.http.HttpServletResponse;
import org.apache.struts.action.ActionError;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionForward;
import hero.struts.forms.*;
import hero.interfaces.*;
import java.util.Vector;


/**
 * <strong>HookAction</strong>
 * Action that allows the user to add a new hook.
 * This action can be forward project or activity pages
 *
 *@author valdes@loria.fr
 */
public class HookAction extends AbstStrutsActionBase {

    public boolean authenticate(String username, String password) {
	return (true);
    }
    
    /**
     * @param mapping The ActionMapping used to select this instance
     * @param actionForm The optional AbstActionFormBase bean for this request (if any)
     * @param request The HTTP request we are processing
     * @param response The HTTP response we are creating
     * @exception IOException if an input/output error occurs
     * @exception ServletException if a servlet exception occurs
     */
    public ActionForward perform(ActionMapping mapping,ActionForm form, HttpServletRequest request, HttpServletResponse response)
	throws IOException, ServletException {
	
	// Create the container for any errors that occur
	ActionErrors errors = new ActionErrors();
        ActionForward actionForward = mapping.findForward(EDITACTIVITY);
	
	String action = request.getParameter("hookAction");
	String hookName = request.getParameter("name");
	HttpSession session = request.getSession();
	String project = (String) session.getAttribute("projectname");
	try {
	    hero.interfaces.ProjectSessionLocalHome projecth =(ProjectSessionLocalHome) hero.interfaces.ProjectSessionUtil.getLocalHome();
	    hero.interfaces.ProjectSessionLocal projectsession =projecth.create();
		projectsession.initProject(project);
		
	    if (!isCancelled(request)) {
		if (action.equals("EditNode") || action.equals("EditNode2")) {
		    request.getSession(true).setAttribute("inter", "false");
		    // Forward control to the specified 'success' URI specified in the structs-config.xml
		    actionForward = mapping.findForward(EDITACTIVITY);
		}
		if (action.equals("Edit") || action.equals("Edit2")) {
		    request.getSession(true).setAttribute("inter", "false");
		    // Forward control to the specified 'success' URI specified in the structs-config.xml
		    actionForward = mapping.findForward(CONFIGPROJECT);
		}
		if (action.equals("AddNode")) {
		    String name = (String) session.getAttribute("nodename");
		    String event = request.getParameter("event");
		    String type = request.getParameter("type");
		    if (hookName.length() != 0 && event.length() != 0) {
			int hookType = 0;
			if (type.equals("Java"))
			    hookType = 0;
			if (type.equals("Tcl"))
			    hookType = 4;
			if (type.equals("BeanShell"))
			    hookType = 5;
			    
			projectsession.addNodeHook(name,hookName,event,hookType);
			request.getSession(true).setAttribute("node",projectsession.getStrutsNode(name));			
		    } else
			errors.add("hook_error", new ActionError("error.hookparameter.mismatch"));
		    // Forward control to the specified 'success' URI specified in the structs-config.xml
		    actionForward = mapping.findForward(EDITACTIVITY);
		}
		if (action.equals("AddNode2")) {
		    String name = (String) session.getAttribute("nodename");
		    String event = request.getParameter("event");
		    String type = request.getParameter("type");
		    
		    if (hookName.length() != 0 && event.length() != 0) {
			int hookType = 0;
			String firstValue = "";
			if (type.equals("InteractionBS"))
			    hookType = 6;
			
			if (event.equals("afterStart"))
			    firstValue = Constants.AFTERSTART;
			if (event.equals("beforeStart"))
			    firstValue = Constants.BEFORESTART;
			if (event.equals("afterTerminate"))
			    firstValue = Constants.AFTERTERMINATE;
			if (event.equals("beforeTerminate"))
			    firstValue = Constants.BEFORETERMINATE;
			if (event.equals("anticipate"))
			    firstValue = Constants.ANTICIPATE;
			if (event.equals("onCancel"))
			    firstValue = Constants.ONCANCEL;
			
			projectsession.addNodeInterHook(name,hookName,event,hookType,firstValue);
			request.getSession(true).setAttribute("node",projectsession.getStrutsNode(name));
			request.getSession(true).setAttribute("hookName",hookName);
			HookForm hookForm = (HookForm) form;
			hookForm.setValue(firstValue);
			Vector interhooks = new Vector(projectsession.getNodeInterHooks(name));
			request.getSession(true).setAttribute("interhooks", interhooks);
		    } else
			errors.add("hook_error", new ActionError("error.interhook.mismatch"));
		    // Forward control to the specified 'success' URI specified in the structs-config.xml
		    actionForward = mapping.findForward(EDITACTIVITY);
		    request.getSession(true).setAttribute("inter", "true");
		}
                if (action.equals("editScript")) {
		    request.getSession(true).setAttribute("inter", "false");
		    String name = (String) session.getAttribute("nodename");
		    request.getSession(true).setAttribute("scri", projectsession.getNodeInterHookValue(name,hookName));
		    request.getSession(true).setAttribute("hoName", hookName);
		    actionForward = mapping.findForward(EDITACTIVITY);
		}
                if (action.equals("addEditScript")) { 
		    request.getSession(true).setAttribute("inter", "false");
			HookForm hookForm = (HookForm) form;
			String value = hookForm.getValue();
			request.getSession(true).setAttribute("val", hookForm.getValue());
			String name = (String) session.getAttribute("nodename");
			hookName = (String) request.getSession(true).getAttribute("hoName");
			projectsession.setNodeInterHookValue(name,hookName,value);
			Vector interhooks = new Vector(projectsession.getNodeInterHooks(name));
		    	request.getSession(true).setAttribute("interhooks", interhooks);
		    actionForward = mapping.findForward(EDITACTIVITY);
		}

		if (action.equals("editProjectScript")) {
		    request.getSession(true).setAttribute("inter", "false");
		    request.getSession(true).setAttribute("scri", projectsession.getInterHookValue(hookName));
		    request.getSession(true).setAttribute("hoName", hookName);
		    request.getSession(true).setAttribute("project", projectsession);
		    System.out.println("PROJECTSEEION");
		    System.out.println(projectsession);
		    actionForward = mapping.findForward(CONFIGPROJECT);
		}
                if (action.equals("addEditProjectScript")) { 
      		        HookForm hookFo = (HookForm) form;
			String value = hookFo.getValue();
			hookName = (String) request.getSession(true).getAttribute("hoName");
 		    request.getSession(true).setAttribute("inter", "false");
			projectsession.setInterHookValue(hookName,value);
			session.setAttribute("interHooks", new Vector(projectsession.getInterHooks()));
		        actionForward = mapping.findForward(CONFIGPROJECT);
		}

		if (action.equals("AddNodeHook")) {
		    HookForm hookForm = (HookForm) form;
		    String value = hookForm.getValue();
		    String name = (String) session.getAttribute("nodename");
		    hookName =(String) request.getSession(true).getAttribute("hookName");
		    try {
			projectsession.setNodeInterHookValue(name,hookName,value);
			request.getSession(true).setAttribute("node",projectsession.getStrutsNode(name));
		    } catch (NumberFormatException etype) {
			errors.add("hook_error",new ActionError("error.hooktype.mismatch"));
		    }
		    request.getSession(true).setAttribute("inter", "false");
		    actionForward = mapping.findForward(EDITACTIVITY);
		}
		if (action.equals("AddHook")) {
		    HookForm hookForm = (HookForm) form;
		    String value = hookForm.getValue();
		    hookName =
			(String) request.getSession(true).getAttribute("hookName");
		    try {
			projectsession.setInterHookValue(hookName, value);
			request.getSession(true).setAttribute("project",projectsession);
			session.setAttribute("interHooks", new Vector(projectsession.getInterHooks()));
		    } catch (NumberFormatException etype) {
			errors.add("hook_error",new ActionError("error.hooktype.mismatch"));
		    }
		    request.getSession(true).setAttribute("inter", "false");
		    actionForward = mapping.findForward(CONFIGPROJECT);
		}
		if (action.equals("Add")) {
		    String event = request.getParameter("event");
		    String type = request.getParameter("type");
		    if (hookName.length() != 0 && event.length() != 0) {
			int hookType = 0;
			if (type.equals("Java"))
			    hookType = 0;
			if (type.equals("Tcl"))
			    hookType = 4;
			if (type.equals("BeanShell"))
			    hookType = 5;
			
			projectsession.addHook(hookName, event, hookType);
			request.getSession(true).setAttribute("project",projectsession);
		    } else
			errors.add("hook_error", new ActionError("error.hookparameter.mismatch"));
		    // Forward control to the specified 'success' URI specified in the structs-config.xml
		    actionForward = mapping.findForward(CONFIGPROJECT);
				}
		if (action.equals("Add2")) {
		    String event = request.getParameter("event");
		    String type = request.getParameter("type");
		    
		    if (hookName.length() != 0 && event.length() != 0) {
			int hookType = 0;
			String firstValue = "";
			if (type.equals("InteractionBS"))
			    hookType = 6;

			    if (event.equals("afterStart"))
				firstValue = Constants.AFTERSTART;
			    if (event.equals("beforeStart"))
				firstValue = Constants.BEFORESTART;
			    if (event.equals("afterTerminate"))
				firstValue = Constants.AFTERTERMINATE;
			    if (event.equals("beforeTerminate"))
				firstValue = Constants.BEFORETERMINATE;
			    if (event.equals("onCancel"))
				firstValue = Constants.ONCANCEL;
			    if (event.equals("anticipate"))
				firstValue = Constants.ANTICIPATE;
		
			        
			projectsession.addInterHook(hookName,event,hookType,firstValue);
			request.getSession(true).setAttribute("project",projectsession);
			request.getSession(true).setAttribute("hookName",hookName);
			HookForm hookForm = (HookForm) form;
			hookForm.setValue(firstValue);
			    
		    } else
			errors.add("hook_error",new ActionError("error.interhook.mismatch"));
		    // Forward control to the specified 'success' URI specified in the structs-config.xml
		    session.setAttribute("interHooks", new Vector(projectsession.getInterHooks()));
		    actionForward = mapping.findForward(CONFIGPROJECT);
		    request.getSession(true).setAttribute("inter", "true");
		}
		if (action.equals("DeleteNode")) {
		    String name = (String) session.getAttribute("nodename");
		    projectsession.deleteNodeInterHook(name, hookName);
		    Vector interhooks = new Vector(projectsession.getNodeInterHooks(name));
		    request.getSession(true).setAttribute("interhooks", interhooks);
		    request.getSession(true).setAttribute("node",projectsession.getStrutsNode(name));
		    request.getSession(true).setAttribute("inter", "false");
		    // Forward control to the specified 'success' URI specified in the structs-config.xml
		    actionForward = mapping.findForward(EDITACTIVITY);
		}
		if (action.equals("Delete")) {
		    projectsession.deleteInterHook(hookName);
		    request.getSession(true).setAttribute("project",projectsession);
 	    	    request.getSession(true).setAttribute("inter", "false");
		    // Forward control to the specified 'success' URI specified in the structs-config.xml
		    session.setAttribute("interHooks", new Vector(projectsession.getInterHooks()));
		    actionForward = mapping.findForward(CONFIGPROJECT);
		}
	    }
	    else if (action.equals("AddHook"))
		actionForward = mapping.findForward(CONFIGPROJECT);
	    else if (action.equals("AddNodeHook"))
		request.getSession(true).setAttribute("inter", "false");
	} catch (Exception e) {
	    errors.add("hook_error", new ActionError("error.interhook.mismatch"));
	    if (action.equals("Add") || action.equals("Add2"))
		actionForward = mapping.findForward(CONFIGPROJECT);
	}

	if (!errors.empty()) {
	    saveErrors(request, errors);
	}
	// Forward control to the appropriate URI as determined by the action.
	return (actionForward);
    }
}
