package hero.struts.actions;

import java.io.IOException;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionForward;

import java.util.*;

import hero.interfaces.*;

/**
 * <strong>EdgeAction</strong> 
 * Action that allows the user to add a new edge in the current project
 * 
 *@author Miguel Valdes Faura
 */
public class InitialAction extends AbstStrutsActionBase 
{

  public boolean authenticate(String username, String password)
  {
	return(true);
  }

    /**
     * @param mapping The ActionMapping used to select this instance
     * @param actionForm The optional AbstActionFormBase bean for this request (if any)
     * @param request The HTTP request we are processing
     * @param response The HTTP response we are creating
     * @exception IOException if an input/output error occurs
     * @exception ServletException if a servlet exception occurs
     */
    public ActionForward perform(ActionMapping mapping, ActionForm form,
        HttpServletRequest request, HttpServletResponse response) throws IOException, ServletException
    {

        ActionForward actionForward = mapping.findForward(INITIAL);
        // Create the container for any errors that occur
        ActionErrors errors = new ActionErrors();

	try 
	{
	    hero.interfaces.AllProjectsSessionLocalHome projecth = (AllProjectsSessionLocalHome)hero.interfaces.AllProjectsSessionUtil.getLocalHome();
		    
	    hero.interfaces.AllProjectsSessionLocal projectl = projecth.create();
	    
	    Vector projects = new Vector((Collection)projectl.getProjects());
	    request.getSession(true).setAttribute("allprojects",projects);
	    request.getSession(true).setAttribute("wsname",null);
	    
	}catch(Exception e){e.printStackTrace();throw new ServletException();};
	
	if (!errors.empty()) {
	    saveErrors(request, errors);
        }
	
	// Forward control to the appropriate URI as determined by the action.
	return (actionForward);
    }
    
}
