package hero.struts.actions;

import java.io.IOException;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import javax.servlet.http.HttpServletResponse;
import org.apache.struts.action.ActionError;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionForward;
import hero.interfaces.*;

/**
 * <strong>LoginAction</strong>
 * Action that performs users authentication and forward activity or project
 * information
 * 
 *@author Miguel Valdes Faura
 */
public class LoginAction extends AbstStrutsActionBase 
{
    /**
     *@param String containing username
     *@param String containing password
     *@return boolean - true authenticated, false not authenticated.
     */
    public boolean authenticate(String username, String password)
    {
        return(true);
    }

    /**
     * @param mapping The ActionMapping used to select this instance
     * @param actionForm The optional AbstActionFormBase bean for this request (if any)
     * @param request The HTTP request we are processing
     * @param response The HTTP response we are creating
     * @exception IOException if an input/output error occurs
     * @exception ServletException if a servlet exception occurs
     */

    public ActionForward perform(ActionMapping mapping, ActionForm form,
        HttpServletRequest request, HttpServletResponse response) throws IOException, ServletException
    {
        // Assume that the login fails, so that the login page is redisplayed
        // if the user isn't authenticated
        ActionForward actionForward = mapping.findForward(LOGIN);
        // Create the container for any errors that occur
        ActionErrors errors = new ActionErrors();
        
	// Extract attributes and parameters we will need from the incoming
	// form.
	
	HttpSession session = request.getSession();
	String action = (String)session.getAttribute("action");

	try {

	    hero.interfaces.UserSessionLocalHome userh = (UserSessionLocalHome)hero.interfaces.UserSessionUtil.getLocalHome();
	    hero.interfaces.UserSessionLocal usersession = userh.create();

	    request.getSession(true).setAttribute("username", usersession.getUser());
	    request.getSession(true).setAttribute("password", usersession.getUserPassword());
            request.getSession(true).setAttribute("workElement", "null");
	    
	    if (action.equals("user"))
	    {
		request.getSession(true).setAttribute("user", usersession);

		String project = (String)session.getAttribute("project");

		if (project.equals("clone"))
		{
		    // Forward control to the specified 'success' URI specified in the structs-config.xml
		    actionForward = mapping.findForward(CLONEPROJECT);
		}
		if (project.equals("details"))
		{
		    // Forward control to the specified 'success' URI specified in the structs-config.xml
		    actionForward = mapping.findForward(PROJECTDETAILS);
		}
	    }
	    else
	    {
	      try{
                 String project = (String)session.getAttribute("projectname");

                 hero.interfaces.ProjectSessionLocalHome projecth = (ProjectSessionLocalHome)hero.interfaces.ProjectSessionUtil.getLocalHome();
                 hero.interfaces.ProjectSessionLocal projectsession = projecth.create();
				 projectsession.initProject(project);

                if (action.equals("node"))
		{
		    String name = (String)session.getAttribute("nodename");
		    String username = (String)session.getAttribute("username");
                    hero.util.StrutsNodeValue node = projectsession.getStrutsNode(name);
		    request.getSession(true).setAttribute("node", node);

		    if (!node.getDeadline().equals("Deadline needed"))
		    {
			java.sql.Timestamp deadline = java.sql.Timestamp.valueOf(node.getDeadline()+" 00:00:00");
			if (deadline.getTime() <= (new java.util.Date()).getTime() && !node.getState().equals("TERMINATED"));
			    errors.add("deadline_error", new ActionError("error.deadline"));
		    }

		    request.getSession(true).setAttribute("project", projectsession);
		    request.getSession(true).setAttribute("proAct", "false");
		    request.getSession(true).setAttribute("edit", "false");
		        
		    // Forward control to the specified 'success' URI specified in the structs-config.xml
		    actionForward = mapping.findForward(ACTIVITY);
		}
		if (action.equals("project"))
		{
		    request.getSession(true).setAttribute("project", projectsession);
		    request.getSession(true).setAttribute("proAct", "true");
		    request.getSession(true).setAttribute("edit", "false");

		    request.getSession(true).setAttribute("nodes", projectsession.getStrutsNodes());
		    request.getSession(true).setAttribute("edges", projectsession.getStrutsEdges());

		    
		    // Forward control to the specified 'success' URI specified in the structs-config.xml
		    actionForward = mapping.findForward(PROJECT);
		}
	      }catch(Exception pe){actionForward = mapping.findForward(INITIAL);errors.add("project_error", new ActionError("error.project.mismatch"));}
	    }
	}catch(Exception e){errors.add(ActionErrors.GLOBAL_ERROR, new ActionError("error.password.mismatch"));}
	
	// If any messages is required, save the specified error messages keys
	// into the HTTP request for use by the <struts:errors> tag.
        if (!errors.empty()) {
            saveErrors(request, errors);
        }
	
	// Forward control to the appropriate URI as determined by the action.
	return (actionForward);
    }
}
