package hero.struts.actions;

import java.io.IOException;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import javax.servlet.http.HttpServletResponse;
import org.apache.struts.action.ActionError;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionForward;
import hero.interfaces.*;

/**
 * <strong>NodeAction</strong>
 * Action that allows the user to add a new node in the current project
 * 
 *@author Miguel Valdes Faura
 */
public class NodeAction extends AbstStrutsActionBase 
{

  public boolean authenticate(String username, String password)
  {
	return(true);
  }

    /**
     * @param mapping The ActionMapping used to select this instance
     * @param actionForm The optional AbstActionFormBase bean for this request (if any)
     * @param request The HTTP request we are processing
     * @param response The HTTP response we are creating
     * @exception IOException if an input/output error occurs
     * @exception ServletException if a servlet exception occurs
     */
    public ActionForward perform(ActionMapping mapping, ActionForm form,
        HttpServletRequest request, HttpServletResponse response) throws IOException, ServletException
    {

        ActionForward actionForward = mapping.findForward(PROJECT);
        // Create the container for any errors that occur
        ActionErrors errors = new ActionErrors();

	String action = request.getParameter("nodeAction");
	HttpSession session = request.getSession();
	String project = (String)session.getAttribute("projectname");
	String userName = (String)session.getAttribute("username");

	try 
	{
	    hero.interfaces.ProjectSessionLocalHome projecth = (ProjectSessionLocalHome)hero.interfaces.ProjectSessionUtil.getLocalHome();
	    hero.interfaces.ProjectSessionLocal projectsession = projecth.create();
		projectsession.initProject(project);
		
	    if (!isCancelled(request))
	    {
		if (action.equals("Edit"))
		{
		    // Forward control to the specified 'success' URI specified in the structs-config.xml
		    actionForward = mapping.findForward(PROJECT);
		}
		if (action.equals("Activity"))
		{
		  String name = request.getParameter("nodename");
		  hero.util.StrutsNodeValue node = projectsession.getStrutsNode(name);
		  request.getSession(true).setAttribute("node", node);

		  /*if (!node.getDeadline().equals("Deadline needed"))
		  {
		      java.sql.Timestamp deadline = java.sql.Timestamp.valueOf(node.getDeadline());
		      if (deadline.getTime() <= (new java.util.Date()).getTime() && !node.getState().equals("TERMINATED"));
		      errors.add("deadline_error", new ActionError("error.deadline"));
		  }*/

		  request.getSession(true).setAttribute("nodename", name);

		  // Forward control to the specified 'success' URI specified in the structs-config.xml
		  actionForward = mapping.findForward(ACTIVITY);
	      }

	      if (action.equals("Add"))
	      {
		  String nodeName = request.getParameter("name");
		  if (nodeName.length()!=0)
		  {
		      projectsession.addNode(nodeName,1);
		      //request.setAttribute("project", projectsession);
		      request.getSession(true).setAttribute("project", projectsession);		      
		      // Forward control to the specified 'success' URI specified in the structs-config.xml
		      actionForward = mapping.findForward(PROJECT);		      
		  }
		  else
		      errors.add("node_error", new ActionError("error.node.mismatch"));
	      }
	      if (action.equals("Delete"))
	      {
		  String nodeName = request.getParameter("nodename");
		  projectsession.deleteNode(nodeName);
		  request.getSession(true).setAttribute("project", projectsession);
		  
		  // Forward control to the specified 'success' URI specified in the structs-config.xml
		  actionForward = mapping.findForward(PROJECT);   		  
	      }
	  }
	    //	}catch(NodeExecutingException e){errors.add("node_error", new ActionError("error.nodeexecuting.mismatch"));
	}catch(Exception e1){errors.add("node_error", new ActionError("error.nodeexisting.mismatch"));}

	if (!errors.empty()) {
            saveErrors(request, errors);
        }

        // Forward control to the appropriate URI as determined by the action.
        return (actionForward);
    }
   

}
