package hero.struts.actions;

import java.io.IOException;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import javax.servlet.http.HttpServletResponse;
import org.apache.struts.action.ActionError;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionForward;
import java.util.*;

import hero.interfaces.*;

/**
 * <strong>ProjectAction</strong>
 * Action that allows the admin to add and clone projects
 * 
 *@author Miguel Valdes Faura
 */

public class ProjectAction extends AbstStrutsActionBase
{
  public boolean authenticate(String username, String password)
  {
	return(true);
  }
    /**
     * @param mapping The ActionMapping used to select this instance
     * @param actionForm The optional AbstActionFormBase bean for this request (if any)
     * @param request The HTTP request we are processing
     * @param response The HTTP response we are creating
     * @exception IOException if an input/output error occurs
     * @exception ServletException if a servlet exception occurs
     */
    public ActionForward perform(ActionMapping mapping, ActionForm form,
        HttpServletRequest request, HttpServletResponse response) throws IOException, ServletException
    {
        ActionForward actionForward = mapping.findForward(ADMIN);
        // Create the container for any errors that occur
        ActionErrors errors = new ActionErrors();

	String action = request.getParameter("action");
	HttpSession session = request.getSession();
	String project = (String)session.getAttribute("projectname");

	if (!isCancelled(request))
	{
	    if (action.equals("ProjectDetails"))
	    {
		try{

		    hero.interfaces.ProjectSessionLocalHome projecth = (ProjectSessionLocalHome)hero.interfaces.ProjectSessionUtil.getLocalHome();
		    hero.interfaces.ProjectSessionLocal projectsession = projecth.create();
		    projectsession.initProject(project);
		    
		      
		    request.getSession(true).setAttribute("project", projectsession);
		    request.getSession(true).setAttribute("proAct", "true");
		    request.getSession(true).setAttribute("edit", "false");
		    actionForward = mapping.findForward(PROJECT);
		}catch(Exception e2){errors.add("project_error", new ActionError("error.projectdetails.mismatch"));actionForward = mapping.findForward(PROJECTDETAILS);}
	    }
	    if (action.equals("configproject")) {
	    	try {

		    hero.interfaces.ProjectSessionLocalHome projecth = (ProjectSessionLocalHome)hero.interfaces.ProjectSessionUtil.getLocalHome();
		    hero.interfaces.ProjectSessionLocal projectsession = projecth.create();
		    projectsession.initProject(project);
	    	session.setAttribute("hooks", new Vector(projectsession.getHooks()));
    		session.setAttribute("properties", new Vector(projectsession.getProperties()));
    		session.setAttribute("interHooks", new Vector(projectsession.getInterHooks()));
    		Collection users = projectsession.getUsers();
    		Iterator iusers = users.iterator();

    		Vector usersP = new Vector();
    		Vector rolesP = new Vector();
    		int i,j;

    		while(iusers.hasNext())
    			{
      String actualUser = (String)iusers.next();
      Collection uRoles = projectsession.getUserRoles(actualUser);
      Collection pRoles = projectsession.getRoles();

      Iterator iuroles = uRoles.iterator();
      while(iuroles.hasNext())
      {
         BnRoleLocal actualuRole = (BnRoleLocal)iuroles.next();
         Iterator iproles = pRoles.iterator();
         while(iproles.hasNext())
         {
           BnRoleLocal actualpRole = (BnRoleLocal)iproles.next();
           if (actualuRole.getId() == actualpRole.getId())
           {
             usersP.add(actualUser);
             rolesP.add(actualuRole.getName());
           }
         }
      } 

    } 
    session.setAttribute("usersP", usersP);
    session.setAttribute("rolesP", rolesP);

		actionForward = mapping.findForward(CONFIGPROJECT);
		}catch(Exception e2){errors.add("project_error", new ActionError("error.projectdetails.mismatch"));actionForward = mapping.findForward(PROJECTDETAILS);}	      
	}
	    if (action.equals("viewproject"))
		actionForward = mapping.findForward(PROJECT);	      
	}
	
	if (!errors.empty()) {
	    saveErrors(request, errors);
        }
	
	// Forward control to the appropriate URI as determined by the action.
	return (actionForward);
    }
}
