package hero.struts.actions;

import java.io.IOException;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import javax.servlet.http.HttpServletResponse;
import org.apache.struts.action.ActionError;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionForward;
import hero.struts.forms.*;
import hero.interfaces.*;
import java.util.Vector;

/**
 * <strong>PropertyAction</strong> 
 * Action that allows the user to add a new property.
 * This action can be forward project or activity pages
 * 
 *@author Miguel Valdes Faura
 */
public class PropertyAction extends AbstStrutsActionBase 
{

    public boolean authenticate(String username, String password)
    {
	return(true);
    }

    /**
     * @param mapping The ActionMapping used to select this instance
     * @param actionForm The optional AbstActionFormBase bean for this request (if any)
     * @param request The HTTP request we are processing
     * @param response The HTTP response we are creating
     * @exception IOException if an input/output error occurs
     * @exception ServletException if a servlet exception occurs
     */
    public ActionForward perform(ActionMapping mapping, ActionForm form,
        HttpServletRequest request, HttpServletResponse response) throws IOException, ServletException
    {
        ActionForward actionForward = mapping.findForward(EDITACTIVITY);
        // Create the container for any errors that occur
        ActionErrors errors = new ActionErrors();

	String action = request.getParameter("propertyAction");
	String key = request.getParameter("key");

	HttpSession session = request.getSession();
	String project = (String)session.getAttribute("projectname");
        PropertyForm propForm = (PropertyForm) form;

	try
	{
	    hero.interfaces.ProjectSessionLocalHome projecth = (ProjectSessionLocalHome)hero.interfaces.ProjectSessionUtil.getLocalHome();
	    hero.interfaces.ProjectSessionLocal projectsession = projecth.create();
		projectsession.initProject(project);
	    
	    if (!isCancelled(request))
	    {
		if (action.equals("EditNode"))
		{
		    session.setAttribute("prop","0");
		    // Forward control to the specified 'success' URI specified in the structs-config.xml
		    actionForward = mapping.findForward(EDITACTIVITY);
		}
		if (action.equals("EditNodeProp"))
		{
		    // Forward control to the specified 'success' URI specified in the structs-config.xml
                    String name = (String)session.getAttribute("nodename");
		    BnNodePropertyValue nodeProperty = projectsession.getNodeProperty(name,key);		    		 
		    propForm.setKey(key);
		    propForm.setValue(nodeProperty.getTheValue());
                    session.setAttribute("PROP", propForm);
                    session.setAttribute("prop", "1");
		    actionForward = mapping.findForward(EDITACTIVITY);
		}
                if (action.equals("EditProjectProp"))
		{
		    session.setAttribute("projectProp", "1");
		    String value = request.getParameter("value");
		    propForm.setKey(key);
		    propForm.setValue(value);
		    session.setAttribute("ProjectProp", propForm);
		    request.getSession(true).setAttribute("project", projectsession);
		    session.setAttribute("properties", new Vector(projectsession.getProperties()));
		    actionForward = mapping.findForward(CONFIGPROJECT);
		}
		if (action.equals("Edit"))
		{
		    session.setAttribute("projectProp", "0");
		    // Forward control to the specified 'success' URI specified in the structs-config.xml
		    actionForward = mapping.findForward(CONFIGPROJECT);
		}
		
		if (action.equals("AddNode"))
		{
		    session.setAttribute("action","Initial");
		    String value = request.getParameter("value");
		    String name = (String)session.getAttribute("nodename");
		    if (key.length()!=0 && value.length()!=0)
		    {
			projectsession.setNodeProperty(name, key, value);
			request.getSession(true).setAttribute("node", projectsession.getStrutsNode(name));
			Vector prop = new Vector(projectsession.getNodeProperties(name));
			request.getSession(true).setAttribute("properties", prop);
		    }
		    else
		      errors.add("property_error", new ActionError("error.property.mismatch"));
		    // Forward control to the specified 'success' URI specified in the structs-config.xml
		    actionForward = mapping.findForward(EDITACTIVITY);
		}
		
		if (action.equals("Add"))
		{
		    session.setAttribute("action","Initial");
		    String value = request.getParameter("value");
		    if (key.length()!=0 && value.length()!=0)
		    {
			projectsession.setProperty(key, value);
			request.getSession(true).setAttribute("project", projectsession);
			session.setAttribute("properties", new Vector(projectsession.getProperties()));
		    }
		    else
			errors.add("property_error", new ActionError("error.property.mismatch"));
		    // Forward control to the specified 'success' URI specified in the structs-config.xml
		    actionForward = mapping.findForward(CONFIGPROJECT);
		}
		if (action.equals("DeleteNode"))
		{
		    String name = (String)session.getAttribute("nodename");
		    projectsession.deleteNodeProperty(name, key);
		    request.getSession(true).setAttribute("node", projectsession.getStrutsNode(name));
		    Vector prop = new Vector(projectsession.getNodeProperties(name));
		    request.getSession(true).setAttribute("properties", prop);
		    // Forward control to the specified 'success' URI specified in the structs-config.xml
		    actionForward = mapping.findForward(EDITACTIVITY);
		}
		if (action.equals("Delete"))
		    {
			projectsession.deleteProperty(key);
			session.setAttribute("properties", new Vector(projectsession.getProperties()));
			request.getSession(true).setAttribute("project", projectsession);
			
			// Forward control to the specified 'success' URI specified in the structs-config.xml
			actionForward = mapping.findForward(CONFIGPROJECT);
		    }
	    }     
	    if (action.equals("Add"))
		actionForward = mapping.findForward(CONFIGPROJECT);
	}catch(Exception e){errors.add("property_error", new ActionError("error.property.mismatch"));}
	
	if (!errors.empty()) {
            saveErrors(request, errors);
        }

        // Forward control to the appropriate URI as determined by the action.
        return (actionForward);
    }
}
