package hero.struts.actions;

import java.io.IOException;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.apache.struts.action.ActionError;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionForward;

import hero.struts.forms.*;
import hero.interfaces.*;

/**
 * <strong>UserAction</strong>
 * Action that allows the admin to add new users
 * 
 *@author Miguel Valdes Faura
 */

public class UserAction extends AbstStrutsActionBase
{
  public boolean authenticate(String username, String password)
  {
	return(true);
  }
    /**
     * @param mapping The ActionMapping used to select this instance
     * @param actionForm The optional AbstActionFormBase bean for this request (if any)
     * @param request The HTTP request we are processing
     * @param response The HTTP response we are creating
     * @exception IOException if an input/output error occurs
     * @exception ServletException if a servlet exception occurs
     */
    public ActionForward perform(ActionMapping mapping, ActionForm form,
        HttpServletRequest request, HttpServletResponse response) throws IOException, ServletException
    {
        ActionForward actionForward;
        // Create the container for any errors that occur
        ActionErrors errors = new ActionErrors();

	String logged = request.getParameter("user");
	actionForward = mapping.findForward(NEWUSER);

	try
	{
	  if (!isCancelled(request))
	  {
	      UserForm userForm = (UserForm) form;
	      String name = userForm.getName();
	      String password = userForm.getPassword();
	      String email = userForm.getEmail();
	      String jabber = userForm.getJabber();

	      if (name.length()!=0 && password.length()!=0 && email.length()!=0)
	      {
		  hero.interfaces.UserRegistrationLocalHome userh = (UserRegistrationLocalHome)hero.interfaces.UserRegistrationUtil.getLocalHome();
		  hero.interfaces.UserRegistrationLocal user = userh.create();

		  if (jabber.length()!=0)
		      user.userCreate(name,password,email,jabber);
		  else
		      user.userCreate(name,password,email);

		  request.getSession(true).setAttribute("newuser", "true");
		  request.getSession(true).setAttribute("newusername", name);
	      }
	      else
	      {
		  errors.add("user_error", new ActionError("error.user.mismatch"));
		  actionForward = mapping.findForward(USERNOTLOGGED);
	      }
	  }
	  else
	      actionForward = mapping.findForward(LOGIN);
	}catch(Exception e){e.printStackTrace();errors.add("user_error", new ActionError("error.user"));
	if (logged.equals("notLogged"))
	    actionForward = mapping.findForward(USERNOTLOGGED);
	else
	    actionForward = mapping.findForward(USER);}

	if (!errors.empty()) {
	    saveErrors(request, errors);
        }
	
	// Forward control to the appropriate URI as determined by the action.
	return (actionForward);
    }
}
