package hero.struts.actions;

import java.io.IOException;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.apache.struts.action.ActionError;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionForward;

import hero.struts.forms.*;
import hero.interfaces.*;


/**
 * <strong>UserPreferencesAction</strong>
 * Action that allows the admin to add new users
 * 
 *@author Miguel Valdes Faura
 */

public class UserPreferencesAction extends AbstStrutsActionBase
{
  public boolean authenticate(String username, String password)
  {
	return(true);
  }
    /**
     * @param mapping The ActionMapping used to select this instance
     * @param actionForm The optional AbstActionFormBase bean for this request (if any)
     * @param request The HTTP request we are processing
     * @param response The HTTP response we are creating
     * @exception IOException if an input/output error occurs
     * @exception ServletException if a servlet exception occurs
     */
    public ActionForward perform(ActionMapping mapping, ActionForm form,
        HttpServletRequest request, HttpServletResponse response) throws IOException, ServletException
    {
        ActionForward actionForward;
        // Create the container for any errors that occur
        ActionErrors errors = new ActionErrors();

	actionForward = mapping.findForward(LOGIN);

	UserPreferencesForm upForm = (UserPreferencesForm) form;
	String startMail = request.getParameter("startMail");
	String startJabber = request.getParameter("startJabber");
	String terminateMail = request.getParameter("terminateMail");
	String terminateJabber = request.getParameter("terminateJabber");
	String addNodeMail = request.getParameter("addNodeMail");
	String addNodeJabber = request.getParameter("addNodeJabber");
	String addEdgeMail = request.getParameter("addEdgeMail");
	String addEdgeJabber = request.getParameter("addEdgeJabber");
	String nodeStateMail = request.getParameter("nodeStateMail");
	String nodeStateJabber = request.getParameter("nodeStateJabber");
	String nodeDeadlineMail = request.getParameter("nodeDeadlineMail");
	String nodeDeadlineJabber = request.getParameter("nodeDeadlineJabber");


	try 
	{
	    hero.interfaces.UserRegistrationLocalHome userh = (UserRegistrationLocalHome)hero.interfaces.UserRegistrationUtil.getLocalHome();
	    hero.interfaces.UserRegistrationLocal user = userh.create();
	    if (!isCancelled(request))
	    {

		String username = (String)request.getSession(true).getAttribute("newusername");
		
		user.setUserProperty(username,hero.util.EventConstants.START+"Mail",startMail);
		user.setUserProperty(username,hero.util.EventConstants.START+"Jabber",startJabber);
		user.setUserProperty(username,hero.util.EventConstants.TERMINATED+"Mail",terminateMail);
		user.setUserProperty(username,hero.util.EventConstants.TERMINATED+"Jabber",terminateJabber);
		user.setUserProperty(username,hero.util.EventConstants.ADDNODE+"Mail",addNodeMail);
		user.setUserProperty(username,hero.util.EventConstants.ADDNODE+"Jabber",addNodeJabber);
		user.setUserProperty(username,hero.util.EventConstants.ADDEDGE+"Mail",addEdgeMail);
		user.setUserProperty(username,hero.util.EventConstants.ADDEDGE+"Jabber",addEdgeJabber);
		
		user.setUserProperty(username,hero.util.EventConstants.SETNODESTATE+"Mail",nodeStateMail);
		user.setUserProperty(username,hero.util.EventConstants.SETNODESTATE+"Jabber",nodeStateJabber);
		user.setUserProperty(username,hero.util.EventConstants.SETNODEDEADLINE+"Mail",nodeDeadlineMail);
		user.setUserProperty(username,hero.util.EventConstants.SETNODEDEADLINE+"Jabber",nodeDeadlineJabber);
	    }
		
	    }catch(Exception e1){errors.add("user_error", new ActionError("error.setProperty.mismatch"));}
	    if (!errors.empty()) {
		saveErrors(request, errors);
	    }
	
	// Forward control to the appropriate URI as determined by the action.
	return (actionForward);
    }
}
