package hero.struts.actions;

import java.io.IOException;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import javax.servlet.http.HttpServletResponse;
import org.apache.struts.action.ActionError;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionForward;

import java.util.*;

import hero.struts.activity.*;
import hero.interfaces.*;
import hero.util.*;

/**
 * <strong>WorklistAction</strong>
 * Action that allows the user to work with worklist
 * 
 *@author Miguel Valdes Faura
 */

public class WorklistAction extends AbstStrutsActionBase
{
  public boolean authenticate(String username, String password)
  {
	return(true);
  }
    /**
     * @param mapping The ActionMapping used to select this instance
     * @param actionForm The optional AbstActionFormBase bean for this request (if any)
     * @param request The HTTP request we are processing
     * @param response The HTTP response we are creating
     * @exception IOException if an input/output error occurs
     * @exception ServletException if a servlet exception occurs
     */
    public ActionForward perform(ActionMapping mapping, ActionForm form,
        HttpServletRequest request, HttpServletResponse response) throws IOException, ServletException
    {

        ActionForward actionForward = mapping.findForward(WORKLIST);
        // Create the container for any errors that occur
        ActionErrors errors = new ActionErrors();
	HttpSession session = request.getSession();

	try 
	{
	    Vector workList = new Vector();
	    hero.interfaces.UserSessionLocalHome userh = (UserSessionLocalHome)hero.interfaces.UserSessionUtil.getLocalHome();
	    hero.interfaces.UserSessionLocal usersession = userh.create();

	    hero.interfaces.ProjectSessionLocalHome projecth = (ProjectSessionLocalHome)hero.interfaces.ProjectSessionUtil.getLocalHome();

	    request.getSession(true).setAttribute("username", usersession.getUser());
	    request.getSession(true).setAttribute("password", usersession.getUserPassword());

	    Collection projects = usersession.getProjectList();
	    Iterator i = projects.iterator();
	    while (i.hasNext())
	    {
		Hashtable todoListReady = new Hashtable();
		Hashtable todoListAnti = new Hashtable();
		Hashtable activityListAnti = new Hashtable();
		Hashtable activityListExec = new Hashtable();

		String currentProject = ((hero.interfaces.BnProjectLightValue)i.next()).getName();
		Vector todoListNames = new Vector(usersession.getToDoList(currentProject));
		Vector activityListNames = new Vector(usersession.getActivityList(currentProject));

		if (todoListNames.size() != 0 || activityListNames.size() != 0)
		{
		  try{
		    Worklist wl = new Worklist();
		    wl.setProjectName(currentProject);
		    hero.interfaces.ProjectSessionLocal projectsession = projecth.create();
			projectsession.initProject(currentProject);
			
		    int j=0;
		    while (j<todoListNames.size())
		    {
			StrutsNodeValue stnt = new StrutsNodeValue();
			stnt.setProjectName(currentProject);
			stnt.setName(((hero.interfaces.BnNodeValue)projectsession.getNodeValue((String)todoListNames.elementAt(j))).getName());
			if (((hero.interfaces.BnNodeValue)projectsession.getNodeValue((String)todoListNames.elementAt(j))).getState() == hero.interfaces.Constants.Nd.READY)
			    todoListReady.put((String)todoListNames.elementAt(j),stnt);
			else
			    todoListAnti.put((String)todoListNames.elementAt(j),stnt);
			j++;
		    }
		    j=0;
		    while (j<activityListNames.size())
		    {
			StrutsNodeValue stna = new StrutsNodeValue();
			stna.setProjectName(currentProject);
			stna.setName(((hero.interfaces.BnNodeValue)projectsession.getNodeValue((String)activityListNames.elementAt(j))).getName());

			if (((hero.interfaces.BnNodeValue)projectsession.getNodeValue((String)activityListNames.elementAt(j))).getState() == hero.interfaces.Constants.Nd.ANTICIPATING)
			    activityListAnti.put((String)activityListNames.elementAt(j),stna);

			else 
			    activityListExec.put((String)activityListNames.elementAt(j),stna);
		        j++;

		    }
		    wl.setTodoListReady(todoListReady);
		    wl.setTodoListAnti(todoListAnti);
		    wl.setActivityListAnti(activityListAnti);
		    wl.setActivityListExec(activityListExec);
		    workList.add(wl);
		  }catch(Exception ex){};
		}
    	    }
	    request.getSession(true).setAttribute("worklist", workList);
		request.getSession(true).setAttribute("worklistSize", Long.toString(workList.size()));
	    request.getSession(true).setAttribute("wsname",null);
   
	    actionForward = mapping.findForward(WORKLIST);
	}catch(Exception e){errors.add("activity_error", new ActionError("error.deadline.mismatch"));}

	if (!errors.empty()) {
	    saveErrors(request, errors);
        }

	// Forward control to the appropriate URI as determined by the action.
	    return (actionForward);
    }

}
