package hero.struts.forms;

import javax.servlet.http.HttpServletRequest;
import org.apache.struts.action.ActionError;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionMapping;


/**
 * Form bean for the Hook.  This form has the following fields,
 * with default values in square brackets:
 * <ul>
 * <li><b>name</b> - The name of the hook.  [REQUIRED]
 * <li><b>event</b> - The event for this hook.  [REQUIRED]
 * <li><b>type</b> - The hook type [REQUIRED]
 * </ul>
 *
 * @author Miguel Valdes Faura
 * @version $Revision: 1.1 $ $Date: 2004/07/30 14:57:57 $
 */

public final class HookForm extends ActionForm  {


// =================================================== Instance Variables


	/**
	 * The hook name
	 */
	private String name = null;


	/**
	 * The hook event
	 */

	private String event = null;

	/**
	 * The hook type
	 */

         private String type = null;

	/**
	 * The hook value
	 */
	private String value = null;


	// =========================================================== Properties


	/**
	 * Return the hook name
	 */
	public String getName() {

	return (this.name);

	}

	/**
	 * Set the hook name
	 *
	 */
	public void setName(String name) {

	this.name = name;

	}

	/**
	 * Return the hook event
	 */
	public String getEvent() {

	return (this.event);

	}

	/**
	 * Set the hook event
	 *
	 */
	public void setEvent(String event) {

	this.event = event;

	}

	/**
	 * Return the hook type
	 */
	public String getType() {

	return (this.type);

	}

	/**
	 * Set the hook type
	 *
	 */
	public void setType(String type) {

	this.type = type;

	}

	/**
	 * Return the hook value
	 */
	public String getValue() {

	return (this.value);

	}

	/**
	 * Set the hook value
	 *
	 */
	public void setValue(String value) {

	this.value = value;
	}


	// --------------------------------------------------------- Public Methods


	/**
	 * Reset all properties to their default values.
	 *
	 * @param mapping The mapping used to select this instance
	 * @param request The servlet request we are processing
	 */
	public void reset(ActionMapping mapping, HttpServletRequest request) {

		this.name = null;
		this.event = null;
		this.type = null;
		this.value = null;
	}

	/**
	 * Validate the properties that have been set from this HTTP request,
	 * and return an <code>ActionErrors</code> object that encapsulates any
	 * validation errors that have been found.  If no errors are found, return
	 * <code>null</code> or an <code>ActionErrors</code> object with no
	 * recorded error messages.
	 *
	 * @param mapping The mapping used to select this instance
	 * @param request The servlet request we are processing
	 */
	public ActionErrors validate(ActionMapping mapping, HttpServletRequest request) {

	    ActionErrors errors = new ActionErrors();

	    if (name == null || name.length()==0)
			errors.add("name",
				   new ActionError("error.name.required"));
	    if (event == null || event.length()==0)
		errors.add("event",
			   new ActionError("error.event.required"));
	    if (type == null || type.length()==0)
		errors.add("type",
		new ActionError("error.type.required"));

	return (errors);

	}
}
