/*
 * ProjectForm.java
 */
package hero.struts.forms;


import javax.servlet.http.HttpServletRequest;
import org.apache.struts.action.ActionError;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionMapping;


/**
 * Form bean for the project.  This form has the following fields,
 * with default values in square brackets:
 * <ul>
 * <li><b>name</b> - The projectname.  [REQUIRED]
 * <li><b>oldName</b> - The old projectname.  [REQUIRED]
 * </ul>
 *
 * @author Miguel Valdes Faura
 * @version $Revision: 1.1 $ $Date: 2004/07/30 14:57:57 $
 */


public final class ProjectForm extends ActionForm  {
    
    // --------------------------------------------------- Instance Variables

    /**
     * The name of the project
     */
    private String name = null;

    /**
     * The name of the oldproject
     */
    private String oldName = null;


    
    // ----------------------------------------------------------- Properties

   
    /**
     * Get the name
     *@return String 
     */
    public String getName() {
    	return (name);
    }

    /**
     * Set the name
     * @param name
     */
    public void setName(String name) {
        this.name = name;
    }

    /**
     * Get the oldname
     *@return String 
     */
    public String getOldName() {
    	return (oldName);
    }

    /**
     * Set the oldname
     * @param oldname
     */
    public void setOldName(String oldName) {
        this.oldName = oldName;
    }

    // --------------------------------------------------------- Public Methods

    /**
     * Reset all properties to their default values.
     *
     * @param mapping The mapping used to select this instance
     * @param request The servlet request we are processing
     */
    public void reset(ActionMapping mapping, HttpServletRequest request) {
	this.oldName = null;
        
    }


    /**
     * Validate the properties that have been set from this HTTP request,
     * and return an <code>ActionErrors</code> object that encapsulates any
     * validation errors that have been found.  If no errors are found, return
     * <code>null</code> or an <code>ActionErrors</code> object with no
     * recorded error messages.
     *
     * @param mapping The mapping used to select this instance
     * @param request The servlet request we are processing
     */
    public ActionErrors validate(ActionMapping mapping,
                                 HttpServletRequest request) {
        ActionErrors errors = new ActionErrors();
	    if (name == null || name.length()==0)
			errors.add("name",
				   new ActionError("error.projectname.required"));

	    if (oldName == null || oldName.length()==0)
			errors.add("olName",
				   new ActionError("error.oldName.required"));

    	return (errors);
    }



}

