package hero.struts.forms;

import javax.servlet.http.HttpServletRequest;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionMapping;


/**
 * Form bean for the BnUser.  This form has the following fields,
 * with default values in square brackets:
 * <ul>
 * <li><b>name</b> - The name of the user.  [REQUIRED]
 * <li><b>password</b> - The password for this user.  [REQUIRED]
 * <li><b>email</b> - The email [REQUIRED]
 * </ul>
 *
 * @author Miguel Valdes Faura
 * @version $Revision: 1.1 $ $Date: 2004/07/30 14:57:57 $
 */

public final class UserPreferencesForm extends ActionForm  {


// =================================================== Instance Variables


	/**
	 * The startMail event
	 */
	private boolean startMail = false;

	/**
	 * The startJabber event
	 */
	private boolean startJabber = false;

	/**
	 * The terminateMail event
	 */
	private boolean terminateMail = false;

	/**
	 * The terminateJabber event
	 */
	private boolean terminateJabber = false;

	/**
	 * The addNodeMail event
	 */
	private boolean addNodeMail = false;

	/**
	 * The addNodeJabber event
	 */
	private boolean addNodeJabber = false;

	/**
	 * The addEdgeMail event
	 */
	private boolean addEdgeMail = false;

	/**
	 * The addEdgeJabber event
	 */
	private boolean addEdgeJabber = false;

	/**
	 * The setNodeStateMail event
	 */
	private boolean nodeStateMail = false;

	/**
	 * The setNodeStateJabber event
	 */
	private boolean nodeStateJabber = false;

	/**
	 * The setNodeDeadlineMail event
	 */
	private boolean nodeDeadlineMail = false;

	/**
	 * The setNodeStateJabber event
	 */
	private boolean nodeDeadlineJabber = false;


	// =========================================================== Properties


	/**
	 * Return the startMail event
	 */
	public boolean getStartMail() {

	return (this.startMail);

	}

	/**
	 * Set the startMail event
	 *
	 */
	public void setStartMail(boolean startMail) {

	this.startMail = startMail;

	}

	/**
	 * Return the startJabber event
	 */
	public boolean getStartJabber() {

	return (this.startJabber);

	}

	/**
	 * Set the startJabber event
	 *
	 */
	public void setStartJabber(boolean startJabber) {

	this.startJabber = startJabber;

	}

	/**
	 * Return the terminateMail event
	 */
	public boolean getTerminateMail() {

	return (this.terminateMail);

	}

	/**
	 * Set the terminateMail event
	 *
	 */
	public void setTerminateMail(boolean TerminateMail) {

	this.terminateMail = TerminateMail;

	}


	/**
	 * Return the terminateJabber event
	 */
	public boolean getTerminateJabber() {

	return (this.terminateJabber);

	}

	/**
	 * Set the terminateJabber event
	 *
	 */
	public void setTerminateJabber(boolean TerminateJabber) {

	this.terminateJabber = TerminateJabber;

	}


	/**
	 * Return the addNodeMail event
	 */
	public boolean getAddNodeMail() {

	return (this.addNodeMail);

	}

	/**
	 * Set the addNodeJabber event
	 *
	 */
	public void setAddNodeMail(boolean addNodeMail) {

	this.addNodeMail = addNodeMail;

	}

	/**
	 * Return the addNodeJabber event
	 */
	public boolean getAddNodeJabber() {

	return (this.addNodeJabber);

	}

	/**
	 * Set the addNodeJabber event
	 *
	 */
	public void setAddNodeJabber(boolean addNodeJabber) {

	this.addNodeJabber = addNodeJabber;

	}


	/**
	 * Return the addEdgeMail event
	 */
	public boolean getAddEdgeMail() {

	return (this.addEdgeMail);

	}

	/**
	 * Set the addEdgeJabber event
	 *
	 */
	public void setAddEdgeMail(boolean addEdgeMail) {

	this.addEdgeMail = addEdgeMail;

	}

	/**
	 * Return the addEdgeJabber event
	 */
	public boolean getAddEdgeJabber() {

	return (this.addEdgeJabber);

	}

	/**
	 * Set the addEdgeJabber event
	 *
	 */
	public void setAddEdgeJabber(boolean addEdgeJabber) {

	this.addEdgeJabber = addEdgeJabber;

	}

	/**
	 * Return the nodeStateMail event
	 */
	public boolean getNodeStateMail() {

	return (this.nodeStateMail);

	}

	/**
	 * Set the nodeStateMail event
	 *
	 */
	public void setNodeStateMail(boolean nodeStateMail) {

	this.nodeStateMail = nodeStateMail;

	}

	/**
	 * Return the nodeStateJabber event
	 */
	public boolean getNodeStateJabber() {

	return (this.nodeStateJabber);

	}

	/**
	 * Set the nodeStateJabber event
	 *
	 */
	public void setNodeStateJabber(boolean nodeStateJabber) {

	this.nodeStateJabber = nodeStateJabber;

	}

	/**
	 * Return the nodeDeadlineMail event
	 */
	public boolean getNodeDeadlineMail() {

	return (this.nodeDeadlineMail);

	}

	/**
	 * Set the nodeDeadlineMail event
	 *
	 */
	public void setNodeDeadlineMail(boolean nodeDeadlineMail) {

	this.nodeDeadlineMail = nodeDeadlineMail;

	}

	/**
	 * Return the nodeDeadlineJabber event
	 */
	public boolean getNodeDeadlineJabber() {

	return (this.nodeDeadlineJabber);

	}

	/**
	 * Set the nodeDeadlineJabber event
	 *
	 */
	public void setNodeDeadlineJabber(boolean nodeDeadlineJabber) {

	this.nodeDeadlineJabber = nodeDeadlineJabber;

	}


	// --------------------------------------------------------- Public Methods


	/**
	 * Reset all properties to their default values.
	 *
	 * @param mapping The mapping used to select this instance
	 * @param request The servlet request we are processing
	 */
	public void reset(ActionMapping mapping, HttpServletRequest request) {

		this.startMail = false;
		this.startJabber = false;
		this.terminateMail = false;
		this.terminateJabber = false;
		this.addNodeMail = false;
		this.addNodeJabber = false;
		this.addEdgeMail = false;
		this.addEdgeJabber = false;
		this.nodeStateMail = false;
		this.nodeStateJabber = false;
		this.nodeDeadlineMail = false;
		this.nodeDeadlineJabber = false;
	}

}
